;------------------------------------------------------------------------------
; BD BDOS-Schnittstelle
;------------------------------------------------------------------------------

;		org	0CF00h

		jp	cmd_bo_bd
aBd:		db "#BD     "
		db 0
		db 0

;------------------------------------------------------------------------------
; RST 8 Routine fr BDOS-Aufrufe
; C = Funktionsnummer
;------------------------------------------------------------------------------

sub_bdos:	ld	l, a
		ld	a, (sys_bank)
		ld	h, a
		ld	a, l
		ld	(sys_bank), a
		ei
		push	hl
		ld	hl, sys_rst20ret
		push	hl
		push	bc
		ld	b, 0
		ld	hl, 0E300h
		add	hl, bc
		add	hl, bc
		add	hl, bc			; HL=Adr. in BDOS-Liste
		ld	a, (sys_bank)
		and	0F0h
		or	0Ch			; Bank 0Ch zuschalten
		di
		out	(0FFh),	a
		ld	c, (hl)
		inc	hl
		ld	b, (hl)			
		inc	hl
		ld	h, (hl)			; BC=Adr, H=Bank
		ld	a, (sys_bank)
		out	(0FFh),	a
		ei
		ld	a, h			; A=Bank, HL=Adr
		ld	l, c
		ld	h, b
		pop	bc
		jp	sys_jphl		; Funktion aufrufen


;------------------------------------------------------------------------------
; BDOS-Aufruf-Tabelle, wird nach E300(E) kopiert
;------------------------------------------------------------------------------

lst_bdos1:	dw bdos_unk			; Funkion 0
		dw bdos_unk
		dw bdos_unk
		dw bdos_unk
		dw bdos_unk
		dw bdos_unk
		dw bdos_unk
		dw bdos_unk
		dw bdos_unk
		dw bdos_unk			; Funktion 9
		dw bdos_10			; Funktion 10

;------------------------------------------------------------------------------
; Initialisierung BDOS-Schnittstelle
; Aufruf: durch BO (Systemanlauf)
;------------------------------------------------------------------------------

cmd_bo_bd:	ld	hl, lst_bdos1
		ld	de, 0E300h
		ld	a, (sys_bank)
		and	0F0h
		or	0Ch			; Bank C
		di
		out	(0FFh),	a
		ld	bc, 22			; 11 Eintrge in Liste
		ld	a, (sys_bank)
		or	0Fh
cmd_bo_bd1:	ldi				; 2 Byte Adr. kopieren
		ldi
		ld	(de), a			; Bank merken
		inc	de
		jp	pe, cmd_bo_bd1
;		
		ld	b, 0FFH-11		; alle restlichen Eintrge
		ex	de, hl
		ld	de, bdos_unk
cmd_bo_bd2:	ld	(hl), e			; mit bdos_unk auffllen
		inc	hl
		ld	(hl), d
		inc	hl
		ld	(hl), a			; und wieder Bank merken
		inc	hl
		djnz	cmd_bo_bd2
;		
		ld	de, bdos_255		; Funktion FF zum Abschlu
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		ld	(hl), a
;		
		ld	a, (sys_bank)
		out	(0FFh),	a
		
;Patchen der RST 8 - Routine.			init_rst_cod ist: (s. BO)
						;	push	af
						;	ld	a, 0FFh
						;	di
						;	out	(0FFh),	a
						;	jp	0

		ld	hl, (9)			; Ziel-Adr. von RST 8 (-> 2c0h)
		ld	(hl), 0			; hier push af durch NOP ersetzen
		inc	hl
		inc	hl
		ld	a, (sys_bank)
		or	0Fh
		ld	(hl), a			; und aktuelle Bank eintragen (bfh)
cmd_bo_bd3:	ld	de, 5
		add	hl, de
		ld	de, sub_bdos
		ld	(hl), e			; statt JP 0 nun JP sub_bdos
		inc	hl
		ld	(hl), d
		ei
		ret

;------------------------------------------------------------------------------
; BDOS Funktion "nicht implementiert"
;------------------------------------------------------------------------------

bdos_unk:	ld	b, c
		ld	a, 6			; Fehler "undefinierte BD-Funktion"
		scf
		ret

;------------------------------------------------------------------------------
; ????
;------------------------------------------------------------------------------

loc_0_CFB1:	ld	hl, sys_bank
		ld	h, (hl)
		push	hl
		ld	hl, sys_rst20ret
		push	hl
		ex	de, hl
		jp	sys_jphl

;------------------------------------------------------------------------------
; BDOS Funktion 10
; Eingabe in Konsolenbuffer
; IN: DE: Pufferadresse
;------------------------------------------------------------------------------

bdos_10:	ld	l, e
		ld	h, d
		inc	hl
		ld	c, l
		ld	b, h
		inc	bc
		ld	(hl), 0
bdos_10_1:	rst	20h
		db 30h			; CONSI, Eingabe von Console (Tastatur)
		ret	c		; bei Fehler
		push	hl
		ld	hl, 0017h	; COLSW
		inc	(hl)
		dec	(hl)
		pop	hl
		jr	nz, bdos_10_6
		cp	3		; <STOP> ?
		jr	nz, bdos_10_2
		xor	a		; Fehler 0 "Abbruch mit Taste"
		scf
		ret
;
bdos_10_2:	cp	1Fh		; <DEL>
		jr	z, bdos_10_5
		cp	2		; <CL LN>
		jr	nz, bdos_10_4
bdos_10_3:	call	sub_0_D010
		ret	c		; bei Fehler
		jr	nz, bdos_10_3
		jr	bdos_10_1
bdos_10_4:	cp	0Dh		; <ENTER>
		jr	z, bdos_10_8
		cp	0Bh		; <CU UP>
		jr	z, bdos_10_1
		cp	0Ah		; <CU DOWN>
		jr	z, bdos_10_1
		cp	8		; <CU LEFT>
		jr	nz, bdos_10_6
bdos_10_5:	call	sub_0_D010
		ret	c		; bei Fehler
		jr	bdos_10_1
bdos_10_6:	cp	10h		; <CONTR P>
		jr	z, bdos_10_7
		inc	(hl)
		ld	(bc), a
		inc	bc
bdos_10_7:	rst	20h
		db 0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret	c		; bei Fehler
		ld	a, (de)
		cp	(hl)
		jr	nz, bdos_10_1
bdos_10_8:	rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
		ret
;
;
;
sub_0_D010:	inc	(hl)
loc_0_D011:	dec	(hl)
		ret	z
		dec	bc
		ld	a, (bc)
		cp	9
		jr	z, loc_0_D025
		cp	' '
		jr	c, loc_0_D011
		ld	a, 8
		rst	20h
		db 0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret	c		; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c		; bei Fehler
loc_0_D025:	ld	a, 8
		rst	20h
		db 0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret	c		; bei Fehler
		dec	(hl)
		ret

;------------------------------------------------------------------------------
; BDOS Funktion 0FFH
; Eintragen einer Funktion in BDOS-Liste
;------------------------------------------------------------------------------

bdos_255:	push	bc
		push	hl
		ld	hl, 7
		add	hl, sp
		ld	a, (hl)
		ld	c, b
		ld	b, 0
		ld	hl, 0E300h
		add	hl, bc
		add	hl, bc
		add	hl, bc
		or	0Fh
		ld	b, a
		ld	a, (sys_bank)
		and	0F0h
		or	0Ch
		di
		out	(0FFh),	a
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		ld	(hl), b
		ld	a, (sys_bank)
		out	(0FFh),	a
		ei
		pop	hl
		pop	bc
		ret

