;------------------------------------------------------------------------------
; BO2 Systemanlauf
;------------------------------------------------------------------------------

;		org 0C000h

		jp	cmd_bo2
		db "##      "
		db 0
		jp	cmd_help
aHelp:		db "HELP    "
		db 0
		db 0

up_wboot:	jp	sub_wboot

;------------------------------------------------------------------------------
; Bank 55 selektieren und Sprung nach Z9001-BIOS-WBOOT.
;------------------------------------------------------------------------------

cmd_z9001:	ld	a, standard_bank	; Bank 55 selektieren
		ld	hl, sys_setbank
		ld	(hl), 0D3h		; OUT FF
		inc	hl
		ld	(hl), 0FFh
		inc	hl
		ld	(hl), 0E9h		; JP (HL)
		ld	hl, WBOOT		; Warmstart, Sprung ins	Z9001-BIOS WBOOT
		jp	sys_setbank

;------------------------------------------------------------------------------
; Kommando BO2 (##)
; Aufruf: durch BO (Teil1), Systemanlauf
;------------------------------------------------------------------------------

asc_cmd_bo3:	db "###     "

a192KbyteRamEpr:db 0Dh
		db 0Ah
		db "192 KByte RAM/EPROM-Modul"
		db 0Dh
		db 0Ah
		db 0Ah
		db "SCPX 9001  0.00   (c) Lutz Elssner 1991"
		db 0Dh
		db 0Ah
		db 0Ah
		db 0

cmd_bo2:	

; Suchen des Kommandos BO3 ('###       ', in bo1.inc, auf Adr. E00C, Bank x0)
; als Kontrolle, ob auch BO1 (=BO3) existiert ???
		ld	de, asc_cmd_bo3		; "###     "
		ld	bc, 0E700h		; suchen ab E700H (0FFH)
		ld	l, 0FFh			; 
		call	fkt_searchlo		; Kommandosuche bis E000H (00H)
		jr	nc, cmd_z9001		; wenn Kdo. nicht gefunden
		
		ld	(user_bank), a		; Merken der BO1-System-Bank 	
		ld	(sys_bank), a
		out	(0FFh),	a		; Zuschaltung der LoBank (Std. ist x0)

; RAM-Systemzellen initialisieren
		call	sub_init_rst		; RSTs initialisieren
		call	sub_initpara		; Init. 0042h und EFF1-EFF9

		ld	hl, sys_wboot
		ld	(1), hl			; JP 0 (Warmstart) setzen auf JP 004dh

; Initialisieren von #UP, #BD
		call	sub_init_up_bd		
		jp	c, cmd_z9001		; bei Fehler Abbruch
		
; Ausgabe Startmeldung
		ld	de, a192KbyteRamEpr 	; "\r\n192 KByte RAM/EPROM-Modul\r\n\nSCPX 9001"...
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		jp	c, cmd_z9001		; bei Fehler
; 
		ld	de, aCcpk		; "#CCPK   "
		push	de
		rst	20h
		db 31h				; STCON, Statusabfrage Console (Tastaturstatus)
		jr	c, cmd_bo25		; bei Fehler
		cp	1Bh			; ESC-Taste gedrckt?
		jp	z, sub_run_ccp		; dann nichts weiter laden und direkt zum CCP

; Kaltstartinitialisierungen $-Kommandos
		ld	hl, aQQQQQQQ		; "$???????"
		ld	de, fcb1+1
		ld	bc, 8
		ldir
		ld	bc, 0E700h		; suche ab 0e700h (ff)
		ld	l, 0FFh
cmd_bo21:	ld	de, fcb1+1
		ld	a, '$'
		ld	(de), a
		call	sub_searchbnk		; Suchen des nchsten $-Kommandos
		jp	nz, sub_wboot7		; wenn nichts mehr gefunden, geht es mit WBOOT weiter
		push	bc
		push	hl
		push	de
		push	af
		ld	hl, fcb2+1		; gefundener Komandoname
		ld	b, 8
		rst	20h
		db 9h				; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		jr	c, cmd_bo23		; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		jr	c, cmd_bo23		; bei Fehler
		pop	af
		pop	de
		call	sub_runkdo		; Kommando starten
		jr	nc, cmd_bo22		; wenn OK
;		
		ld	de, aNichtBereit	; "nicht bereit"
		rst	20h			; anzeigen, wenn Fehler in Initialisierungs-Kdo.
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		jr	c, cmd_bo24		; bei Fehler
cmd_bo22:	rst	20h
		db 5h				; PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
		jr	c, cmd_bo24		; bei Fehler
		pop	hl
		pop	bc
		jr	cmd_bo21		; nchstes Kommando suchen
;
cmd_bo23:	pop	hl
		pop	de
cmd_bo24:	pop	hl
		pop	bc
cmd_bo25:	pop	de
		jp	sub_error

aQQQQQQQ:	db "$???????"

;------------------------------------------------------------------------------
; UP 81 WBOOT, BIOS-Ruf 1 Warmstart
;------------------------------------------------------------------------------

sub_wboot:	di
		ld	a, i
		cp	2			; I-Register korrekt?
		jr	z, sub_wboot6

; alles neu initialisieren		
		ld	a, (sys_bank)
		or	0Fh
		ld	(sys_bank), a
		out	(0FFh),	a

		; Sichern des Bereichs 100h..1FFh nach E600h..E6FFh(0FFh)
		ld	hl, 100h
		ld	de, 0E600h
		ld	bc, 100h
		xor	a
sub_wboot1:	ldi
		dec	hl
		ld	(hl), a			; dabei gleichzeitig Bereich lschen
		inc	hl
		jp	pe, sub_wboot1

		; Tauschen des Bereichs 200h..2FFh mit E700h..E7FFh(0FFh)
		ld	bc, 100h
sub_wboot2:	ld	a, (de)
		ldi
		dec	hl
		ld	(hl), a
		inc	hl
		jp	pe, sub_wboot2

		ld	hl, sys_wboot
		ld	(1), hl
		
		ld	a, (3)
		ld	b, a
		ld	a, (IOBYT)
		ld	(3), a			; I/O-Byte == 3
		ld	a, b
		ld	(IOBYT), a		; 
		
		ld	hl, 0F314h		; Z9001-BOS-Start (fr Sys-CALL 5)
		ld	(6), hl			; Call 5 -> 0F314h
		
		; Restarts testen
		ld	hl, 8			; Adr RST 8
		ld	de, 6			; Offset
		ld	c, 0C0h			; Adr. RST8 ist 02C0h
		ld	b, 7
sub_wboot3:	ld	a, 0C3h			; Code JP testen
		cp	(hl)
		inc	hl
		jr	nz, sub_wboot4		; bei Fehler
		ld	a, c			
		cp	(hl)			; lo(Adr.) testen
sub_wboot4:	inc	hl
		jr	nz, sub_wboot5		; bei Fehler
		ld	a, i
		cp	(hl)			; hi(Adr.) testen
		jr	nz, sub_wboot5		; bei Fehler
		ld	(hl), 2			; rcksetzen auf 2xxh
		
sub_wboot5:	add	hl, de			; HL = HL + 2 + 6 = Adr. nchster RST
		ld	a, c
		add	a, 9			; jeweils 9 Byte Code
		ld	c, a			; deshalb Adr. um 9 erhhen
		djnz	sub_wboot3		; alle RST bearbeiten
		
		ld	a, 2
		ld	i, a			; I-Register setzen
		
sub_wboot6:	ld	sp, 200h
		ei
		
		ld	a, (user_bank)
		ld	(sys_bank), a
		out	(0FFh),	a
		
		call	sub_initpara		; Init. 0042h und EFF1-EFF9
		
		ld	a, 0FFh			; Funktion FF, Initialisieren/Zurcksetzen CONST-Gert
		rst	20h			; Gertetreiberaufruf
		db 71h				; CCRT , CON - CRT - Gert (Bildschirm und Tastatur)
		jp	c, sub_error		; bei Fehler


		ld	de, aCcpw		; "#CCPW   "
		push	de
		
; Warmstartinitialisierungen der %-Kommandos (Bei Aufruf aus Kaltstart zeigt DE auf "#CCPK   ")
sub_wboot7:	ld	hl, aQQQQQQQ_0		; "%???????"
		ld	de, fcb1+1
		ld	bc, 8
		ldir
		ld	bc, 0E700h		; suche ab 0e700h (ff)
		ld	l, 0FFh
sub_wboot8:	ld	de, fcb1+1
		ld	a, '%'
		ld	(de), a
		call	sub_searchbnk		; Suchen des nchsten %-Kommandos
		jr	nz, sub_run_ccp		; wenn nichts mehr gefunden
		push	bc
		push	hl
		call	sub_runkdo		; Kommando starten
		jr	nc, sub_wboot9
		ld	hl, fcb2+1
		ld	b, 8
		rst	20h
		db 9h				; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		jr	c, sub_wboot10
		rst	20h
		db 5h				; PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
		jr	c, sub_wboot10
		ld	de, aNichtBereit 	; "nicht bereit"
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		jr	c, sub_wboot10
sub_wboot9:	pop	hl
		pop	bc
		jr	sub_wboot8
sub_wboot10:	pop	hl
		pop	bc
		
		pop	de
		jp	sub_error		; Fehler

aQQQQQQQ_0:	db "%???????"
aNichtBereit:	db "nicht bereit"
		db 0

;------------------------------------------------------------------------------
; Start des CCP
;------------------------------------------------------------------------------

sub_run_ccp:	pop	hl
		push	hl
		ld	de, fcb1+1
		ld	bc, 8
		ldir
		ld	bc, 0FC00h
		ld	l, 0FFh
		ld	de, fcb1+1
		call	sub_searchbnk
		ex	de, hl
		pop	de
		jp	z, sys_jphl
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		jp	c, cmd_z9001		; bei Fehler
		ld	de, aNichtGefundenA 	; "nicht gefunden -> ABBRUCH\r\n"
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		jp	cmd_z9001

aCcpk:		db "#CCPK   "
		db 0
aCcpw:		db "#CCPW   "
		db 0
aNichtGefundenA:db "nicht gefunden -> ABBRUCH"
		db 0Dh
		db 0Ah
		db 0

;------------------------------------------------------------------------------
; Abbruch bei Fehler
;------------------------------------------------------------------------------

sub_error:	rst	20h
		db 0Ch				; PRNER, Systemfehleranzeige, A=Fehlercode, B=Zusatzinformation
		jp	cmd_z9001

;------------------------------------------------------------------------------
; Initialisieren von UP und BD
;------------------------------------------------------------------------------

sub_init_up_bd:	ld	hl, aUp_0		; "#UP     "
		call	sub_init_up_bd1		; UP initialisieren
		ret	c			; bei Fehler
;
		ld	a, (sys_bank)
		ld	c, 45h			; UP CPROM in UP-Liste eintragen
		ld	de, up_cprom	
		rst	20h
		db 0FFh				; EXTUP, Einbindung eines weiteren Unterprogrammes in das System UP
		ret	c			; bei Fehler

		ld	c, 81h			; UP WBOOT in UP-Liste eintragen
		ld	de, up_wboot
		rst	20h
		db 0FFh				; EXTUP, Einbindung eines weiteren Unterprogrammes in das System UP
		ret	c			; bei Fehler
;
		ld	hl, aBd_0		; "#BD     "
						; BD initialisieren
;
sub_init_up_bd1:	ld	de, fcb1+1
		ld	bc, 8
		ldir
		ld	bc, 0DF00h
		ld	l, 0FFh
		ld	a, (user_bank)
		ld	(sys_bank), a
		out	(0FFh),	a
		ld	de, fcb1+1
		call	0E019h			; Kommandosuche in BO1
		ccf
		call	nc, sub_runkdo		; und Kdo starten
		ret

aUp_0:		db "#UP     "
aBd_0:		db "#BD     "

;------------------------------------------------------------------------------
; Init. 0042h und EFF1-EFF9
;------------------------------------------------------------------------------

sub_initpara:	
; Init. 0042h, 004dh
		ld	hl, loc_0_C30B
		ld	de, sys_rst20ret
		ld	bc, loc_0_C31E - loc_0_C30B	; Lnge
		ldir
; Init. User-Bank und sys_jphl
		ld	de, user_bank			; HL = loc_0_C31E
		ld	bc, sub_searchbnk - loc_0_C31E
		ld	a, (user_bank)
		di
		ldir
		ld	(user_bank), a
		ld	(sys_bank), a
		or	0Fh
		ld	(sys_wboot_bank+1), a	; sys_wboot patchen
		ei
		ret

;------------------------------------------------------------------------------
; Kommando auf DE starten
;------------------------------------------------------------------------------

sub_runkdo:	ex	de, hl
		push	hl
		ld	hl, sys_bank
		ld	h, (hl)
		ex	(sp), hl
		push	hl
		ld	hl, sys_rst20ret
		ex	(sp), hl
		jp	sys_jphl

;------------------------------------------------------------------------------
; RST 8 bis RST 38 initialisieren
; jp 02c0h, jp 02c9h, jp 02d2h, jp 02dbh, jp 02e4h, jp 02edh, jp 02f6h
;------------------------------------------------------------------------------

sub_init_rst:	ld	a, 0C3h			; JMP-Befehl 
		ld	c, 0			; Code-Offset
		ld	hl, 0008h		; erste Adresse (von RST 8)
		call	sub_init_rst_b		; fr alle RSTs JMP eintragen

		ld	a, 0C0h			; Adr. RST8 ist 02C0h
		ld	c, 9			; jeweils im 9er Offset weiter
		inc	hl			; Position Adr (Lo)
		call	sub_init_rst_b		; fr alles RSTs Adr (Lo) eintragen
		
		ld	a, i			; i ist 2
		ld	c, 0
		inc	hl			; Position Adr (Hi)
		call	sub_init_rst_b		; fr alles RSTs Adr (Hi) eintragen

		ld	a, i			; i ist 2
		ld	d, a
		ld	e, 0C0h			; de = 02c0h
		ld	a, 7			; fr alle RSTs
sub_init_rst1:	ld	bc, 9			; jeweils 9 Byte Code
		ld	hl, sub_init_rst_cod		
		ldir				; kopieren
		dec	a
		jr	nz, sub_init_rst1	
		ret

;
; Byte A nach HL, A+C nach HL+DE, A+2*C nach HL+2*DE, ... schreiben
;
sub_init_rst_b:	ld	b, 7
		ld	de, 8
		push	hl
sub_init_rst_b1:	ld	(hl), a
		add	a, c
		add	hl, de
		djnz	sub_init_rst_b1
		pop	hl
		ret

;
; Code fr RST - Befehle
;
sub_init_rst_cod:	push	af
		ld	a, 0FFh			; Schalten auf Bank 0FFh
		di
		out	(0FFh),	a
		jp	0			; und Warmstart

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------


loc_0_C30B:	equ	$

		phase	sys_rst20ret
	
; RST20-Return-Code, wird nach 0042h kopiert
		ex	(sp), hl
		push	af
		ld	a, h
		ld	(sys_bank), a
		out	(0FFh),	a
		pop	af
		pop	hl
		ret

; wird nach sys_wboot kopiert (Aufruf durch Warmstart JP 0)
		ld	hl, up_wboot
sys_wboot_bank:	ld	a, 0FFh
		jp	sys_jphl

		dephase

loc_0_C31E:	equ	$

		phase	user_bank

; wird nach 0EFF1h kopiert
		db	0FFh			; User-Bank

; wird nach 0EFF2h kopiert
		ld	(sys_bank), a		; sys_jphl init.

; wird nach 0EFF5h kopiert
		out	(0FFh),	a
		jp	(hl)

; wird nach 0EFF8h kopiert (ISR-Routine)
		ld	a, 0FFh			; sys_bank
		out	(0FFh),	a
		pop	af
		ei
		reti

		dephase

;------------------------------------------------------------------------------
; Kommandosuche mit Bankrckschaltung
;------------------------------------------------------------------------------

sub_searchbnk:	call	sub_searchfull
		push	af
		ld	a, (user_bank)
		ld	(sys_bank), a
		out	(0FFh),	a
		pop	af
		ret

;------------------------------------------------------------------------------
; Kommandosuche mit Bankrckschaltung
;------------------------------------------------------------------------------

up_cprom:	di
		call	sub_searchfull
		push	af
		ld	a, (sys_bank)
		or	0Fh
		ld	(sys_bank), a
		out	(0FFh),	a
		pop	af
		ei
		ret

;------------------------------------------------------------------------------
; Kommandosuche
;------------------------------------------------------------------------------

sub_searchfull:	ld	h, 0E8h			; Suche im Bereich FFFF - E800
		call	sub_search		; Kommandosuche mit '?'-Joker in einer Bank von (BC) bis (HL)
		jr	z, sub_searchfull1	; wenn gefunden
;		
		call	fkt_searchlo		; Kommandosuche im Bereich E000-E7FF
		jr	c, sub_searchfull3	; wenn gefunden
;		
		ld	a, (user_bank)		; Kommandosuche im Bereich C000-DFFF
		ld	(sys_bank), a
		out	(0FFh),	a
		call	0E019h			; fkt_searchhi Kommandosuche in BO1
		jr	c, sub_searchfull2	; wenn gefunden
;		
		ld	h, 1			; Suche im Bereich BFFF - 0100
		call	sub_search		; Kommandosuche mit '?'-Joker in einer Bank von (BC) bis (HL)
		ret	nz			; wenn nicht gefunden
;
sub_searchfull1:ld	a, (user_bank)
		ret
;
sub_searchfull2:and	0F0h
		ld	h, a
		srl	a
		srl	a
		srl	a
		srl	a
		jr	sub_searchfull4
;
sub_searchfull3:and	0Fh
		ld	h, a
		sla	a
		sla	a
		sla	a
		sla	a
;
sub_searchfull4:or	h
		cp	a
		ret

;------------------------------------------------------------------------------
; Kommandosuche im Lo-Bank-Bereich (E000-E7FF)
; gesucht wird von BC (L) bis E000h (00h).
; BC: Startadresse, DE: Suchstring, L: Bank
; Return: A: Bank, DE: Adr, Cy=1 gefunden
;------------------------------------------------------------------------------

fkt_searchlo:	ld	a, b
		cp	0E0h
		ccf
		ret	nc			; zurck, wenn BC < 0E000h
;
		ld	a, l			; Bank aus L
		and	0Fh			; Lo-Teil
		ld	h, a			; merken
		ld	a, (sys_bank)		; Systembank holen
		and	0F0h                    ; Systembank (Lo)
		or	h                       ; kombinieren
;
fkt_searchlo1:	ld	(sys_bank), a		; Bank merken
		out	(0FFh),	a		; und switchen
		ld	h, 0E0h			; Suche von BC bis 0E000h
		call	sub_search		; Kommandosuche mit '?'-Joker in einer Bank von (BC) bis (HL)
		ld	a, (sys_bank)		; Systembank holen
		scf
		ret	z			; zurck wenn gefunden
;
		ld	h, a			; Systembank merken
		and	0Fh			; Lo-Teil
		ret	z			; wenn Suche bis Bank 0x beendet
;
		ld	a, l			; Suchbank (Lo) verringern
		sub	1
		ld	l, a
		ld	a, h			; aktuelle Systembank
		sub	1
		ld	bc, 0E700h		; Suche ab 0E700h abwrts
		jr	fkt_searchlo1		; weitersuchen

;------------------------------------------------------------------------------
; Kommandosuche mit '?'-Joker (in einer Bank)
; es wird abwrts von (BC) bis (HL) in aktueller Bank auf xx00-Adressen gesucht
; BC: Suchadresse_von, HL: Suchadresse_bis, DE: Suchstring
; Return: A = 0ffh, Cy=1 nicht gefunden
; A=0, DE=Adr wenn gefunden
;------------------------------------------------------------------------------

sub_search:	ld	a, b
		cp	h			; Bereichsende erreicht?
		jr	nc, sub_search1		; weitersuchen
		xor	a			; A = 0
		dec	a			; A = 0ffh, Cy=1
		ret				; nicht gefunden
;		

sub_search1:	ld	a, (bc)			; ist auf der Adresse BC ein JMP-Befehl?
		cp	0C3h 			; JMP
		jr	nz, sub_search7		; nein -> nchsten Bereich
; folgt ein 0-Byte hinter JMP und Kdo-Name?
		push	hl
		ld	hl, 11			; 3 Byte JMP + 8 Byte Name
		add	hl, bc			; HL = Adr. nchster Tabelleneintrag
		ld	a, (hl)			; 
		pop	hl
		or	a			; 0-Byte?
		jr	nz, sub_search7		; nein -> nchster Bereich
;
		push	hl
		push	bc
		push	de
		ld	hl, 3
		add	hl, bc			; HL = BC+3 = adr Kdo-Name
;
		ld	bc, fcb2+1
		ld	a, 8			; 8 Zeichen
sub_search2:	push	af
		ld	a, (hl)			; Buchstaben holen
		ld	(bc), a			; in Param2 kopieren
		ld	a, (de)			; Suchstring-Buchstaben 
		cp	'?'			; Joker-Zeichen?
		jr	z, sub_search4		; dann ok
		or	a
		jr	nz, sub_search3		; 0-Bytes in Leerzeichen wandeln
		ld	a, ' '
sub_search3:	cp	(hl)			; Zeichen vergleichen
		jr	nz, sub_search5		; wenn ungleich
;		
sub_search4:	inc	hl			; nchstes Zeichen Kdo-Tabelle
		inc	de			; nchstes Zeichen Suchstring
		inc	bc			; nchstes Zeichen Param2
		pop	af
		dec	a			; alle 8 Zeichen bearbeitet?
		jr	nz, sub_search2		; nein -> weiter vergleichen
;Kdo-Namen gefunden
		pop	de			; Suchstring restaurieren
		pop	bc			; aktuelle Suchadresse
		inc	bc
		ld	a, (bc)
		ld	e, a
		inc	bc
		ld	a, (bc)
		ld	d, a			; DE = JMP-Adresse des Kdo
		dec	bc
		dec	bc			; BC zurcksetzen
		xor	a			; A=0
		jr	sub_search6
;
sub_search5:	pop	de			; Namen nicht gefunden
		pop	de
		pop	bc
sub_search6:	ld	hl, 12			; Lnge kompletter Tabelleneintrag
		add	hl, bc
		ld	c, l
		ld	b, h			; BC = BC+12 (Adr nchster KDO-Eintrag)
		pop	hl
		scf
		ccf
		ret	z			; zurck, wenn Namen gefunden
		jr	sub_search		; sonst weitersuchen
;		
sub_search7:	dec	b			; nchsten Bereich 
		ld	c, 0			; xx00h-Adresse
		jr	sub_search		; weitersuchen

;------------------------------------------------------------------------------
; Aulisten aller Programme
; Aufruf: HELP [kdo-name]
;------------------------------------------------------------------------------

cmd_help:	ld	a, (fcb1+1)
		cp	' '            		; folgt ein Parameter?
		jr	nz, cmd_help1		; ja, dann diesen nehmen
		ld	hl, aQQQQQQQQ		; "????????"
		ld	de, fcb1+1		; sonst	Standard-Maske (alle Kdo)
		ld	bc, 8
		ldir				; auf Param1 kopieren
;		
cmd_help1:	ld	bc, 0E700h		; Suche ab 0E700H (0FFH)
		ld	l, 0FFh
;		
cmd_help2:	ld	de, fcb1+1
		call	sub_searchbnk		; Suche
		ret	nz			; Ende wenn nichts mehr gefunden
;
		ex	de, hl
		rst	20h			; Ausgabe Bank
		db 6h				; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
;
		push	hl
		ld	hl, - 12
		add	hl, bc
		rst	20h			; Anzeige Kdo-Adresse in Tabelle
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		pop	hl
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		rst	20h			; Anzeige Kdo-Adresse in Speicher
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
;
		ld	hl, fcb2+1		; gefundener Kdo-Name
		push	bc
		ld	b, 8
		rst	20h			; anzeigen
		db 9h				; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		pop	bc
		ret	c			; bei Fehler
		rst	20h
		db 5h				; PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
		ret	c			; bei Fehler
		rst	20h
		db 13h				; PAUSE, Tastatureingabe PAUSE, CONT, STOP auswerten
		ret	c			; bei Fehler
		ret	z			; Ende bei Tastendruck
;
		ex	de, hl
		jr	cmd_help2		; weitersuchen

aQQQQQQQQ:	db "????????"			; Std-Suchmaske
