;------------------------------------------------------------------------------
; DB00, Bank A: EPROG - EPROM-Programmierung
;------------------------------------------------------------------------------

;		org	0db00h

		jp	cmd_el
		db "EL      "
		db 0
		jp	cmd_ek
		db "EK      "
		db 0
		jp	cmd_ed
		db "ED      "
		db 0
		jp	cmd_er
		db "ER      "
		db 0
		jp	cmd_ep
		db "EP      "
		db 0
		db    0

;------------------------------------------------------------------------------
; Eprom Leertest.
; Aufruf: EL [aepr eepr]
;------------------------------------------------------------------------------

cmd_el:
		ld	c, 'I'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		ld	a, (fcb1+1)
		cp	20h
		jr      z, cmd_el1		; Sprung, wenn keine Parameter angegeben wurden
		rst     20h
		db 1Eh				; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c			; bei Fehler
		call	sub_0_DE82
		ret	c			; bei Fehler

cmd_el1:	ld	c, 'L'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		ld	de, aEpromIstNichtL 	; "EPROM ist nicht leer"
		call	sub_0_DEE2
		ret	c			; bei Fehler
		ld	c, 'I'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret

aEpromIstNichtL:db "EPROM ist nicht leer"
		db  20h
		db  21h
		db    0

;------------------------------------------------------------------------------
; Eprom Kontrollsumme.
; Aufruf: EK [aepr eepr]
;------------------------------------------------------------------------------

cmd_ek:
		ld	c, 'I'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		ld	a, (fcb1+1)
		cp	20h
                jr      z, cmd_ek1		; Sprung, wenn keine Parameter angegeben wurden
		rst	20h
		db 1Eh				; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c			; bei Fehler
		call	sub_0_DE82
		ret	c			; bei Fehler
cmd_ek1:	ld	c, 'K'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
;
		ld	b, 8
cmd_ek2:	rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		rst	20h
		db 1h				; PRNZ , Ausgabe Register A als ASCII-Zeichen zum Bildschirm (00-1F als '.')
		ret	c			; bei Fehler
		djnz	cmd_ek2
;
		ld	b, 2
cmd_ek3:	rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		rst	20h
		db 6h				; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		djnz	cmd_ek3
		ld	c, 'I'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret

;------------------------------------------------------------------------------
; Eprom Display.
; Aufruf: ED [aepr eepr]
;------------------------------------------------------------------------------

cmd_ed:
		ld	c, 'I'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		ld	hl, 0
		ld	a, (fcb1+1)
		cp	20h
		jr	z, cmd_ed1		; Sprung, wenn keine Parameter angegeben wurden
		rst	20h
		db 1Eh				; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c			; bei Fehler
		call	sub_0_DE82
		ret	c			; bei Fehler
cmd_ed1:	ld	c, 'R'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
cmd_ed2:
		rst	20h
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
;
		ld	b, 8
cmd_ed3:	ld	c, 2
cmd_ed4:	rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		cp	0Dh
		jr	z, cmd_ed6
		rst	20h
		db 1h				; PRNZ , Ausgabe Register A als ASCII-Zeichen zum Bildschirm (00-1F als '.')
		ret	c			; bei Fehler
		dec	c
		jr	nz, cmd_ed4
		inc	hl
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		djnz	cmd_ed3
;
		rst	20h
		db 5h				; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c			; bei Fehler
		rst	20h
		db 13h				; PAUSE, Tastatureingabe PAUSE, CONT, STOP auswerten
		ret	c			; bei Fehler
		jr	nz, cmd_ed2
		ld	de, aAbbruchBitteWa 	; "\r\nABBRUCH - Bitte warten!"
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
;
cmd_ed5:	rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		cp	0Dh
		jr	nz, cmd_ed5
cmd_ed6:
		rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		ld	c, 'I'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret

aAbbruchBitteWa:db 0Dh
		db 0Ah
		db "ABBRUCH - Bitte warten!"
		db 0

;------------------------------------------------------------------------------
; Eprom Read.
; Aufruf: ER zadr [bank]
;	  ER aepr eepr zadr [bank]
;------------------------------------------------------------------------------

cmd_er:
		ld	c, 49h
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		rst	20h
		db 1Dh				; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		ret	c			; bei Fehler
		ld	a, (fcb2+1)
		cp	20h
cmd_er1:
		jr	z, cmd_er2
		push	de
		rst	20h
		db 1Dh				; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		pop	hl
		ret	c			; bei Fehler
		ex	de, hl
		push	hl
		sbc	hl, de
		pop	hl
		ex	de, hl
		ld	a, 2
		ret	c			; bei Fehler
		call	sub_0_DE82
		ret	c			; bei Fehler
		rst	20h
		db 1Dh				; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		ret	c			; bei Fehler
cmd_er2:
		ld	l, e
		ld	h, d
		call	sub_getbank
		ret	c			; bei Fehler
		ld	b, a
		push	de
		call	sub_0_DC75
		pop	de
		ret	c			; bei Fehler
		ld	c, 49h
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		dec	hl
		ex	de, hl
		rst	20h
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		ld	a, 2Dh
		rst	20h
		db 0h				; PRNA , Ausgabe Register A zum Bildschirm
		ret	c			; bei Fehler
		ex	de, hl
		rst	20h
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		ld	a, b
		rst	20h
		db 6h				; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		ld	de, aGeladen		; " geladen"
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret

aGeladen:	db " geladen"
		db 0

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

sub_0_DC75:
		ld	c, 'R'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
loc_0_DC7A:
		rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		cp	0Dh
		jr	z, loc_0_DCA6
		ld	c, a
		call	sub_hexziffer
		jr	c, loc_0_DCA2		; wenn keine Hex-Ziffer
		and	0Fh
		add	a, a
		add	a, a
		add	a, a
		add	a, a
		ld	e, a
		rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		ld	c, a
		call	sub_hexziffer
		jr	c, loc_0_DCA2		;  wenn keine Hex-Ziffer
		and	0Fh
		or	e
		ld	e, a
		ld	a, b
		rst	20h
		db 42h				; W1   , 1 Byte aus E auf (HL) in Bank (A) schreiben
		ret	c			; bei Fehler
		inc	hl
		jr	loc_0_DC7A
loc_0_DCA2:
		ld	b, c
		ld	a, 2
		ret
loc_0_DCA6:
		rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret

;------------------------------------------------------------------------------
; Eprom Programmieren.
; Aufruf: EP aadr eadr [bank [aepr [alg]]]
;------------------------------------------------------------------------------

cmd_ep:
		rst	20h
		db 1Eh				; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c			; bei Fehler
		call	sub_getbank
		ret	c			; bei Fehler
		ld	b, a
		push	hl
		ex	de, hl
		sbc	hl, de
		ld	de, 0
		ld	c, 0FFh
		ld	a, (fcb1+1)
		cp	20h
                jr      z, cmd_ep0
                rst     20h
                db 1Dh				; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
                jp      c, cmd_ep4
                ld      a, (fcb1+1)
                cp      20h
                jr      z, cmd_ep0
                push    de
		rst	20h
		db 19h				; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ld	c, e
		pop	de
		jr	c, cmd_ep4
cmd_ep0:	
		push	de
		ld	de, aProgrammieren 	; "\r\nprogrammieren:"
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		pop	de
		jr	c, cmd_ep4
		ex	de, hl
		ex	(sp), hl
		rst	20h
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		jr	c, cmd_ep4
		ld	a, '-'
		rst	20h
		db 0h				; PRNA , Ausgabe Register A zum Bildschirm
		jr	c, cmd_ep4
		push	hl
		add	hl, de
		rst	20h
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		pop	hl
		jr	c, cmd_ep4
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		jr	c, cmd_ep4
		ld	a, b
		rst	20h
		db 6h				; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		jr	c, cmd_ep4
		push	de
		ld	de, aPfeil		; " -> "
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		pop	de
		jr	c, cmd_ep4
		ex	(sp), hl
		rst	20h
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		jr	c, cmd_ep4
		ld	a, '-'
		rst	20h
		db 0h				; PRNA , Ausgabe Register A zum Bildschirm
		jr	c, cmd_ep4
		push	hl
		add	hl, de
		rst	20h
		db 7h				; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		pop	hl
		jr	c, cmd_ep4
		rst	20h
		db 5h				; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		jr	c, cmd_ep4
		ld	a, 3
		cp	c
		jr	nc, cmd_ep2
		push	de
		ld	de, aProgrammieralg 	; "\r\nProgrammieralgorithmen:\r\n\n0 STANDARD "...
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		pop	de
		jr	c, cmd_ep4
cmd_ep1:
		push	de
		ld	de, aAlgorithmusNum 	; "Algorithmus Nummer:"
		ld	c, 1
		rst	20h
		db 17h				; INPDA, Eingabe 1 Byte mit Aufforderungstext und Anzeige des vorgegebenen Wertes
		pop	de
		jr	c, cmd_ep4
		ld	a, 3
		cp	c
		jr	c, cmd_ep1
cmd_ep2:
		ld	a, 'I'
		call	sub_0_DEDA
		jr	c, cmd_ep4
		push	de
		ex	de, hl
		add	hl, de
		ex	de, hl
		push	bc
		call	sub_0_DE82
		ld	d, b
		pop	bc
		jr	nc, cmd_ep3
		ld	b, d
cmd_ep3:
		pop	de
cmd_ep4:
		pop	hl
		ret	c			; bei Fehler
		ld	a, 'P'
		call	sub_0_DEDA
		ret	c			; bei Fehler
		ld	a, c
		and	3
		or	30h
		ld	c, a
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		inc	de
cmd_ep5:
		ld	a, b
		rst	20h
		db 40h				; R1   , 1 Byte von (HL) Bank (A) in A lesen
		ret	c			; bei Fehler
		call	sub_0_DEB6
		ret	c			; bei Fehler
		inc	hl
		dec	de
		ld	a, e
		or	d
		jr	nz, cmd_ep5
		ld	de, aProgrammierfeh	; 'Programmierfehler !'
		call	sub_0_DEE2
		ret	c			; bei Fehler
		ld	c, 'I'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret

aProgrammieren:	db 0Dh
		db 0Ah
		db "programmieren:"
		db 0

aPfeil:		db " -> "
		db 0

aProgrammieralg:db 0Dh
		db 0Ah
		db "Programmieralgorithmen:"
		db 0Dh
		db 0Ah
		db 0Ah
		db "0 STANDARD        1 FAST INTEL"
		db 0Dh
		db 0Ah
		db "2 FAST FUJITSU    3 FAST AMD"
		db 0Dh
		db 0Ah
		db 0Ah
		db 0
aAlgorithmusNum:db "Algorithmus Nummer:"
		db 0
aProgrammierfeh:db "Programmierfehler !"
		db 0

;------------------------------------------------------------------------------
; Bank aus Kdo-Zeile holen bzw. interaktiv abfragen
; in: 	HL - Speicheradresse
; out: 	A - Bank
;------------------------------------------------------------------------------

sub_getbank:	ld	a, (fcb1+1)
		cp	' '
		jr	z, sub_getbank1		; keine Parameter vorhanden
		push	de
		rst	20h
		db 19h				; PARH2, 1 Byte hex aus Kdozeile in Register E
		jr	c, sub_getbank4		; bei Fehler
		ld	a, e
		pop	de
		ret				; Rckkgabe Bank in A
;
sub_getbank1:	ld	a, h			; Test auf Speicherbereich C000h-E7FFh
		and	0F8h
		cp	0E0h
		jr	z, sub_getbank2
		and	0E0h
		cp	0C0h
		jr	z, sub_getbank2
		ld	a, 0FFh			; anderer Bereich, gibt Bank 'FF' zurck
		or	a
		ret
;
sub_getbank2:	push	de			; Bereich C000h-E7FFh, Bank wird abgefragt
		ld	de, aBankZuAdresse 	; "Bank zu Adresse:"
		rst	20h
		db 8				; PRNST, Ausgabe ab (DE) bis 00
		jr	c, sub_getbank4		; bei Fehler
		inc	de
		rst	20h			; Ausgabe der Speicheradresse
		db 7				; PRNAD, Ausgabe HL hexa
		jr	c, sub_getbank4		; bei Fehler
		rst	20h
		db 5				; PCRLF, Ausgabe CR LF
		jr	c, sub_getbank4		; bei Fehler
		push	bc
		ld	c, 0FFh			; Vorgabebank FF
		rst	20h
		db 17h				; INPDA; Eingabe ein Byte mit Anzeige alter Wert
		jr	c, sub_getbank3		; bei Fehler
		rst	20h			; Eingabe aufbereiten
		db 28h				; NPAR CCP, 2 Parameter	aus Kdo-Zeile ab 80 als	Dateibezeichnung in FCB	ab 5C
		jr	c, sub_getbank3		; bei Fehler
		ld	a, c			; Rckkgabe Bank in A
		pop	bc
		pop	de
		ret
sub_getbank3:	pop	de
sub_getbank4:	pop	de
		ret
aBankZuAdresse:	db "Bank zu Adresse:"
		db 0
aEingeben:	db "  eingeben"
		db 0

;------------------------------------------------------------------------------
; Test auf Hex-Ziffer, Cy=1 bei Fehler
;------------------------------------------------------------------------------

sub_hexziffer:
		cp	30h
		ret	c			; bei Fehler
		cp	3Ah
		ccf
		ret	nc
		and	0DFh
		sub	7
		cp	3Ah
		ret	c			; bei Fehler
		cp	40h
		ccf
		ret

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------

sub_0_DE82:
		ld	bc, 0
		push	bc
		ld	c, 'X'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		jr	c, loc_0_DED7
		pop	bc
		ld	a, b
		and	7
		or	30h
		ld	b, c
		ld	c, a
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		call	sub_0_DEB0
		ret	c			; bei Fehler
		ex	de, hl
		ld	c, 'Y'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		ld	a, b
		and	7
		or	30h
		ld	c, a
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		call	sub_0_DEB0
		ret	c			; bei Fehler
		ex	de, hl
		ret

sub_0_DEB0:
		ld	a, h
		call	sub_0_DEB6
		ret	c			; bei Fehler
		ld	a, l
sub_0_DEB6:
		push	bc
		ld	b, a
		rlca
		rlca
		rlca
		rlca
		call	sub_0_DEC9
		jr	c, loc_0_DED7
		ld	a, b
loc_0_DEC2:
		call	sub_0_DEC9
		jr	c, loc_0_DED7
		pop	bc
		ret
sub_0_DEC9:
		and	0Fh
		add	a, 30h
		cp	3Ah
		jr	c, loc_0_DED3
		add	a, 7
loc_0_DED3:
		ld	c, a
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret
loc_0_DED7:
		inc	sp
		inc	sp
		ret
sub_0_DEDA:
		push	bc
		ld	c, a
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		jr	c, loc_0_DED7
		pop	bc
		ret
sub_0_DEE2:
		ld	c, 'S'
		rst	20h
		db 38h				; PUNO , Ausgabe zu Punch
		ret	c			; bei Fehler
		rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		ld	b, a
		rst	20h
		db 6h				; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		rst	20h
		db 6h				; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		rst	20h
		db 34h				; READI, Eingabe vom Reader
		ret	c			; bei Fehler
		rst	20h
		db 6h				; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		ld	a, b
		cp	30h
		ret	z
		rst	20h
		db 8h				; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret
