;------------------------------------------------------------------------------
; ER - ausfhrliche Fehlermeldungen
; reass 14.10.03 vpohlers
;------------------------------------------------------------------------------

;		org	0D500h
		
		jp	cmd_i_er
aEr:		db "$ER     "
		db 0
		jp	cmd_error
aError_0:	db "ERROR   "
		db 0
		db    0 ;

;------------------------------------------------------------------------------
; Eintragen erweiterter Fehlermeldungs-Ausgabe
; Aufruf: durch BO (Kaltstartinitialisierung)
;------------------------------------------------------------------------------

cmd_i_er:	ld	a, (sys_bank)
		ld	c, 0Ch		; UP PRNER
		ld	de, cmd_error1
		rst	20h
		db	0FFh		; EXTUP, Einbindung eines weiteren Unterprogrammes in das System UP
		ret

;------------------------------------------------------------------------------
; Testen der erweiterten Fehlermeldungen
; Aufruf: ERROR fehlernr zusatzinfo
;------------------------------------------------------------------------------

cmd_error:	rst	20h
		db 1Ah			; PARB2, 2 Byte hex. aus Kommandozeile holen, 1.Byte in L, 2.Byte in H u. E
		ret	c		; bei Fehler
		ld	a, l		; A = Fehlernummer
		ld	b, h		; B = Zusatzinfo
;
cmd_error1:	ld	d, a		; Sichern von Fehlernummer und Zusatzinfo
		ld	e, b
;		
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
		ret	c		; bei Fehler
		ld	a, d
		rst	20h		; Anzeige der Fehlernummer
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c		; bei Fehler
		ld	a, e
		rst	20h		; Anzeige der Zusatzinfo
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c		; bei Fehler
;
		ld	hl, tab_errnr
		ld	bc, tab_erridx-tab_errnr	; Anzahl der Fehlercodes
		ld	a, d
		cpir			; Suchen des Fehlers
		jr	nz, cmd_error2	; wenn nicht gefunden
;		
		ld	bc, tab_errnr
		scf
		sbc	hl, bc		; HL = Offset Fehlernummer in tab_errnr
		ld	bc, tab_erridx	
		add	hl, hl		; HL = HL*2 + tab_erridx
		add	hl, bc		; (HL) = Adresse des Fehlertexts
		push	de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)		; DE = Adresse des Fehlertexts
		rst	20h		; Ausgabe des Fehlertexts
		db 8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		pop	de
		ret	c		; bei Fehler
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
		ret	c		; bei Fehler
		ret
;		
cmd_error2:	ld	de, aUnprintableErr ; "unprintable error"
		rst	20h
		db 8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c		; bei Fehler
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
		ret

aUnprintableErr:db "unprintable error"
		db 0

tab_errnr:	db    0
		db    1
		db    2
		db    3
		db    4
		db    6
		db    7
		db    8
		db    9
		db  0Ah
		db  0Bh
		db  0Ch
		db  0Dh
		db  0Eh

tab_erridx:	dw aAbbruchMitTast	; 0 "Abbruch mit Taste"
		dw aZuWenigeParame	; 1 "zu wenige Parameter eingegeben"
		dw aFehlerhafterPa	; 2 "fehlerhafter Parameter"
		dw aParameterAusse	; 3 "Parameter ausserhalb zul. Grenzen"
		dw aFehlerBeiTreib	; 4 "Fehler bei Treiberzuweisung"
		dw aUndefinierteBd	; 6 "undefinierte BD-Funktion"
		dw aUndefinierteUp	; 7 "undefinierte UP-Funktion"
		dw aLog_GeraetNich	; 8 "log. Geraet nicht zugewiesen"
		dw aMemoryProtecte	; 9 "memory protected"
		dw aEndOfMemory		; A "end of memory"
		dw aRecordNotFound	; B "record not found"
		dw aBadRecord		; C "bad record"
		dw aFileNotFound	; D "file not found"
		dw aTapePruefsumme	; E "TAPE: Pruefsummenfehler"

aAbbruchMitTast:db "Abbruch mit Taste"
		db 0
aZuWenigeParame:db "zu wenige Parameter eingegeben"
		db 0
aFehlerhafterPa:db "fehlerhafter Parameter"
		db 0
aParameterAusse:db "Parameter ausserhalb zul. Grenzen"
		db 0
aFehlerBeiTreib:db "Fehler bei Treiberzuweisung"
		db 0
aQQQ:		db "???"
		db 0
aUndefinierteBd:db "undefinierte BD-Funktion"
		db 0
aUndefinierteUp:db "undefinierte UP-Funktion"
		db 0
aLog_GeraetNich:db "log. Geraet nicht zugewiesen"
		db 0
aMemoryProtecte:db "memory protected"
		db 0
aEndOfMemory:	db "end of memory"
		db 0
aRecordNotFound:db "record not found"
		db 0
aBadRecord:	db "bad record"
		db 0
aFileNotFound:	db "file not found"
		db 0
aTapePruefsumme:db "TAPE: Pruefsummenfehler"
		db 0

