;-----------------------------------------------------------------------------
; C000, Bank 4 - FDT+FDK
;-----------------------------------------------------------------------------

;FDCD:		equ	40h		; FDC Datenregister
;FDCC:		equ	41h		; FDC Steueregister
;FDCZ:		equ	48h		; FDC Zusatzregister, Bit 5: FDC Reset
					; 5 4 3 2 1 0
					; x x x x x x
					; | | | | | |
					; | | | | | Motor Laufwerk 0 ein/aus
					; | | | | Motor Laufwerk 1 ein/aus
					; | | | Motor Laufwerk 2 ein/aus
					; | | Motor Laufwerk 3 ein/aus
					; | ???
					; FDC Reset

;  Robotron-Modul
FDCD         	equ	98h  		; FDC Datenregister
FDCC         	equ	99h  		; FDC Steueregister
FDCZ        	equ	0A0h 		; FDC Zusatzregister
					; 5 4 3 2 1 0
					; x x 0 0 x x
					; | |     | |
					; | |     | Motor Laufwerk 0 ein/aus
					; | |     Motor Laufwerk 1 ein/aus
					; | Terminal Count aktivieren/deakt.
					; FDC Reset

port49:		equ	49h		; PIO B Daten
port4A:		equ	4Ah		; PIO A Kommando
port4B:		equ	4Bh		; PIO B Kommando

fdtkdotab:	equ	0E540h		; Standard-Kommando-Tabelle fr Modul FDT, Bank xE
fdkkdotab:	equ	0E013h		; Standard-Kommando-Tabelle fr Modul FDK, Bank xE

; IX zeigt auf Kdo-Tabelle
; ix+00h		; Anzahl Bytes Befehlsphase
; ix+01h		; Befehlscode
; ix+02h		; Parameter 1
; ix+03h		; Parameter 2
; ix+04h		; Parameter 3
; ix+05h		; Parameter 4
; ix+06h		; Parameter 5
; ix+07h		; Parameter 6
; ix+08h		; Parameter 7
; ix+09h		; Parameter 8
; ix+0Ah		; Anzahl Bytes Ergebnisphase
; ix+0Bh		; Resultatbyte 1: FDC-Status 0
; ix+0Ch		; Resultatbyte 2
; ix+0Dh		; Resultatbyte 3
; ix+0Eh		; Resultatbyte 3
; ix+0Fh		; Resultatbyte 5
; ix+10h		; Resultatbyte 6
; ix+11h		; Resultatbyte 7


;		org 0C000h

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

_0_C000:	in	a, (FDCD)
		and	b
		ld	l, a
		jp	(hl)

;------------------------------------------------------------------------------
; beliebiges FDC-Kommando
;------------------------------------------------------------------------------

sub_u8272:	in	a, (FDCD)
		bit	7, a
		jr	z, sub_u8272	; warten bis Daten vorhanden
		jr	u8272_1
;
		db  20h
		db  20h
		db  20h
;
_0_C010:        in	a, (FDCD)
                and	b
                ld	l, a
                jp	(hl)
;
u8272_1:	and	0F0h
		cp	80h
		ld	a, 80h
		scf
		ret	nz
		jr	u8272_2
;
		db  20h
;
_0_C020:        in	a, (FDCD)
                and	b
                ld	l, a
                jp	(hl)
;
u8272_2:	ld	(ix+0),	0
		ld	(ix+0Ah), 0
		jr	u8272_3
;
		db  20h
;
_0_C030:        in	a, (FDCD)
                and	b
                ld	l, a
                jp	(hl)
;
u8272_3:	ld	a, r
		push	hl
		push	bc
		push	af
		ld	c, 41h
		di
		exx
		jr	u8272_4
;
_0_C040:        in	a, (FDCD)
                and	b
                ld	l, a
                jp	(hl)
;
u8272_4:	ld	h, 0C0h
		ld	b, 0F0h
		ld	d, 0
		ld	c, (ix+1)	; Befehlscode
		jr	u8272_5
;
_0_C050:        in	a, (FDCD)
                and	b
                ld	l, a
                jp	(hl)
;
u8272_5:	call	sub_0_C090
		rr	l
		rlc	l
		pop	af
		ld	a, l
		jr	u8272_6
;
_0_C060:        in	a, (FDCD)
                and	b
                ld	l, a
                jp	(hl)
;
u8272_6:	exx
		jp	po, u8272_7
		ei
		jr	u8272_7
		db  20h
		db  20h
		db  20h
		db  20h
;
_0_C070:        in	a, (FDCD)
                and	b
                ld	l, a
                jp	(hl)
;
u8272_7:	pop	bc
		cp	80h
		jr	z, u8272_8
		inc	sp
		inc	sp
		scf
		ret
;
		db  20h
		db  20h
;
_0_C080:	ret

u8272_8:	ex	de, hl
		ex	(sp), hl
		ex	de, hl
		push	hl
		sbc	hl, de
		pop	hl
		pop	de
		ld	a, 93h
		ret	c
		ld	a, 92h
		ret
;
		db  20h
;
sub_0_C090:	ld	a, (ix+0Ah)	; Anzahl Bytes Ergebnisphase
		or	a
		ret	nz
		ld	e, (ix+0)	; Anzahl Bytes Befehlsphase
		ld	a, 8
		cp	e
		ret	c
		jr	loc_0_C0A1
;
		db  20h
		db  20h
;
_0_C0A0:	ret
;
loc_0_C0A1:	ld	a, c
		out	(FDCC), a
		ld	l, 6
loc_0_C0A6:	dec	l
		jr	nz, loc_0_C0A6
		inc	(ix+0)		; Anzahl Bytes Befehlsphase
		jr	loc_0_C0C1
;
		db  20h
		db  20h
;
_0_C0B0:	exx
		outi			; nchstes Byte ausgeben
		exx
loc_0_C0B4:	in	a, (FDCD)
		and	b
		ld	l, a
		jp	(hl)
;
		db  20h
		db  20h
		db  20h
		db  20h
		db  20h
		db  20h
		db  20h
;
_0_C0C0:	ret
;
loc_0_C0C1:	push	ix
		add	ix, de
		ld	c, (ix+2)
		pop	ix
		jr	loc_0_C0B4
;
		db  20h
		db  20h
		db  20h
		db  20h
;
_0_C0D0:	ld	e, (ix+0Ah)	; Anzahl Bytes Ergebnisphase
		ld	a, 6
		cp	e
		ret	c
		in	a, (FDCC)
		ld	l, 14h
loc_0_C0DB:	dec	l
		jr	nz, loc_0_C0DB	; kurz warten
		jr	loc_0_C0E1
;
_0_C0E0:	ret
;
loc_0_C0E1:	push	ix
		add	ix, de
		ld	(ix+0Bh), a	; FDC-Status merken
		pop	ix
		inc	(ix+0Ah)
		jr	loc_0_C0F4
;
		db  20h
;
_0_C0F0:	exx
		ini			; nchstes Byte lesen
		exx
loc_0_C0F4:	in	a, (FDCD)
		and	b
		ld	l, a
		jp	(hl)
;
		db  20h
		db  20h
		db  20h
		db  20h
		db  20h
		db  20h
		db  20h

;------------------------------------------------------------------------------
; C100, Bank A: FDT Floppy Disk Treiber
;------------------------------------------------------------------------------

;		org	0c100h
		org	nextpage($)

		jp	cmd_i_fdc
		db "$FDC    "
		db 0
		jp	cmd_i_fdc
		db "FDI     "
		db 0

byte_0_C118:	db 0			; Default-Wert FDCZ

;------------------------------------------------------------------------------
; FDT-Sprungtabelle
;------------------------------------------------------------------------------

fdt_u8272:	jp	sub_u8272	; beliebiges FDC-Kommando
		jp	sub_u82nd	; FDC-Kommando ohne Datenbertragung
		jp	sub_u82rw	; READ/WRITE DATA
fdt_prd:	jp	sub_prd		; Diskettenpuffer lesen
fdt_pwr:	jp	sub_pwr		; Diskettenpuffer schreiben
fdt_recal:	jp	sub_recal	; RECALIBRATE (mit neuem Steuerblock)
fdt_seek:	jp	sub_seek	; SEEK (mit neuem Steuerblock)
fdt_idzy:	jp	sub_idzy	; ID-Feld lesen
fdt_anz:	jp	sub_anz		; Anzeigen der Befehls- und Ergebnisphase
fdt_error:	jp	sub_error	; Fehleranzeige FDC
fdt_recau:	jp	sub_recau	; RECALIBRATE-Unterprogramm
fdt_seeku:	jp	sub_seeku	; SEEK-Unterprogramm
fdt_morec:	jp	sub_morec	; Motor ein, RECALIBRATE, Motor aus
		jp	sub_mordy	; Motor ein, warten bis FDC READY
		jp	sub_ready	; warten bis FDC READY
		jp	sub_stat	; Statusabfrage FDC, Rckkehrparameter A=ST3
cmd_fdr:	jp	sub_fdres	; Kommando FDR
cmd_fdm:	jp	sub_fdm		; Kommando FDM

;------------------------------------------------------------------------------
; Kommandos $FDC, FDI
;
; Initialisierung des Floppy-Disk-Moduls. Es werden alle Motoren ausgeschaltet,
; die Prkompensation ausgeschaltet, die FDC-Taktfrequenz 4 MHz eingestellt und
; der Befehl FDC-SPEZIFY zur Einstellung der Schrittzeit, Kopfentladezeit,
; Kopfladezeit und zur Einstellung des Nicht-DMA-Modus abgearbeitet.
;------------------------------------------------------------------------------

cmd_i_fdc:	call	sub_0_C228		; Test FDC bereit + Bank xE einstellen
		ret	c			; bei Fehler
		ld	a, (byte_0_C118)	; Default-Wert FDCZ
		cp	0
		jr	z, cmd_i_fdc1
;
		ld	a, 0CFh			; PIO-Mode 3 (Einzelbit-E/A)
		out	(port4B), a
		ld	a, 0F0h			; Bit 7-4 Eingabe, Bit 3-0 Ausgabe
		out	(port4B), a
		ld	a, 3
		out	(port49), a		; Bit 1, 0 = 1 --> bewirkt was?
		ld	a, 0CFh			; PIO-Mode 3 (Einzelbit-E/A)
		out	(port4A), a
		ld	a, 0C0h			; Bit 7-4 Eingabe, Bit 3-0 Ausgabe
		out	(port4A), a
;
		ld	a, (byte_0_C118)	; Default-Wert FDCZ
;
cmd_i_fdc1:	out	(FDCZ), a
;
		ld	ix, fdtkdotab
		ld	(ix+1),	3		; Befehlscode SPEZIFY
		ld	(ix+2),	11100001b	; Schrittratenzeit SRT = 14 = 4ms, Kopfentladezeit HUT = 1 = 32ms
		ld	(ix+3),	00001001b	; Kopfladezeit = 4 = x ms, Nicht-DMA-Betrieb
		call	sub_u82nd		; FDC-Kommando ohne Datenbertragung
		jp	c, sub_error
		ret

;------------------------------------------------------------------------------
; Kommando FDR
;
; Auslsung eines Hardware-Reset fr den FDC U 8272. Dieses Kommando ist bei
; Verklemmungen des FDC einzugeben.
;------------------------------------------------------------------------------

sub_fdres:	ld	a, (byte_0_C118)	; Default-Wert FDCZ
		push	af
		xor	20h			; Bit 5 -> FDC-Reset
		out	(FDCZ), a
		pop	af
		out	(FDCZ), a		; Default-Wert ausgeben
		ret

;------------------------------------------------------------------------------
; Kommando FDM [nummer]
;
; Ein- und Ausschalten des Motors eines Diskettenlaufwerkes. Zum Einschalten ist
; als nummer die physische Laufwerksnummer 0-3 einzugeben. Die Motoren der anderen
; 3 Laufwerke werden dabei ausgeschaltet. Bei Weglassen der nummer werden alle
; Motoren ausgeschaltet.
;------------------------------------------------------------------------------

sub_fdm:	in	a, (FDCD)
		cp	80h
		ld	a, 80h
		scf
		ret	nz
		ld	a, (fcb1+1)
		cp	20h
		ld	a, (byte_0_C118)	; Default-Wert FDCZ
		jr	z, sub_fdm1
		rst	20h
                db 19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c		; bei Fehler
		ld	a, e
		call	sub_0_C216		; Laufwerk setzen
sub_fdm1:	out	(FDCZ), a
		ret

;------------------------------------------------------------------------------
; UP zu Diskettenpuffer schreiben (PWR)
;------------------------------------------------------------------------------

sub_0_C1B2:	push	hl
		push	bc
		ld	a, (ix+2)
		and	3
		ld	c, a
		ld	b, 0
		add	hl, bc
		add	hl, bc
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		pop	bc
		bit	3, (hl)
		jr	nz, loc_0_C1CB
		res	6, (ix+1)
loc_0_C1CB:	ld	d, 3
		bit	4, (hl)
		jr	nz, loc_0_C1D3
		res	1, d
loc_0_C1D3:	xor	a
loc_0_C1D4:	add	a, (ix+3)
		dec	e
		jr	nz, loc_0_C1D4
		ld	e, a
		inc	hl
		cp	(hl)
		ccf
		jr	c, loc_0_C212
		inc	hl
		cp	(hl)
		jr	c, loc_0_C1E6
		set	2, d
loc_0_C1E6:	ld	(ix+0),	0
		ld	a, (ix+2)
		add	ix, bc
		ld	(ix+1),	0FFh
		ld	(ix+2),	a
		ld	(ix+3),	e
		call	sub_0_C216		; Laufwerk setzen
		ld	e, a
		ld	(ix+0),	0
		add	ix, bc
		ld	(ix+1),	3
		inc	hl
		ld	a, (hl)
		ld	(ix+2),	a
		inc	hl
		ld	a, (hl)
		ld	(ix+3),	a
		or	a
loc_0_C212:	pop	hl
		ld	a, 52h
		ret

;------------------------------------------------------------------------------
; Laufwerk setzen
; in a: Laufwerk 0..3. Verknpfen mit byte_0_C118 und Rckgabe in A
;------------------------------------------------------------------------------

sub_0_C216:	push	de
		and	3
		ld	e, 1
		jr	z, loc_0_C222
loc_0_C21D:	rlc	e
		dec	a
		jr	nz, loc_0_C21D
loc_0_C222:	ld	a, (byte_0_C118)	; Default-Wert FDCZ
		xor	e
		pop	de
		ret

;------------------------------------------------------------------------------
; Test FDC bereit + Bank xE einstellen
;------------------------------------------------------------------------------

sub_0_C228:	in	a, (FDCD)
		and	0F0h
		cp	80h
		ld	a, 80h
		scf
		ret	nz
		ld	a, (sys_bank)		; aktuelle Bank des Systems
		and	0F0h
		or	0Eh			; Bank xE zuschalten
		ld	(sys_bank), a		; aktuelle Bank des Systems
		out	(0FFh),	a
		ret

;------------------------------------------------------------------------------
; Fehleranzeige FDC
;------------------------------------------------------------------------------

sub_error:	or	a
		jr	z, sub_anz
		rst	20h
		db 0Ch				; PRNER, Systemfehleranzeige, A=Fehlercode, B=Zusatzinformation
		ret

;------------------------------------------------------------------------------
; Anzeigen der Befehls- und Ergebnisphase
;
; in folgender Form angezeigt:
;    xxxx xxxx (Datenbereich)
;    xx xx xx xx xx xx xx xx xx (Befehlsphase)
;    xx xx xx xx xx xx xx (Ergebnisphase)
;------------------------------------------------------------------------------

sub_anz:	push	ix
		push	bc
sub_anz1:	ld	a, (ix+0)		; Anzahl Bytes Befehlsphase
		or	a
		jr	nz, sub_anz2		; wenn A > 0

; wenn Anzahl Bytes Befehlsphase = 0, so Anzeige 2 Byte Befehlscode + Anzeige 2 Byte Anzahl Bytes Ergebnisphase und FDC-Status 0
		ld	a, 2
		ld	bc, 1
		call	sub_0_C274		; Anzeige von 2 Bytes ab (IX+1)
		jr	c, sub_anz3
		ld	bc, 0Ah			; Anzeige von 2 Bytes ab (IX+0Ah)
		add	ix, bc
		jr	sub_anz1

; wenn Anzahl Bytes Befehlsphase > 0, so Anzeige Kdo-Tabelle
sub_anz2:	ld	bc, 1
		call	sub_0_C274		; Anzeige von (ix+0) Byte (IX+1)
		jr	c, sub_anz3
		ld	a, (ix+0Ah)
		ld	bc, 0Bh
		call	sub_0_C274		; Anzeige von (ix+0Ah) Byte ab (IX+0bh)
sub_anz3:	pop	bc
		pop	ix
		ret

; Anzeige von A Bytes ab (IX+BC)
sub_0_C274:	push	ix
		add	ix, bc
		ld	b, a
		call	sub_0_C27F
		pop	ix
		ret

; Anzeige von B Bytes ab (IX)
sub_0_C27F:	inc	b
		dec	b
		jr	z, loc_0_C290		; wenn B=0
loc_0_C283:	ld	a, (ix+0)
		inc	ix
		rst	20h
		db 6h				; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db 2h				; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		djnz	loc_0_C283
loc_0_C290:	rst	20h
		db 5h				; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret

;------------------------------------------------------------------------------
; RECALIBRATE (mit neuem Steuerblock)
;------------------------------------------------------------------------------

sub_recal:	push	ix
		push	bc
		ld	(ix+0),	0		; Anzahl Bytes Befehlsphase
		ld	a, (ix+2)
		ld	bc, 0Ah
		add	ix, bc
		ld	(ix+2),	a
		pop	bc
		call	sub_recau
		pop	ix
		ret

;------------------------------------------------------------------------------
; SEEK (mit neuem Steuerblock)
;------------------------------------------------------------------------------

sub_seek:	push	ix
		push	bc
		push	de
		ld	(ix+0),	0		; Anzahl Bytes Befehlsphase
		ld	e, (ix+2)
		ld	bc, 0Ah
		add	ix, bc
		ld	(ix+2),	e
		ld	(ix+3),	a
		pop	de
		pop	bc
		call	sub_seeku
		pop	ix
		ret

;------------------------------------------------------------------------------
; RECALIBRATE-Unterprogramm
;------------------------------------------------------------------------------

sub_recau:	ld	(ix+3),	0FFh
		res	2, (ix+2)
sub_recau1:	ld	(ix+1),	7	; Befehlscode RECALIBRATE
		call	sub_u82nd	; FDC-Kommando ohne Datenbertragung
		ret	c		; bei Fehler
		push	de
		ld	de, 200h
		jr	sub_seeku1

;------------------------------------------------------------------------------
; SEEK-Unterprogramm
;------------------------------------------------------------------------------

sub_seeku:	ld	a, 55h
		cp	(ix+3)
		ld	a, 50h
		ret	c		; bei Fehler
		ld	(ix+1),	0Fh
		call	sub_u82nd	; FDC-Kommando ohne Datenbertragung
		ret	c		; bei Fehler
		push	de
		ld	de, 300h
sub_seeku1:	call	sub_0_C4D2	; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
		pop	de
		ret	c		; bei Fehler
;
sub_seeku2:	ld	(ix+1),	8	; Befehlscode SENSE INTERRUPT STATUS
		call	sub_u82nd	; FDC-Kommando ohne Datenbertragung
		ret	c		; bei Fehler
		ld	a, (ix+0Ah)	; Anzahl Bytes Ergebnisphase
		cp	1
		jr	nz, sub_seeku3
		ld	a, (ix+0Bh)	; FDC-Status 0
		cp	80h		; RQM-Bit: FDC bereit (B7=1)?
		jr	z, sub_seeku2	; wenn nicht bereit
;
sub_seeku3:	push	de
		ld	de, 102h
		call	sub_0_C4D2	; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
		pop	de
		ret	c		; bei Fehler
		push	bc
		ld	a, (ix+2)
		and	3
		ld	b, a
		ld	a, (ix+0Bh)	; FDC-Status 0
		and	3
		cp	b
		pop	bc
		jr	nz, sub_seeku2
		ld	a, (ix+0Bh)	; FDC-Status 0
		and	0F0h
		cp	20h
		jr	nz, sub_seeku5
		ld	a, (ix+3)
		cp	0FFh
		jr	nz, sub_seeku4
		xor	a
sub_seeku4:	cp	(ix+0Ch)
		ld	a, 51h
		scf
		ret	nz
		or	a
		ret
sub_seeku5:	cp	70h
		ld	a, 0
		scf
		ret	nz
		inc	(ix+3)
		jp	z, sub_recau1
		dec	(ix+3)
		ret

;------------------------------------------------------------------------------
; ID-Feld lesen
;------------------------------------------------------------------------------

sub_idzy:	ld	a, (ix+1)	; Befehlscode
		and	40h		; MFM-Bit erhalten
		or	0Ah
		ld	(ix+1),	a	; Befehlscode READ ID
		ld	a, b
		or	a
		ret	z
		ld	a, 38h
		cp	b
		jr	nc, sub_idzy1
		ld	b, a
sub_idzy1:	push	bc
		push	de
		push	hl
		push	ix
		ld	de, 12h
		ld	l, (ix+1)	; Befehlscode
		ld	h, (ix+2)
		ld	a, r
		push	af
		di
sub_idzy2:	ld	(ix+1),	l	; Befehlscode
		ld	(ix+2),	h
		call	sub_u82nd	; FDC-Kommando ohne Datenbertragung
		jr	c, sub_idzy3
		add	ix, de
		djnz	sub_idzy2
		or	a
sub_idzy3:	pop	hl
		bit	2, l
		jr	z, sub_idzy4
		ei
sub_idzy4:	pop	ix
		pop	hl
		pop	de
		pop	bc
		ret

;------------------------------------------------------------------------------
; Diskettenpuffer lesen
; in: HL
;------------------------------------------------------------------------------

sub_prd:	push	de
		ld	a, r
		push	af
		ld	a, (ix+1)	; Befehlscode
		and	40h		; MFM-Bit erhalten
		or	6
		ld	(ix+1),	a	; Befehlscode READ DATA
; 9 Byte von (IX+1)=Befehl nach (HL) kopieren
		push	ix
		push	bc
		ld	b, 9
		di
sub_prd1:	ld	a, (ix+1)
		ld	(hl), a
		inc	hl
		inc	ix
		djnz	sub_prd1
		pop	bc
		pop	ix
; 1 Byte  von E nach (HL) kopieren
		ld	(hl), e
		inc	hl
		jr	sub_pwr2

;------------------------------------------------------------------------------
; Diskettenpuffer schreiben
; in: HL
;------------------------------------------------------------------------------

sub_pwr:	push	de
		ld	a, r
		push	af
		di
		ld	a, (hl)
		and	40h		; MFM-Bit erhalten
		or	5		; Befehlscode WRITE DATA
		ld	(hl), a
; 9 Byte von (HL) nach (IX+1)=Befehl kopieren
		push	ix
		push	bc
		ld	b, 9
sub_pwr1:	ld	a, (hl)
		ld	(ix+1),	a	; Befehlscode
		inc	hl
		inc	ix
		djnz	sub_pwr1
		pop	bc
		pop	ix
; 1 Byte  von (HL) nach E kopieren
		ld	e, (hl)
		inc	hl
;
sub_pwr2:	push	ix
		call	sub_0_C1B2
		jr	c, sub_pwr5
		ld	a, (byte_0_C118)	; Default-Wert FDCZ
		cp	0
		jr	z, sub_pwr3
;
		ld	a, d
		out	(port49), a		; PIO Bits setzen
;
sub_pwr3:	ld	a, e
		out	(FDCZ), a
;
		in	a, (FDCD)
		and	0F0h
		cp	80h
		ld	a, 80h
		scf
		jr	nz, sub_pwr4
		call	sub_u82nd		; FDC-Kommando ohne Datenbertragung
		jr	c, sub_pwr4
		ld	de, 300h
		call	sub_0_C4D2		; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
		jr	c, sub_pwr4
		xor	a
		sub	c
		ld	c, a
		ld	a, 0
		sbc	a, b
		ld	b, a
		push	ix
		add	ix, bc
		ld	a, (ix+2)
		pop	ix
		ld	(ix+2),	a
		call	sub_ready
		jr	c, sub_pwr4
		add	ix, bc
		call	sub_seeku
		jr	c, sub_pwr4
		ld	de, 8
		add	hl, de
		add	ix, bc
		ld	de, 400h
		call	sub_u82rw
sub_pwr4:	push	af
		ld	a, (byte_0_C118)	; Default-Wert FDCZ
		out	(FDCZ), a
		pop	af
sub_pwr5:	pop	ix
		pop	de
		bit	2, e
		jr	z, sub_pwr6
		ei
sub_pwr6:	pop	de
		ret

;------------------------------------------------------------------------------
; Motor ein, RECALIBRATE, Motor aus
;------------------------------------------------------------------------------

sub_morec:	call	sub_mordy
		call	nc, sub_recal
		push	af
		ld	a, (byte_0_C118)	; Default-Wert FDCZ
		out	(FDCZ), a
		pop	af
		ret

;------------------------------------------------------------------------------
; Motor ein, waren bis FDC ready
;------------------------------------------------------------------------------

sub_mordy:	ld	a, (ix+2)
		call	sub_0_C216		; Laufwerk setzen
		out	(FDCZ), a
		push	ix
		push	bc
		ld	(ix+0),	0
		ld	a, (ix+2)
		ld	bc, 0Ah
		add	ix, bc		; IX = Kdo-Tabelle Ergebnisphase
		ld	(ix+2),	a
		pop	bc
		call	sub_ready
		pop	ix
		ret

;------------------------------------------------------------------------------
; warten bis FDC READY
;------------------------------------------------------------------------------

sub_ready:	push	de
		ld	de, 4000h
sub_ready1:	call	sub_stat
		jr	c, sub_ready2
		and	0A0h
		cp	20h
		jr	z, sub_ready2
		dec	de
		ld	a, e
		or	d
		jr	nz, sub_ready1
		ld	a, 81h
		scf
sub_ready2:	pop	de
		ret

;------------------------------------------------------------------------------
; READ/WRITE DATA
;------------------------------------------------------------------------------

sub_u82rw:	push	de
		push	hl
		call	sub_u8272
		jr	c, sub_u82rw2
		sbc	hl, de
		push	de
		ld	de, 907h
		call	sub_0_C4D2	; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
		pop	de
		jr	c, sub_u82rw2
		ld	a, (ix+0Bh)	; FDC-Status 0
		and	0F8h
		cp	40h
		jr	nz, sub_u82rw1
		ld	a, (ix+0Ch)	; FDC-Status 1
		cp	80h
		jr	nz, sub_u82rw1
		ld	a, (ix+0Dh)	; FDC-Status 2
		or	a
		jr	nz, sub_u82rw1
		pop	de
		sbc	hl, de
		ex	de, hl
		jr	z, sub_u82rw4
		ld	a, 94h
		jr	sub_u82rw3
sub_u82rw1:	xor	a
sub_u82rw2:	pop	de
sub_u82rw3:	scf
sub_u82rw4:	pop	de
		ret

;------------------------------------------------------------------------------
; Statusabfrage FDC, Rckkehrparameter A=ST3
;------------------------------------------------------------------------------

sub_stat:	ld	(ix+1),	4	; Befehlscode SENSE DRIVE STATUS
		call	sub_u82nd	; FDC-Kommando ohne Datenbertragung
		ret	c		; bei Fehler
		push	de
		ld	de, 201h
		call	sub_0_C4D2	; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
		pop	de
		ret	c		; bei Fehler
		ld	a, (ix+0Bh)	; FDC-Status 0
		ret

; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
sub_0_C4D2:	ld	a, d
		cp	(ix+0)		; Anzahl Bytes Befehlsphase
		ld	a, 9
		scf
		ret	nz
		ld	a, e
		cp	(ix+0Ah)	; Anzahl Bytes Ergebnisphase
		ld	a, 7
		scf
		ret	nz
		ld	a, (ix+0Bh)	; FDC-Status 0
		and	0C0h
		ld	a, 0
		ret

;------------------------------------------------------------------------------
; FDC-Kommando ohne Datenbertragung
;------------------------------------------------------------------------------

sub_u82nd:	push	hl
		ld	hl, 0F000h
		call	sub_u8272
		pop	hl
		ret	c		; bei Fehler
		scf
		ret	nz		; bei Fehler
		or	a		; Cy=0
		ret





;------------------------------------------------------------------------------
; C500, Bank A: FDK - Floppy Disk Kommandos
;------------------------------------------------------------------------------

;		org	0C500h
		org	nextpage($)

		jp	cmd_fdr
aFdr:		db "FDR     "
		db 0
		jp	cmd_fdm
aFdm:		db "FDM     "
		db 0
		jp	cmd_fdc
aFdc_0:		db "FDC     "
		db 0
		jp	cmd_fid
aFid:		db "FID     "
		db 0
		jp	cmd_fre
aFre:		db "FRE     "
		db 0
		jp	cmd_fse
aFse:		db "FSE     "
		db 0
		jp	cmd_format
aFormat:	db "FORMAT  "
		db 0
		jp	cmd_fsave
aFsave:		db "FSAVE   "
		db 0
		jp	cmd_fload
aFload:		db "FLOAD   "
		db 0
		nop


;------------------------------------------------------------------------------
; Kommando FDC
; Ausfhren eines FDC-Befehls
; Aufruf: FDC p1 p2 p3 p4 p5 p6 p7 p8 p9
;
; Ausfhrung eines der 15 Befehle des FDC. Die 9 Parameter entsprechen den 9
; Bytes, die der FDC in der Befehlsphase maximal liest. Abhngig vom Befehl knnen
; auch weniger Parameter ausreichen. Jeder Befehl besteht aus den 3 Phasen
; Befehlsphase, Ausfhrungsphase und Ergebnisphase. In der Befehlsphase werden die
; vom FDC tatschlich gelesenen Bytes, in der Ausfhrungsphase die tatschlich
; bertragenen Datenbytes und in der Ergebnisphase die tatschlich zurckgegebenen
; Bytes gezhlt.
;------------------------------------------------------------------------------

cmd_fdc:	call	sub_0_C691	; Test FDC bereit + Bank xE einstellen
		ret	c		; bei Fehler
		ld	ix, fdtkdotab
		call	up_seek
		ret	c		; bei Fehler
		ld	hl, fdkkdotab
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c		; bei Fehler
		call	fdt_u8272
		jp	c, fdt_error
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c		; bei Fehler
		jp	fdt_anz

;------------------------------------------------------------------------------
; Kommando READ ID
; Lesen mehrerer aufeinanderfolgender ID-Felder von der aktuellen Spur
; Aufruf: FID befehl nummer anzahl
;
; Lesen mehrerer aufeinanderfolgender Identifikationsfelder von der aktuellen Spur
; der Diskette. Als befehl ist 0A fr FM und 4A fr MFM anzugeben. Die nummer
; entspricht wieder der Laufwerksnummer 0-3, wobei zustzlich Bit 3 die Seite
; angibt. Als anzahl wird angegeben, wieviele ID-Felder gelesen werden sollen. Mit
; diesem Kommando knnen die Sektorgre, der physische Sektorversatz und weitere
; Angaben zum Diskettenformat ermittelt werden.
;------------------------------------------------------------------------------

cmd_fid:	call	sub_0_C691	; Test FDC bereit + Bank xE einstellen
		ret	c		; bei Fehler
		ld	b, 3
		ld	ix, fdkkdotab
		call	up_seek
		ret	c		; bei Fehler
		ld	b, (ix+3)
		call	fdt_idzy
		jp	c, fdt_error
		ld	a, b
		or	a
		ret	z
		ld	de, 12h
cmd_fid1:	call	fdt_anz
		ret	c		; bei Fehler
		add	ix, de
		rst	20h
		db 13h			; PAUSE, Tastatureingabe PAUSE, CONT, STOP auswerten
		ret	c		; bei Fehler
		ret	z
		djnz	cmd_fid1
		ret

;------------------------------------------------------------------------------
; Kommando RECALIBRATE
; Kopf auf Spur 0 positionieren
; Aufruf: FRE nummer
;
; lm angegebenen Laufwerk wird der Kopf auf Spur 0 positioniert.
;------------------------------------------------------------------------------

cmd_fre:	call	sub_0_C691	; Test FDC bereit + Bank xE einstellen
		ret	c		; bei Fehler
		ld	b, 1
		ld	ix, fdtkdotab
		inc	ix
		call	up_seek
		dec	ix
		ret	c		; bei Fehler
		call	fdt_recau
		jp	c, fdt_error
		ret

;------------------------------------------------------------------------------
; Kommando SEEK
; Kopf auf angegebene Spur positionieren
; Aufruf: FSE nummer spur
;
; im angegebenen Laufwerk wird der Kopf auf die angegebene Spur positioniert.
;------------------------------------------------------------------------------

cmd_fse:	call	sub_0_C691	; Test FDC bereit + Bank xE einstellen
		ret	c		; bei Fehler
		ld	b, 2
		ld	ix, fdtkdotab
		inc	ix
		call	up_seek
		dec	ix
		ret	c		; bei Fehler
		call	fdt_seeku
		jp	c, fdt_error
		ret

;------------------------------------------------------------------------------
; Kommando FORMAT
; phys. Formatieren von einzelnen Spuren
; Aufruf: FORMAT befehl nummer N SC GPL D tab H0v H1b
;
; Physisches Formatieren von einzelnen Spuren oder gesamten Disketten. Die
; ersten 6 Parameter entsprechen dem FDC-Befehl FORMAT A TRACK.
; befehl 0D fr FM und 4D fr MFM
; 	nummer 	Laufwerksnummer
; 	N 	Sektorlngencode 0 fr 128, 1 fr 256, 2 fr 512 und 3 fr 1024
; 	SC 	Sektoranzahl pro Spur
; 	GPL 	Lange der Lcke zwischen 2 Sektoren
; 	D 	Flldatenbyte, damit werden alle Sektoren beschrieben
; 	tab 	Nummer einer Sektornummerntabelle fr physischen Sektorversatz
; 	H0v 	Bit 7=1 Seite 0 formatieren
; 	Bit 0-6 Nummer der ersten zu formatierenden Spur
; 	H1b 	Bit 7=1 Seite 1 formatieren
; 	Bit 0-6 Nummer der letzten zu formatierenden Spur
;
; Bsp:	2 Seiten, 80 Spuren, 5 Sektoren je 1024 Byte MFM (800K)
; 	FORMAT 4D 0 3 5 74 E5 3 80 CF
;------------------------------------------------------------------------------

cmd_format:	call	sub_0_C691	; Test FDC bereit + Bank xE einstellen
		ret	c		; bei Fehler
		ld	b, 9
		ld	ix, fdtkdotab
		call	up_seek
		ret	c		; bei Fehler
		ld	hl, fdkkdotab
		call	up_format
		jp	c, fdt_error
		ret

;------------------------------------------------------------------------------
; Kommando FSAVE
; Speichen des Speicherinhalts 300h-A2FFh auf Disk
; Aufruf: FSAVE zahl
;
; Abspeichern des Speicherinhaltes von Adresse 300H bis A2FFH (40 KByte) auf 4
; Spuren (Vorder- und Rckseite) der Diskette. Die Spuren mssen mit 5 * 1024 Byte
; formatiert sein. Die gesamte Diskette ist in 20 Bereiche von je 4 Spuren (40
; KByte) eingeteilt. Die zahl (0-13H) gibt an, auf welchen Bereich abgespeichert
; werden soll.
;------------------------------------------------------------------------------

cmd_fsave:	call	sub_0_C691	; Test FDC bereit + Bank xE einstellen
		ret	c		; bei Fehler
		ld	ix, fdtkdotab
		ld	(ix+1),	0C5h	; Befehlscode WRITE DATA (MT=1, MFM=1, SK=0)
		jr	cmd_fload1

;------------------------------------------------------------------------------
; Kommando FLOAD
; Laden des Speicherinhalts 300h-A2FFh von Disk
; Aufruf: FLOAD zahl
;
; Laden eines mit FSAVE abgespeicherten 40 KByte Bereiches in den Speicher-
; Adrebereich 300H bis A2FFH. Die zahl (0-13H) gibt die Nummer des Bereiches an.
;------------------------------------------------------------------------------

cmd_fload:	call	sub_0_C691	; Test FDC bereit + Bank xE einstellen
		ret	c		; bei Fehler
		ld	ix, fdtkdotab
		ld	(ix+1),	0C6h	; Befehlscode READ DATA (MT=1, MFM=1, SK=0)
cmd_fload1:	rst	20h
		db 19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c		; bei Fehler
		ld	a, 13h
		cp	e
		ld	a, 3		; Fehler 3 "Parameter ausserhalb zul. Grenzen"
		ret	c		; wenn E > 13H
;
		sla	e
		sla	e		; E := E*4
		ld	(ix+2),	0	; Laufwerk 0
		ld	(ix+4),	0	; Kopf 0
		ld	(ix+5),	1	; Sektor 1
		ld	(ix+6),	3	; relative Sektorlnge 2^N = 2^3 = 8
		ld	(ix+7),	5	; EOT: Nummer des letzten Sektors der Spur
		ld	(ix+8),	38h	; GPL: Anzahl Lckenbytes in GAP 3
		ld	(ix+9),	0FFh	; DTL: Datenfeldlnge
		call	fdt_recal
		jp	c, fdt_error
;		
		ld	b, 4		; 4 x 10K speichern (= 4 Spuren)
		ld	hl, 300h	; Anfangsadresse
cmd_fload2:	ld	(ix+3),	e	; Spurnummer (Zylinder)
		ld	a, e
		call	fdt_seek
		jp	c, fdt_error
		call	fdt_u8272
		jp	c, fdt_error
		push	de
		ld	de, 907h
		call	sub_0_C74B	; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
		pop	de
		jp	c, fdt_error
		jr	z, cmd_fload3
		ld	a, (ix+0Bh)	; FDC-Status 0
		and	0F8h
		cp	40h
		jr	nz, cmd_fload4
		ld	a, (ix+0Ch)	; FDC-Status 1
		cp	80h
		jr	nz, cmd_fload4
		ld	a, (ix+0Dh)	; FDC-Status 2
		cp	0
		jr	nz, cmd_fload4
cmd_fload3:	inc	e		; nchste Spur
		djnz	cmd_fload2
;
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret
cmd_fload4:	xor	a
		jp	fdt_error

;------------------------------------------------------------------------------
; Test FDC bereit + Bank xE einstellen
;------------------------------------------------------------------------------

sub_0_C691:	in	a, (FDCD)	
		and	0F0h
		cp	80h
		ld	a, 80h
		scf
		ret	nz
		ld	a, (sys_bank)	; aktuelle Bank des Systems
		and	0F0h
		or	0Eh		; Bank xE zuschalten
		ld	(sys_bank), a	; aktuelle Bank des Systems
		out	(0FFh),	a
		ret

;------------------------------------------------------------------------------
; SEEK-Unterprogramm
;------------------------------------------------------------------------------

up_seek:	push	ix
		push	de
up_seek1:	rst	20h
		db 19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		jr	c, up_seek2
		ld	(ix+1),	e	; Befehlscode
		inc	ix
		ld	a, (fcb1+1)
		cp	20h
                jr      z, up_seek2
		djnz	up_seek1
up_seek2:	pop	de
		pop	ix
		ret

;------------------------------------------------------------------------------
; FORMAT-Unterprogramm
;------------------------------------------------------------------------------

up_format:	call	fdt_recal
		ret	c		; bei Fehler
up_format1:	ld	a, (ix+8)
		and	7Fh
		ld	c, a
		call	fdt_seek
		ret	c		; bei Fehler
		bit	7, (ix+8)
		jr	z, up_format2
		res	2, (ix+2)
		call	up_format4
		ret	c		; bei Fehler
up_format2:	bit	7, (ix+9)
		jr	z, up_format3
		set	2, (ix+2)
		call	up_format4
		ret	c		; bei Fehler
up_format3:	ld	a, (ix+9)
		and	7Fh
		ld	c, a
		ld	a, (ix+8)
		and	7Fh
		cp	c
		ret	nc
		inc	(ix+8)
		jr	up_format1
;
up_format4:	ld	a, (ix+1)	; Befehlscode
		and	40h		; MFM-bit erhalten
		or	0Dh		; Befehl FORMAT A TRACK
		ld	(ix+1),	a	; Befehlscode
		push	hl
		push	de
		push	bc
		push	hl
		ld	hl, sectab
		ld	a, (ix+7)
		and	0Fh
		ld	e, a
		ld	d, 0
		add	hl, de
		add	hl, de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		pop	hl
		ld	b, (ix+4)
		push	hl
up_format5:	ld	(hl), c
		inc	hl
		ld	a, (ix+2)
		srl	a
		srl	a
		ld	(hl), a
		inc	hl
		ld	a, (de)
		inc	de
		ld	(hl), a
		inc	hl
		ld	a, (ix+3)
		ld	(hl), a
		inc	hl
		djnz	up_format5
		pop	hl
		pop	bc
		pop	de
		call	fdt_u8272
		pop	hl
		ret	c		; bei Fehler
		push	de
		ld	de, 607h
		call	sub_0_C74B	; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
		pop	de
		ret	c		; bei Fehler
		scf
		ret	nz
		or	a
		ret

;------------------------------------------------------------------------------
; Test, ob (D) Bytes Befehlsphase und (E) Bytes Ergebnisphase
; (vgl. sub_0_C4D2 in Softwarekomponente FDT)
;------------------------------------------------------------------------------

sub_0_C74B:	ld	a, d
		cp	(ix+0)		; Anzahl Bytes Befehlsphase
		ld	a, 9
		scf
		ret	nz
		ld	a, e
		cp	(ix+0Ah)	; Anzahl Bytes Ergebnisphase
		ld	a, 7
		scf
		ret	nz
		ld	a, (ix+0Bh)	; FDC-Status 0
		and	0C0h
		ld	a, 0
		ret

;------------------------------------------------------------------------------
; Sektornummerntabellen fr physischen Sektorversatz
;------------------------------------------------------------------------------

sectab:		dw sectab1
		dw sectab2
		dw sectab3
		dw sectab4	; SCPX 5105
		dw sectab5	; CP/A
		dw sectab1
		dw sectab1
		dw sectab1
		dw sectab1
		dw sectab1
		dw sectab1
		dw sectab1
		dw sectab1
		dw sectab1
		dw sectab1
		dw sectab1

sectab1:	db    1
		db    2
		db    3
		db    4
		db    5
		db    6
		db    7
		db    8
		db    9
		db  0Ah
		db  0Bh
		db  0Ch
		db  0Dh
		db  0Eh
		db  0Fh
		db  10h

sectab2:	db    1
		db    2
		db    3
		db    4
		db  0Dh
		db  0Eh
		db  0Fh
		db  10h
		db    9
		db  0Ah
		db  0Bh
		db  0Ch
		db    5
		db    6
		db    7
		db    8

sectab3:	db    1
		db    9
		db    2
		db  0Ah
		db    3
		db  0Bh
		db    4
		db  0Ch
		db    5
		db  0Dh
		db    6
		db  0Eh
		db    7
		db  0Fh
		db    8
		db  10h

sectab4:	db    1		; CP/A
		db    5
		db    4
		db    3
		db    2

sectab5:	db    1		; SCPX 5105
		db    4
		db    2
		db    5
		db    3

		db 0FFh

