;------------------------------------------------------------------------------
; E400, Bank 0: KO - Monitorkommandos
;------------------------------------------------------------------------------

;		org	0E400h

		jp	cmd_pm
aPm:		db "PM      "
		db 0
		jp	cmd_rm
aRm:		db "RM      "
		db 0
		jp	cmd_pr
aPr:		db "PR      "
		db 0
		jp	cmd_s
aS:		db "S       "
		db 0
		jp	cmd_out
aOut:		db "OUT     "
		db 0
		jp	cmd_in
aIn:		db "IN      "
		db 0
		jp	cmd_d
aD:		db "D       "
		db 0
		jp	cmd_t
aT:		db "T       "
		db 0
		jp	cmd_v
aV:		db "V       "
		db 0
		jp	cmd_f
aF:		db "F       "
		db 0
		jp	cmd_j
aJ:		db "J       "
		db 0
		jp	cmd_cs
aCs:		db "CS      "
		db 0
		jp	cmd_hex
aHex:		db "HEX     "
		db 0
		jp	cmd_dez
aDez:		db "DEZ     "
		db 0

;------------------------------------------------------------------------------
; Bank aus Kdo-Zeile holen bzw. interaktiv abfragen
; in: 	HL - Speicheradresse
; out: 	A - Bank
;------------------------------------------------------------------------------
sub_getbank:	ld	a, (fcb1+1)
		cp	' '		
		jr	z, sub_getbank1	; keine Parameter vorhanden
		push	de
		rst	20h
		db 19h			; PARH2, 1 Byte hex aus Kdozeile in Register E
		jr	c, sub_getbank4	; bei Fehler
		ld	a, e
		pop	de
		ret			; Rckkgabe Bank in A
;
sub_getbank1:	ld	a, h		; Test auf Speicherbereich C000h-E7FFh
		and	0F8h
		cp	0E0h
		jr	z, sub_getbank2
		and	0E0h
		cp	0C0h
		jr	z, sub_getbank2
		ld	a, 0FFh		; anderer Bereich, gibt Bank 'FF' zurck
		or	a
		ret
;
sub_getbank2:	push	de		; Bereich C000h-E7FFh, Bank wird abgefragt
		ld	de, aBankZuAdresse ; "Bank zu Adresse:"
		rst	20h
		db 8			; PRNST, Ausgabe ab (DE) bis 00
		jr	c, sub_getbank4	; bei Fehler
		inc	de
		rst	20h		; Ausgabe der Speicheradresse
		db 7			; PRNAD, Ausgabe HL hexa
		jr	c, sub_getbank4	; bei Fehler
		rst	20h
		db 5			; PCRLF, Ausgabe CR LF
		jr	c, sub_getbank4	; bei Fehler
		push	bc
		ld	c, 0FFh		; Vorgabebank FF
		rst	20h
		db 17h			; INPDA; Eingabe ein Byte mit Anzeige alter Wert
		jr	c, sub_getbank3	; bei Fehler
		rst	20h		; Eingabe aufbereiten
		db 28h			; NPAR CCP, 2 Parameter	aus Kdo-Zeile ab 80 als	Dateibezeichnung in FCB	ab 5C
		jr	c, sub_getbank3	; bei Fehler
		ld	a, c		; Rckkgabe Bank in A
		pop	bc
		pop	de
		ret
sub_getbank3:	pop	de
sub_getbank4:	pop	de
		ret
aBankZuAdresse:	db "Bank zu Adresse:"
		db 0
aEingeben:	db "  eingeben"
		db 0

;------------------------------------------------------------------------------
; Punch Memory. Ausgabe eines Speicherbereiches auf PUNCH
; Aufruf: PM aadr eadr [sadr] [bank]
;------------------------------------------------------------------------------

; vp: das erscheint mir noch ein wenig unlogisch: Wo bleibt eadr und was ist mit 5Fh ?
; vp: derzeit wird von aadr bis sadr bzw. FFFFh ausgegeben

cmd_pm:
		rst	20h		; aadr und eadr holen
		db 1Eh			; PARA2, 2 Adr.	aus Kdo-Zeile nach HL und DE
		ret	c		; bei Fehler
		ld	de, 0FFFFh	; Default-Wert fr sadr
		ld	a, (5Fh)	; ???
		cp	' '
		jr	z, cmd_pm1
		rst	20h		; sadr holen
		db 1Dh			; PARH4, 1 Adr. hex aus Kdo-Zeile nach DE
		ret	c		; bei Fehler
cmd_pm1:	call	sub_getbank	; bank holen
		ret	c		; bei Fehler
		ld	b, a		; B = bank
		rst	20h
		db 3Ah			; OPPUN, Open PUNCH
		ret	c		; bei Fehler
cmd_pm2:	ld	a, b		; A = bank
		rst	20h
		db 40h			; R1, 1 Byte von (HL) Bank (A) in A lesen
		ret	c		; bei Fehler
		ld	c, a
		rst	20h
		db 38h			; PUNO, Ausgabe zu PUNCH
		ret	c		; bei Fehler
		push	hl
		sbc	hl, de		; solange Ende nicht erreicht
		pop	hl
		inc	hl		; nchste Adresse
		jr	nz, cmd_pm2	; und weiter ausgeben
		rst	20h
		db 3Bh			; CLPUN, Close PUNCH
		ret

;------------------------------------------------------------------------------
; Eingabe vos logischen Kanal READER in den Speicher
; Aufruf: RM aadr eadr [bank]
;------------------------------------------------------------------------------
cmd_rm:		rst	20h
		db 1Eh			; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c		; bei Fehler
		call	sub_getbank	; bank holen
		ret	c		; bei Fehler
		ld	b, a
		rst	20h
		db 36h			; OPRDR, OPEN Reader
		ret	c		; bei Fehler
cmd_rm1:	rst	20h
		db 34h			; READI, Eingabe vom Reader
		ret	c		; bei Fehler
		push	de
		ld	e, a
		ld	a, b
		rst	20h
		db 42h			; W1   , 1 Byte aus E auf (HL) in Bank (A) schreiben
		pop	de
		ret	c		; bei Fehler
		push	hl
		sbc	hl, de
		pop	hl
		inc	hl
		jr	nz, cmd_rm1
		rst	20h
		db 37h			; CLRDR, CLOSE Reader
		ret

;------------------------------------------------------------------------------
; Eingabe von logischen Kanal READER und Ausgabe auf den logischen Kanal PUNCH
; Aufruf: PR
;------------------------------------------------------------------------------
cmd_pr:		rst	20h
		db 36h			; OPRDR, OPEN Reader
		ret	c		; bei Fehler
		rst	20h
		db 3Ah			; OPPUN, OPEN Punch
		ld	hl, 0
		ld	e, l		; HL = DE = 0
		ld	d, h
		jr	c, cmd_pr3	; bei Fehler
cmd_pr1:	rst	20h
		db 35h			; STRDR, Statusabfrage Reader
		jr	c, cmd_pr2	; bei Fehler
		or	a
		jr	z, cmd_pr4	; A = 0 bei Ende 
		rst	20h		; Byte holen
		db 34h			; READI, Eingabe vom Reader
		jr	c, cmd_pr2	; bei Fehler
		ld	c, a
		rst	20h		; und byte audgeben
		db 38h			; PUNO , Ausgabe zu Punch
		jr	c, cmd_pr2	; bei Fehler
		ld	bc, 1		; Anzahl der transferierten Bytes in DEHL incrementieren
		rst	20h
		db 23h			; DADBC, BCD-Addition 8 Tetraden DEHL:=DEHL+BC
		jr	cmd_pr1		; und weitermachen
cmd_pr2:	push	af		; Carry-Flag retten
		call	cmd_pr4		; Ausgabe Anzahl verschobenener Bytes
		pop	af
		ret
cmd_pr3:	push	af		
		call	cmd_pr5
		pop	af
		ret
cmd_pr4:	rst	20h
		db 3Bh			; CLPUN, CLOSE Punch
		jr	c, cmd_pr3	; bei Fehler
;
cmd_pr5:	rst	20h		; Ausgabe Anzahl verschobenener Bytes
		db 37h			; CLRDR, CLOSE Reader
		ret	c		; bei Fehler
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c		; bei Fehler
		ex	de, hl		; Anzeige der Anzahl: erst DE, dann HL ausgeben
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c		; bei Fehler
		ex	de, hl
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c		; bei Fehler
		ld	de, aBytesTransfere ; " BYTES TRANSFERED "
		rst	20h
		db 8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret
aBytesTransfere:db " BYTES TRANSFERED "
		db 0

;------------------------------------------------------------------------------
; Anzeigen und ndern von Speicherzellen
; Aufruf: S aadr [bank]
;------------------------------------------------------------------------------
cmd_s:		rst	20h
		db 1Dh			; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		ret	c		; bei Fehler
		ex	de, hl		; HL = aadr
		call	sub_getbank	; bank holen
		ret	c		; bei Fehler
		ld	b, a		; B = Bank
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c		; bei Fehler
cmd_s1:		ld	a, b
		rst	20h		; Anzeige der Bank
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c		; bei Fehler
		rst	20h		; Anzeige der Adresse
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen 03
		ret	c		; bei Fehler
		ld	a, b		; Bank nach A
		rst	20h
		db 40h			; R1   , 1 Byte von (HL) Bank (A) in A lesen
		ret	c		; bei Fehler
		ld	c, a
		rst	20h		; Anzeige Byte hexadezimal
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c		; bei Fehler
		ld	a, c
		rst	20h		; Anzeige Byte ascii
		db 1h			; PRNZ , Ausgabe Register A als ASCII-Zeichen zum Bildschirm (00-1F als '.')
		ret	c		; bei Fehler
		ld	a, ':'
		rst	20h
		db 0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret	c		; bei Fehler
		rst	20h		; Eingabe eines neuen Wertes
		db 10h			; INBY , Eingabe 1 Byte hexadezimal in E   R:A=1 leer / A=2 falsch / A=3 OK
		ret	c		; bei Fehler
		dec	a
		jr	z, cmd_s3	; wenn nichts eingegeben
		dec	a
		jr	nz, cmd_s2	; wenn Eingabe ok
		ld	a, 0Bh
		rst	20h		; wenn Eingabe fehlerhaft, dann wiederholen
		db 0h			; PRNA , Ausgabe Register A zum Bildschirm
		jr	cmd_s1
cmd_s2:		ld	a, b		; Bank nach A
		rst	20h		; und neuen Wert schreiben
		db 42h			; W1   , 1 Byte aus E auf (HL) in Bank (A) schreiben
		ret	c		; bei Fehler
cmd_s3:		inc	hl		; nchste Adresse
		jr	cmd_s1		; und weitermachen bis Abbruch

;------------------------------------------------------------------------------
; Ausgabe auf eine Portadresse
; Aufruf: OUT port byte1 [byte2 ...]
;------------------------------------------------------------------------------
cmd_out:	rst	20h
		db 1Ah			; PARB2, 2 Byte hex. aus Kommandozeile holen, 1.Byte in L, 2.Byte in H u. E
		ret	c		; bei Fehler
		ld	c, l		; port
		ld	a, (fcb1+1)
		cp	' '		
		jr	nz, cmd_out1	; es folgen weitere Parameter
		out	(c), h		; Ausgabe byte1
		ret
cmd_out1:	rst	20h
		db 19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c		; bei Fehler
		di
		out	(c), h		; Ausgabe Byte1
		out	(c), e		; Ausgabe Byte2
		ei
cmd_out2:	ld	a, (fcb1+1)
		cp	' '
		ret	z		; keine weiteren Parameter
		rst	20h
		db 19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c		; bei Fehler
		out	(c), e		; Byte ausgeben
		jr	cmd_out2


;------------------------------------------------------------------------------
; Eingabe von einer Portadresse
; Aufruf: IN port [byte]
;------------------------------------------------------------------------------
cmd_in:		rst	20h
		db 19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c		; bei Fehler
		ld	c, e		; Port
		ld	a, (fcb1+1)
		cp	' '
		jr	nz, cmd_in1	; es folgen weitere Parameter
		in	a, (c)		; Port abfragen
		jr	cmd_in2
cmd_in1:	rst	20h		; byte holen
		db 19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c		; bei Fehler
		di
		out	(c), e		; byte ausgeben
		in	a, (c)		; Port abfragen
		ei
cmd_in2:	rst	20h		; gelesenes Byte anzeigen
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret

;------------------------------------------------------------------------------
; Anzeigen von Speicherbereichen
; Aufruf: D aadr eadr [bank]
;------------------------------------------------------------------------------
cmd_d:		rst	20h
		db 1Eh			; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c		; bei Fehler
					; HL = aadr, DE = eadr
		ld	a, l		; die Anfangsadresse auf xxx8h bzw. xxx0h abrunden
		and	0F8h
		ld	l, a
		call	sub_getbank	; bank holen
		ret	c		; bei Fehler
		ld	c, a		; C = bank
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c		; bei Fehler
cmd_d1:		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen 03
		ret	c		; bei Fehler
		push	hl
		ld	b, 8		; 8 Bytes nebeneinander anzeigen
cmd_d2:		ld	a, c
		rst	20h		; Byte holen
		db 40h			; R1   , 1 Byte von (HL) Bank (A) in A lesen
		ret	c		; bei Fehler
		inc	hl		; nchste Adresse
		rst	20h		; Byte anzeigen
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		jr	c, cmd_d3	; bei Fehler
		rst	20h
		db 2			; PRNSP, Ausgabe ein Leerzeichen
		jr      c, cmd_d3	; bei Fehler
		djnz	cmd_d2		; bis 8 Bytes abgearbeitet
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen
cmd_d3:		pop	hl		; Adresse wiederherstellen
		ret	c		; bei Fehler
		ld	b, 8		; 8 Bytes nebeneinander anzeigen
cmd_d4:		ld	a, c		; bank
		rst	20h
		db 40h			; R1   , 1 Byte von (HL) Bank (A) in A lesen
		ret	c		; bei Fehler
		inc	hl
		rst	20h		; Byte ascii anzeigen
		db 1h			; PRNZ , Ausgabe Register A als ASCII-Zeichen zum Bildschirm (00-1F als '.')
		ret	c		; bei Fehler
		djnz	cmd_d4		; bis 8 Bytes abgearbeitet
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c		; bei Fehler
		push	hl
		dec	hl
		sbc	hl, de		; aktuelle adr-1 < eadr ? 
		pop	hl
		ret	nc		; wenn Endeadresse erreicht
		rst	20h		; Tastendruck auswerten
		db 13h			; PAUSE, Tastatureingabe PAUSE, CONT, STOP auswerten
		ret	c		; bei Fehler
		ret	z		; Feierabend bei Abbruch
		jr	cmd_d1		; sonst weiteranzeigen

;------------------------------------------------------------------------------
; Transportieren von Speicherbereichen
; Aufruf: T aadr eadr zadr [qbank] [zbank]
;------------------------------------------------------------------------------
cmd_t:		rst	20h
		db 1Fh			; PARA3, 3 Adressen hexadezimal aus Kommandozeile in HL, DE und BC holen
		ret	c		; bei Fehler
		push	bc
		call	sub_getbank	; bank holen
		jr	c, cmd_t2
		ld	b, a
		ex	(sp), hl
		call	sub_getbank	; bank holen
		jr	c, cmd_t2
		ld	c, a
		ex	(sp), hl
		ex	de, hl
		sbc	hl, de
		ex	(sp), hl
		push	hl
		sbc	hl, de
		pop	hl
		ex	(sp), ix
		jr	nc, cmd_t1
		ex	de, hl
		inc	ix
		rst	20h
		db 44h			; LDIRU, Blocktransport zwischen Bnken von (HL) (B) nach (DE) (C), Lnge = IX
		pop	ix
		ret
cmd_t1:		push	bc
		ex	(sp), ix
		pop	bc
		add	hl, bc
		ex	de, hl
		add	hl, bc
		inc	bc
		push	bc
		ex	(sp), ix
		pop	bc
		rst	20h
		db 46h			; LDDRU, Blocktransport rckwrts (entspricht LDDR), Register wie LDIRU
		pop	ix
		ret
cmd_t2:		pop	de
		ret

;------------------------------------------------------------------------------
; Vergleichen von Speicherbereichen
; Aufruf: V aadr eadr zadr [qbank] [zbank]
;------------------------------------------------------------------------------
cmd_v:
		rst	20h
		db 1Fh			; PARA3, 3 Adressen hexadezimal aus Kommandozeile in HL, DE und BC holen
		ret	c		; bei Fehler
		push	bc
		call	sub_getbank	; bank holen
		jr	c, cmd_t2
		ld	b, a
		ex	(sp), hl
		call	sub_getbank	; bank holen
		jr	c, cmd_t2
		ld	c, a
		ex	(sp), hl
		ex	de, hl
		sbc	hl, de
		ex	(sp), hl
		ex	(sp), ix
		ex	de, hl
cmd_v1:		push	bc
		ld	a, b
		rst	20h
		db 40h			; R1   , 1 Byte von (HL) Bank (A) in A lesen
		jr	c, cmd_v3	; bei Fehler
		ld	b, a
		ld	a, c
		ex	de, hl
		rst	20h
		db 40h			; R1   , 1 Byte von (HL) Bank (A) in A lesen
		ex	de, hl
		jr	c, cmd_v3	; bei Fehler
		ld	c, a
		cp	b
		jr	z, cmd_v2
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		jr	c, cmd_v3	; bei Fehler
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen 03
		jr	c, cmd_v3	; bei Fehler
		ex	(sp), hl
		ld	a, h
		rst	20h
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		jr	c, cmd_v3	; bei Fehler
		ld	a, ':'
		rst	20h
		db 0h			; PRNA , Ausgabe Register A zum Bildschirm
		jr	c, cmd_v3	; bei Fehler
		ld	a, b
		rst	20h
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		jr	c, cmd_v3
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen 03
		jr	c, cmd_v3	; bei Fehler
		ex	de, hl
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		jr	c, cmd_v3	; bei Fehler
		ex	de, hl
		rst	20h
		db 2h			; PRNSP, Ausgabe ein Leerzeichen 03
		jr	c, cmd_v3	; bei Fehler
		ld	a, l
		rst	20h
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		jr	c, cmd_v3	; bei Fehler
		ex	(sp), hl
		ld	a, ':'
		rst	20h
		db 0h			; PRNA , Ausgabe Register A zum Bildschirm
		jr	c, cmd_v3	; bei Fehler
		ld	a, c
		rst	20h
		db 6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		jr	c, cmd_v3	; bei Fehler
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		jr	c, cmd_v3	; bei Fehler
cmd_v2:		rst	20h
		db 13h			; PAUSE, Tastatureingabe PAUSE, CONT, STOP auswerten
		jr	c, cmd_v3
		jr	z, cmd_v3
		ld	bc, 0FFFFh
		add	ix, bc
		pop	bc
		inc	hl
		inc	de
		jr	c, cmd_v1
		pop	ix
		ret
cmd_v3:		pop	de
		pop	ix
		ret

;------------------------------------------------------------------------------
; Fllen von Speicherbereichen
; Aufruf: F aadr eadr byte [bank]
;------------------------------------------------------------------------------
cmd_f:		rst	20h
		db 1Eh			; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c		; bei Fehler
		ex	de, hl
		sbc	hl, de
		ld	c, l
		ld	b, h
		inc	bc
		ex	de, hl
		rst	20h
		db 19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c		; bei Fehler
		call	sub_getbank	; bank holen
		ret	c		; bei Fehler
		ld	d, a
cmd_f1:		ld	a, d
		rst	20h
		db 42h			; W1   , 1 Byte aus E auf (HL) in Bank (A) schreiben
		ret	c		; bei Fehler
		inc	hl
		dec	bc
		ld	a, b
		or	c
		ret	z
		jr	cmd_f1

;------------------------------------------------------------------------------
; Sprung zu einer Speicheradresse
; Aufruf: J adr [bank]
;------------------------------------------------------------------------------
cmd_j:		rst	20h
		db 1Dh			; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		ret	c		; bei Fehler
		ex	de, hl		; HL = adr
		call	sub_getbank	; bank holen
		ret	c		; bei Fehler
		jp	sys_jphl	; Sprung zu (HL) in Bank (A)

;------------------------------------------------------------------------------
; Berechnen der Prfsumme eines Speicherbereiches
; Aufruf: CS aadr eadr [bank]
;------------------------------------------------------------------------------
cmd_cs:		rst	20h
		db 1Eh			; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c		; bei Fehler
		call	sub_getbank	; bank holen
		ret	c		; bei Fehler
		ld	c, e
		ld	b, d
		ld	de, 0FFFFh
		push	ix
		ld	ix, 0
cmd_cs1:	push	af
		rst	20h
		db 40h			; R1   , 1 Byte von (HL) Bank (A) in A lesen
		jr	c, cmd_cs2	; bei Fehler
		push	bc
		ld	c, a
		ld	b, 0
		add	ix, bc
		pop	bc
		xor	d
		ld	d, a
		rrca
		rrca
		rrca
		rrca
		and	0Fh
		xor	d
		ld	d, a
		rrca
		rrca
		rrca
		push	af
		and	1Fh
		xor	e
		ld	e, a
		pop	af
		push	af
		rrca
		and	0F0h
		xor	e
		ld	e, a
		pop	af
		and	0E0h
		xor	d
		ld	d, e
		ld	e, a
		pop	af
		push	hl
		or	a
		sbc	hl, bc
		pop	hl
		inc	hl
		jr	nz, cmd_cs1
		push	ix
		pop	hl
		pop	ix
		push	de
		ld	de, aCs_0	; "CS:"
		rst	20h
		db 8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		pop	de
		ret	c		; bei Fehler
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c		; bei Fehler
		ex	de, hl
		ld	de, aCrc	; "CRC:"
		rst	20h
		db 8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c		; bei Fehler
		rst	20h
		db 7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c		; bei Fehler
		rst	20h
		db 5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret
cmd_cs2:	pop	de
		pop	ix
		ret
aCs_0:		db "CS:"
		db 0
aCrc:		db " CRC:"
		db 0

;------------------------------------------------------------------------------
; Konvertierung dez -> hex
; Aufruf: HEX dez
;------------------------------------------------------------------------------
cmd_hex:	rst	20h
		db 1Ch			; PARDA, 1 Adr.	dez aus	Kdo-Zeile nach DE
		ret	c		; bei Fehler
		ex	de, hl
		rst	20h
		db 7			; PRNAD, Ausgabe HL hex
		ret

;------------------------------------------------------------------------------
; Konvertierung hex -> dez
; Aufruf: DEZ hex
;------------------------------------------------------------------------------
cmd_dez:	rst	20h
		db 1Dh			; PARH4, 1 Adr.	hex aus	Kdo-Zeile nach DE
		ret	c		; bei Fehler
		ex	de, hl
		rst	20h
		db 0Dh			; PRDEZ, Ausgabe HL dez
		ret

