PORT_SIODA	EQU 0B0H			; Datenadr SIO Kanal A
PORT_IOKD	EQU PORT_SIODA+2		; Kdoadr   - " -
PORT_CTC0	EQU 0A8H			; Adr CTC Kanal 0

;------------------------------------------------------------------------------
; SIO serielle Treiber
;------------------------------------------------------------------------------

;		org	0d500h

		jp	cmd_dtr
		db "DTR     "
		db 0
		jp	cmd_xonxoff
		db "XON/XOFF"
		db 0
		jp	cmd_lst
		db "LST     "
		db 0
		jp	cmd_ctrlp
		db "'^P     "
		db 0
		jp	cmd_i_sio
		db "$SIO    "
		db 0
		db    0

;------------------------------------------------------------------------------
; Druckertest, Ausgabe Testtext auf LIST-Kanal
; Aufruf: LST
;------------------------------------------------------------------------------

cmd_lst:	ld	de, aDruckertest 	; "Druckertest\r\n"
cmd_lst1:	ld	a, (de)
		inc	de
		or	a
		ret	z
		ld	c, a
		rst	20h
		db 3Ch				; LISTO, Ausgabe zu List
		ret	c			; bei Fehler
		jr	cmd_lst1
;
aDruckertest:	db "Druckertest"
		db 0Dh
		db 0Ah
		db 0

;------------------------------------------------------------------------------
; Hardcopy aus
; Aufruf: ^P
;------------------------------------------------------------------------------

cmd_ctrlp:	xor	a			; A := 0
		ld	(LISW), a
		ret

;------------------------------------------------------------------------------
; SIO initialisieren
; Aufruf (durch BO): $SIO
;------------------------------------------------------------------------------

cmd_i_sio:	ld	hl, data_i_sio		; Initialisierungsdaten
cmd_i_sio1:	ld	a, (hl)
		inc	hl
		or	a
		jr	z, cmd_i_sio2
		ld	b, a			; Anzahl Bytes
		ld	c, (hl)			; Port
		inc	hl
		otir				; an SIO ausgeben
		jr	cmd_i_sio1
cmd_i_sio2:	ld	a, 1
		out	(port_iokd), a
		in	a, (port_iokd)
		ld	b, a
		and	0FEh
		cp	0Eh
		ld	a, 8
		scf
		ret	nz
		ld	a, 2
		and	3
		sla	a
		sla	a
		ld	c, a
		sla	a
		sla	a
		or	c
		ld	b, a
		ld	a, i
		ld	h, a
		ld	a, 90h
		add	a, c
		ld	l, a
		ld	(hl), PORT_SIODA
		inc	hl
		ld	(hl), port_iokd
		inc	hl
		ld	(hl), 6Ah
		inc	hl
		ld	(hl), 0
		ld	a, i
		ld	h, a
		ld	a, 0A0h
		add	a, c
		ld	l, a
		ld	(hl), PORT_SIODA
		inc	hl
		ld	(hl), port_iokd
		inc	hl
		ld	(hl), 6Ah
		inc	hl
		ld	(hl), 0
		ld	a, (sys_bank)
		ld	de, up_dtr
		ld	c, 76h
		rst	20h
		db	0ffh
		ret	c			; bei Fehler
		ld	c, 7Ah
		rst	20h
		db	0ffh
		ret	c			; bei Fehler
		ld	hl, 4
		ld	a, i
		cp	2
		jr	z, cmd_i_sio3
		dec	hl
cmd_i_sio3:	ld	a, (hl)
		and	0C3h
		or	b
		ld	(hl), a
		ret

; Initialisierungsdaten fr SIO

data_i_sio:	db    2				; Anzahl Bytes
		db    port_ctc0			; Port
		db    7
		db    1				; 9600 Baud
;
		db    7				; Anzahl Bytes
		db    port_iokd			; Port
		db	00011000b		; Kdo Channel Reset
		db	4			; next Register WR4
		db	01000111b		; Parity even, 1 Stop Bit, x16 Clock
		db	3			; next Register WR3
		db	11000001b		; Rx enable, no Rx CRC, Rx 8Bits/Char
		db	5			; next Register WR5
		db	01101010b		; no Tx CRC, RTS, Tx enable, no Send Break, Tx 8 Bits/Char, DTR
		db    0				; Ende

;------------------------------------------------------------------------------
; DTR-Protokoll
; Aufruf: DTR p1 p2 ...
;------------------------------------------------------------------------------

cmd_dtr:	call	sub_0_D642		; C = Treiber-Index
		ret	c			; bei Fehler
		push	de			; DE = p2 p1
		push	bc
		call	sub_0_D8C7
		pop	hl			; L = Treiber-Index
		pop	de
		ret	c			; bei Fehler
		push	de
		ld	de, up_dtr
		jr	cmd_xonxoff1

;------------------------------------------------------------------------------
; XON/XOFF-Protokoll
; Aufruf: XON/XOFF p1 p2 ...
;------------------------------------------------------------------------------

cmd_xonxoff:	call	sub_0_D642
		ret	c			; bei Fehler
		push	de
		push	bc
		call	sub_0_D94E
		pop	hl
		pop	de
		ret	c			; bei Fehler
		push	de
		ld	de, up_xonxoff
;
cmd_xonxoff1:	ld	a, l			; L = Treiber-Index
		add	a, 70h
		ld	c, a			; C = UP-Nr
		ld	a, (sys_bank)		; A = Bank
		rst	20h			; DE = UP-Adr.
		db 0FFh				; EXTUP,  Einbindung eines weiteren Unterprogrammes in das System UP
		pop	de
		ret	c			; bei Fehler

		ld	a, e
		cp	3			; log. Gert LIST?
		jr	nz, cmd_xonxoff2
		push	de
		ld	e, l
		ld	d, 0
		ld	hl, para_ATTYC		; Beginn Adretabelle fr Gertetreiber
		add	hl, de
		add	hl, de
		ld	de, 0030h		; Adr. RST 30
		ld	(hl), e
		inc	hl
		ld	(hl), d
		pop	de
cmd_xonxoff2:	ld	hl, IOBYT		; IO-Byte
		ld	a, i
		cp	2
		jr	z, cmd_xonxoff3
		dec	hl
cmd_xonxoff3:	sla	e
		ld	b, e
		ld	a, (hl)
		ld	c, 1
		jr	z, cmd_xonxoff5
		ld	c, 9
cmd_xonxoff4:	rrca
		dec	c
		djnz	cmd_xonxoff4
cmd_xonxoff5:	and	0FCh
		or	d
cmd_xonxoff6:	dec	c
		jr	z, cmd_xonxoff7
		rrca
		jr	cmd_xonxoff6
cmd_xonxoff7:	ld	(hl), a
		or	a
		ret


;------------------------------------------------------------------------------
; Parameterkonvertierung fr Treiberprogramm-Initialisierung
; Kdo-Parameter: p1 0-3 log. Gert p2 0-3 zugehriger Kanal
; return: C = Treiber-Index, HL = 0280H..02BCH (Adr. RAM-Speicher fr Gertetreiber, DE = P2, P1
;------------------------------------------------------------------------------

sub_0_D642:	rst	20h
		db 1Ah				; PARB2, 2 Byte hex. aus Kommandozeile holen, 1.Byte in L, 2.Byte in H u. E
		ret	c			; bei Fehler
		ex	de, hl			; D = P2, E = P1
		ld	a, e
		cp	4
		jr	nc, loc_0_D65E		; Gertenummer >= 4
		ld	a, d
		cp	4
		jr	nc, loc_0_D65E		; Gertenummer >= 4
		ld	a, e
		add	a, a
		add	a, a			; A = 4 * P1 + P2
		or	d
		ld	c, a			; C=Index fr log. Gert - Kanal
;		
		add	a, a
		add	a, a
		add	a, 80h			; A = A*4+80h
		ld	l, a
		ld	a, i			; I = 2
		ld	h, a			; HL = 02xxh, Adresse RAM-Speicher fr Treiber
		ret
;		
loc_0_D65E:	ld	b, a			; B = log. Gert
		ld	a, 3			; Fehler 3 "Parameter ausserhalb zul. Grenzen"
		scf
		ret

;------------------------------------------------------------------------------
; UP 7x - Gertetreiber DTR
;------------------------------------------------------------------------------

up_dtr:		push	af
		ld	a, i
		ld	h, a
		ld	a, b
		and	0Fh
		add	a, a
		add	a, a
		add	a, 80h
		ld	l, a
		pop	af
		inc	a
		jp	z, sub_0_D8C7
		dec	a
		jr	nz, loc_0_D67F
		call	sub_0_D6D8
		ret	nc
		or	a
		ret	z
		scf
		ret
loc_0_D67F:	dec	a
		jr	nz, loc_0_D68B
		call	sub_0_D6D8
		ret	c			; bei Fehler
		ld	a, (hl)
		dec	hl
		res	7, (hl)
		ret
loc_0_D68B:	dec	a
		jp	z, loc_0_D78D
		sub	0Fh
		jp	z, loc_0_D77B
		dec	a
		dec	a
		jp	z, loc_0_D77B
		or	a
		ret
		
;------------------------------------------------------------------------------
; UP 7x - Gertetreiber XONXOFF
;------------------------------------------------------------------------------
		
up_xonxoff:	push	af
		ld	a, i
		ld	h, a
		ld	a, b
		add	a, a
		add	a, a
		add	a, 80h
		ld	l, a
		pop	af
		inc	a
		jp	z, sub_0_D94E
		dec	a
		jr	nz, loc_0_D6B5
		call	sub_0_D717
		ret	nc
		or	a
		ret	z
		scf
		ret
loc_0_D6B5:	dec	a
		jr	nz, loc_0_D6C1
		call	sub_0_D717
		ret	c			; bei Fehler
		ld	a, (hl)
		dec	hl
		res	7, (hl)
		ret
loc_0_D6C1:	dec	a
		jp	z, loc_0_D7C6
		sub	0Fh
		jp	z, loc_0_D77B
		dec	a
		jp	z, loc_0_D7DB
		dec	a
		jp	z, loc_0_D77B
		dec	a
		jp	z, loc_0_D827
		or	a
		ret
sub_0_D6D8:	inc	hl
		ld	c, (hl)
		inc	hl
		bit	7, (hl)
		jr	nz, loc_0_D71E
		call	sub_0_D867
loc_0_D6E2:	call	sub_0_D856
		jr	c, sub_0_D6F8
		in	a, (c)
		bit	0, a
		jr	nz, loc_0_D712
		call	sub_0_D874
		jr	nc, loc_0_D707
		rst	20h
		db 18h				; STENT, Tastatureingabe STOP, ENTER auswerten
		ret	c			; bei Fehler
		jr	nz, loc_0_D6E2
		scf
sub_0_D6F8:	push	af
		ld	a, 5
		out	(c), a
		ld	a, (hl)
		res	7, a
		out	(c), a
		call	sub_0_D86D
		pop	af
		ret
loc_0_D707:	ld	a, 5
		out	(c), a
		ld	a, (hl)
		set	7, a
		out	(c), a
		jr	loc_0_D6E2
loc_0_D712:	call	sub_0_D6F8
		jr	loc_0_D766
sub_0_D717:	inc	hl
		ld	c, (hl)
		inc	hl
		bit	7, (hl)
		jr	z, loc_0_D722
loc_0_D71E:	inc	hl
		ld	a, (hl)
		jr	loc_0_D777
loc_0_D722:	call	sub_0_D867
loc_0_D725:	call	sub_0_D856
		jr	c, sub_0_D73B
		in	a, (c)
		bit	0, a
		jr	nz, loc_0_D762
		call	sub_0_D874
		jr	nc, loc_0_D754
		rst	20h
		db 18h				; STENT, Tastatureingabe STOP, ENTER auswerten
		ret	c			; bei Fehler
		jr	nz, loc_0_D725
		scf
sub_0_D73B:	call	sub_0_D86D
		bit	0, (hl)
		ret	z
		res	0, (hl)
		ld	b, 13h
sub_0_D745:	push	af
		dec	hl
		dec	hl
		call	sub_0_D7A7
		inc	hl
		ld	c, (hl)
		inc	hl
		jr	c, loc_0_D752
		pop	af
		ret
loc_0_D752:	pop	bc
		ret
loc_0_D754:	bit	0, (hl)
		jr	nz, loc_0_D725
		set	0, (hl)
		ld	b, 11h
		call	sub_0_D745
		ret	c			; bei Fehler
		jr	loc_0_D725
loc_0_D762:	call	sub_0_D73B
		ret	c			; bei Fehler
loc_0_D766:	dec	hl
		dec	hl
		call	sub_0_D883
		ret	c			; bei Fehler
		ld	c, (hl)
		inc	hl
		inc	hl
		set	7, (hl)
		inc	hl
		jr	nz, loc_0_D776
		in	a, (c)
loc_0_D776:	ld	(hl), a
loc_0_D777:	or	a
		ret	nz
		dec	a
		ret
loc_0_D77B:	ld	b, 6
		ld	c, (hl)
loc_0_D77E:	in	a, (c)
		djnz	loc_0_D77E
		inc	hl
		ld	c, (hl)
		ld	a, 30h
		out	(c), a
		inc	hl
		res	7, (hl)
		or	a
		ret
loc_0_D78D:	ld	b, c
		inc	hl
		ld	c, (hl)
		dec	hl
		call	sub_0_D867
loc_0_D794:	call	sub_0_D856
		ret	c			; bei Fehler
		ld	a, 10h
		out	(c), a
		in	a, (c)
		bit	5, a
		jr	z, loc_0_D794
loc_0_D7A2:	push	hl
		ld	hl, sub_0_D86D
		ex	(sp), hl
sub_0_D7A7:	push	de
		ld	de, 0FFFFh
loc_0_D7AB:	in	a, (c)
		bit	2, a
		jr	nz, loc_0_D7BE
		dec	de
		ld	a, e
		or	d
		jr	nz, loc_0_D7AB
		ld	de, aTxcError		; "\r\nTxC-ERROR"
		rst	20h
		db 0Ah
		pop	de
		scf
		ret
loc_0_D7BE:	pop	de
		push	bc
		ld	c, (hl)
		out	(c), b
		pop	bc
		or	a
		ret
loc_0_D7C6:	ld	b, c
		inc	hl
		ld	c, (hl)
		dec	hl
		call	sub_0_D867
loc_0_D7CD:	call	sub_0_D856
		ret	c			; bei Fehler
		call	sub_0_D829
		jp	c, sub_0_D86D
		jr	z, loc_0_D7CD
		jr	loc_0_D7A2
loc_0_D7DB:	ld	b, (hl)
		inc	hl
		ld	c, (hl)
		inc	hl
		ld	de, aWaitingForXonE 	; "\r\nWAITING FOR XON\r\nENTER:XON     STOP:B"...
loc_0_D7E2:	in	a, (c)
		bit	0, a
		jr	z, loc_0_D807
		ld	a, 1
		out	(c), a
		in	a, (c)
		and	70h
		jr	nz, loc_0_D810
		push	bc
		ld	c, b
		in	a, (c)
		pop	bc
		cp	11h
		jr	z, loc_0_D803
		cp	13h
		jr	nz, loc_0_D7E2
		res	0, (hl)
		jr	loc_0_D7E2
loc_0_D803:	set	0, (hl)
		jr	loc_0_D7E2
loc_0_D807:	push	bc
		ld	c, b
		ld	b, 6
loc_0_D80B:	in	a, (c)
		djnz	loc_0_D80B
		pop	bc
loc_0_D810:	ld	a, 30h
		out	(c), a
		or	a
		bit	0, (hl)
		ret	nz
		rst	20h
		db 0Ah
		ret	c			; bei Fehler
		rst	20h
		db 13h				; PAUSE, Tastatureingabe PAUSE, CONT, STOP auswerten
		ret	c			; bei Fehler
		scf
		ret	z
		cp	0Dh
		jr	nz, loc_0_D7E2
		set	0, (hl)
		ret
loc_0_D827:	or	a
		ret
sub_0_D829:	in	a, (c)
		bit	0, a
		jr	z, loc_0_D84E
		push	bc
		call	sub_0_D883
		pop	bc
		ret	c			; bei Fehler
		jr	nz, loc_0_D83C
		push	bc
		ld	c, (hl)
		in	a, (c)
		pop	bc
loc_0_D83C:	inc	hl
		inc	hl
		cp	11h
		jr	z, loc_0_D84A
		cp	13h
		jr	nz, loc_0_D850
		res	0, (hl)
		jr	loc_0_D850
loc_0_D84A:	set	0, (hl)
		jr	loc_0_D850
loc_0_D84E:	inc	hl
		inc	hl
loc_0_D850:	or	a
		bit	0, (hl)
		dec	hl
		dec	hl
		ret
sub_0_D856:	in	a, (88h)
		or	a
		bit	6, a
		ret	nz
		push	de
		ld	de, aBreakByGraphic 	; "\r\nBREAK BY GRAPHIC-KEY "
loc_0_D860:	rst	20h
		db 0Ah
		pop	de
		ret	c			; bei Fehler
		xor	a
		scf
		ret
sub_0_D867:	in	a, (88h)
		set	6, a
		jr	loc_0_D871
sub_0_D86D:	in	a, (88h)
		res	6, a
loc_0_D871:	out	(88h), a
		ret
sub_0_D874:	in	a, (c)
		and	80h
		ld	a, 10h
		out	(c), a
		ret	z
		push	de
		ld	de, aRxdBreak		; "\r\nRxD-BREAK "
		jr	loc_0_D860
sub_0_D883:	push	de
		call	sub_0_D892
		pop	de
		ret	c			; bei Fehler
		ret	z
		rst	20h
		db 18h				; STENT, Tastatureingabe STOP, ENTER auswerten
		ret	c			; bei Fehler
		scf
		ret	z
		ccf
		ld	a, b
		ret
sub_0_D892:	ld	a, 1
		out	(c), a
		in	a, (c)
		and	70h
		ret	z
		ld	b, a
		bit	4, b
		jr	z, loc_0_D8A6
		ld	de, aParity		; "PARITY "
		rst	20h
		db 0Ah
		ret	c			; bei Fehler
loc_0_D8A6:	bit	5, b
		jr	z, loc_0_D8B0
		ld	de, aOverflow		; "OVERFLOW "
		db 0E7h
		ld	a, (bc)
		ret	c			; bei Fehler
loc_0_D8B0:	bit	6, b
		jr	z, loc_0_D8BA
		ld	de, aFrame		; "FRAME "
		rst	20h
		db 0Ah
		ret	c			; bei Fehler
loc_0_D8BA:	push	bc
		ld	c, (hl)
		in	a, (c)
		pop	bc
		ld	b, a
		ld	a, 30h
		out	(c), a
		or	a
		ld	a, b
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_0_D8C7:	ld	de, aCtcAdresse		; "CTC-Adresse       "
		ld	c, port_ctc0
		call	sub_0_D95A
		ret	c			; bei Fehler
		ld	b, c
		ld	de, aZeitkonstante 	; "Zeitkonstante     "
		ld	c, 1
		call	sub_0_D95A
		ret	c			; bei Fehler
		ld	a, b
		ld	b, c
		ld	c, a
		ld	a, 7
		out	(c), a
		out	(c), b
		ld	de, aSioAdresseDate 	; "SIO-Adresse Daten "
		ld	c, PORT_SIODA
		call	sub_0_D95A
		ret	c			; bei Fehler
		ld	(hl), c
		inc	c
		inc	c
		inc	hl
		ld	(hl), c
		ld	de, aParity0No1Odd2 	; "PARITY 0:NO/1:ODD/2:EVEN "
		ld	c, 0
		call	sub_0_D95A
		ret	c			; bei Fehler
loc_0_D8FA:	ld	a, c
		cp	3
		jr	c, loc_0_D909
		ld	de, aParity0No1Odd2 	; "PARITY 0:NO/1:ODD/2:EVEN "
		ld	c, 0
		rst	20h
		db 17h				; INPDA, Eingabe 1 Byte mit Aufforderungstext und Anzeige des vorgegebenen Wertes
		ret	c			; bei Fehler
		jr	loc_0_D8FA
loc_0_D909:	cp	2
		jr	nz, loc_0_D90E
		inc	a
loc_0_D90E:	or	44h
		ld	b, a
		ld	de, aBitZeichen		; "BIT/ZEICHEN       "
		ld	c, 8
		call	sub_0_D95A
		ret	c			; bei Fehler
		jr	loc_0_D924
loc_0_D91C:	ld	de, aBitZeichen		; "BIT/ZEICHEN       "
		ld	c, 8
		rst	20h
		db 17h				; INPDA, Eingabe 1 Byte mit Aufforderungstext und Anzeige des vorgegebenen Wertes
		ret	c			; bei Fehler
loc_0_D924:	ld	a, c
		ld	d, 41h
		ld	e, 2Ah
		sub	7
		jr	z, loc_0_D934
		dec	a
		jr	nz, loc_0_D91C
		set	7, d
		set	6, e
loc_0_D934:	ld	c, (hl)
		inc	hl
		ld	(hl), e
		ld	a, 18h
		out	(c), a
		ld	a, 4
		out	(c), a
		out	(c), b
		ld	b, 3
		out	(c), b
		out	(c), d
		ld	b, 5
		out	(c), b
		out	(c), e
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

sub_0_D94E:	call	sub_0_D8C7
		out	(c), b
		set	7, e
		out	(c), e
		ld	(hl), 0
		ret


sub_0_D95A:	ld	a, (fcb1+1)
		cp	20h
		db 28h
		ld	b, 0D5h
		rst	20h
		db 19h				; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ld	c, e
		pop	de
		ret
		rst	20h
		db 17h				; INPDA, Eingabe 1 Byte mit Aufforderungstext und Anzeige des vorgegebenen Wertes
		ret



aCtcAdresse:	db "CTC-Adresse       "
		db 0
aZeitkonstante:	db "Zeitkonstante     "
		db 0
aSioAdresseDate:db "SIO-Adresse Daten "
		db 0
aParity0No1Odd2:db "PARITY 0:NO/1:ODD/2:EVEN "
		db 0
aBitZeichen:	db "BIT/ZEICHEN       "
		db 0
aTxcError:	db 0Dh
		db 0Ah
		db "TxC-ERROR"
		db 0
aBreakByGraphic:db 0Dh
		db 0Ah
		db "BREAK BY GRAPHIC-KEY "
		db 0
aRxdBreak:	db 0Dh
		db 0Ah
		db "RxD-BREAK "
		db 0
aParity:	db "PARITY "
		db 0
aOverflow:	db "OVERFLOW "
		db 0
aFrame:		db "FRAME "
		db 0
aWaitingForXonE:db 0Dh
		db 0Ah
		db "WAITING FOR XON"
		db 0Dh
		db 0Ah
		db "ENTER:XON     STOP:BREAK"
		db 0Dh
		db 0Ah
		db 0

