;------------------------------------------------------------------------------
; TAPE - Kassetteninterface (d700)
;------------------------------------------------------------------------------

;		org	0D700h

		jp	cmd_i_tape
aTape:		db	"$TAPE   "
		db	0
		jp	cmd_reads
aReads:		db	"READS   "
		db	0
		jp	cmd_verify
aVerify:	db	"VERIFY  "
		db	0
		jp	cmd_fcb
aFcb:		db	"FCB     "
		db	0
		jp	cmd_csave
aCsave:		db	"CSAVE   "
		db	0
		jp	cmd_cload
aCload:		db	"CLOAD   "
		db	0
		db	0

;------------------------------------------------------------------------------
; TAPE initialisieren (Kaltstartinitialisierung durch BO)
; Eintragen der BD-Kommandos in die BD-BDOS-Tabelle
;------------------------------------------------------------------------------

cmd_i_tape:	ld	hl, cmd_i_tape_bdlist
		ld	d, 10			; Anzahl der Kommandos
		ld	c, 0FFh			; Funktion neuer Tabelleneintrag
cmd_i_tape1:	push	de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)			; DE = Adresse
		inc	hl
		ld	b, (hl)			; B = BDOS-Nr.
		inc	hl
		push	hl
		rst	8			; CALL BDOS
		pop	hl
		pop	de
		ret	c			; bei Fehler
		dec	d
		jr	nz, cmd_i_tape1
		ret

cmd_i_tape_bdlist:dw	bd_openw
		db	80h
		dw	bd_write
		db	81h
		dw	bd_closw
		db	82h
		dw	bd_openr
		db	84h
		dw	bd_read
		db	85h
		dw	bd_closr
		db	86h
		dw	bd_rrand
		db	87h
		dw	bd_karam
		db	88h
		dw	bd_marek
		db	89h
		dw	bd_load1
		db	8Ch

;------------------------------------------------------------------------------
; LOAD1: wird vom CCP zum Laden von Programmen aufgerufen.
; LOAD1 darf im CP/M-Modus nicht genutzt werden.
;------------------------------------------------------------------------------

bd_load1:	call	sub_bank_xe		; Bank xE selektieren
		ld	ix, fcb1
		ld	hl, tape_dma
		ld	c, 0FFh
		ld	a, (ix+9)		; Typ eingetragen?
		cp	' '
		jr	nz, bd_load11		; ja
		ld	(ix+9),	'C'		; sonst 'COM' setzen
		ld	(ix+0Ah), 'O'
		ld	(ix+0Bh), 'M'
bd_load11:	call	bd_openr
		jr	nc, bd_load12
		call	sub_0_D7DF
		ret	c			; bei Fehler
		jr	nz, bd_load11
bd_load12:	ld	e, (ix+12h)		; AADR
		ld	d, (ix+13h)
bd_load13:	call	bd_read
		jr	nc, bd_load14
		call	sub_0_D7DF
		ret	c			; bei Fehler
		jr	nz, bd_load13
bd_load14:	ld	b, a
		push	bc
		ld	a, (sys_bank)
		ld	b, a
		push	hl
		push	ix
		ld	ix, 80h
		rst	20h
		db	44h			; LDIRU, Blocktransport zwischen Bnken von (HL) (B) nach (DE) (C), Lnge = IX
		pop	ix
		pop	hl
		jr	c, bd_load15
		pop	bc
		inc	b
		jr	nz, bd_load13
		call	bd_closr
		ret	c			; bei Fehler
		ld	l, (ix+16h)		; SADR
		ld	h, (ix+17h)
		ret
bd_load15:	inc	sp
		inc	sp
		ret
;
sub_0_D7DF:	cp	0Bh
		ret	c			; bei Fehler
		cp	0Fh
		ccf
		ret	c			; bei Fehler
		sub	0Bh
		add	a, a
		push	hl
		push	de
		ld	l, a
		ld	h, 0
		ld	de, off_0_D822
		add	hl, de
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		pop	de
		pop	hl
		ret	c			; bei Fehler
loc_0_D7FA:	rst	20h
		db	30h			; CONSI, Eingabe von Console (Tastatur)
		ret	c			; bei Fehler
		cp	3
		jr	nz, loc_0_D804
		xor	a
		scf
		ret
loc_0_D804:	and	0DFh
		cp	'I'
		jr	nz, loc_0_D815
		inc	(ix+0Fh)		; LBLNR
		rst	20h
		db	0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret	c			; bei Fehler
		rst	20h
		db	5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c			; bei Fehler
		xor	a
		ret
loc_0_D815:	cp	'R'
		jr	nz, loc_0_D7FA
		rst	20h
		db	0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret	c			; bei Fehler
		rst	20h
		db	5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c			; bei Fehler
		xor	a
		dec	a
		ret

off_0_D822:	dw	aRecordNotFou_0		; "record not found (R,I,^C):"
		dw	aBadRecordRIC		; "bad record (R,I,^C):"
		dw	aFileNotFoundRI		; "file not found (R,I,^C):"
		dw	aChecksumErrorR		; "checksum error (R,I,^C):"
aRecordNotFou_0:db	"record not found (R,I,^C):"
		db	0
aBadRecordRIC:	db	"bad record (R,I,^C):"
		db	0
aFileNotFoundRI:db	"file not found (R,I,^C):"
		db	0
aChecksumErrorR:db	"checksum error (R,I,^C):"
		db	0

;------------------------------------------------------------------------------
; Anzeige des File-Control-Blocks
; Aufruf: FCB
;------------------------------------------------------------------------------

cmd_fcb:	call	sub_bank_xe		; Bank xE selektieren
		ld	de, aName		; "\r\nNAME:"
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		ld	hl, tape_fcb + 1	; Dateiname anzeigen
		ld	b, 8
		rst	20h		
		db	9h			; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		ret	c			; bei Fehler
		inc	de
		rst	20h			; Ausgabe "TYP :"
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		ld	b, 3
		rst	20h			; Ausgabe Dateityp
		db	9h			; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		ret	c			; bei Fehler
		inc	de
		rst	20h			; Ausgabe "AADR:"
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		ld	hl, (tape_fcb + 12h)
		rst	20h
		db	7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		inc	de
		rst	20h			; Ausgabe "EADR:"
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		ld	hl, (tape_fcb + 14h)
		rst	20h
		db	7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		inc	de
		rst	20h			; Ausgabe "SADR:"
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		ld	hl, (tape_fcb + 16h)
		rst	20h
		db	7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		inc	de
		rst	20h			; Ausgabe "SBY :"
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		ld	a, (tape_fcb + 18h)
		rst	20h
		db	6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db	5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret

aName:		db	0Dh
		db	0Ah
		db	"NAME:"
		db	0
aTyp:		db	0Dh
		db	0Ah
		db	"TYP :"
		db	0
aAadr:		db	0Dh
		db	0Ah
		db	"AADR:"
		db	0
aEadr:		db	0Dh
		db	0Ah
		db	"EADR:"
		db	0
aSadr:		db	0Dh
		db	0Ah
		db	"SADR:"
		db	0
aSby:		db	0Dh
		db	0Ah
		db	"SBY :"
		db	0

;------------------------------------------------------------------------------
; Lesen eines 128 Byte langen Blocks von Kassette und Anzeigen auf dem Bildschirm
; Aufruf: READS nr
;------------------------------------------------------------------------------

cmd_reads:	call	sub_bank_xe		; Bank xE selektieren
		rst	20h
		db	19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c			; bei Fehler
		push	de
		ld	de, aKassetteStarte 	; "Kassette starten -> Abbruch mit GRAPHIC"...
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		pop	de
		ret	c			; bei Fehler
cmd_reads1:	ld	hl, tape_dma
		call	bd_marek		; Block E einlesen
		ret	c			; bei Fehler
		cp	0FFh
		jr	z, cmd_reads2		; bei Ende-Block
		cp	e
		jr	c, cmd_reads1		; Block noch nicht erreicbt
		jr	z, cmd_reads2		; Block gefunden
		ld	d, a			; 
		ld	a, e
		rst	20h			; 
		db	6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db	2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		ld	a, d
		rst	20h
		db	6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		ld	de, aFoundRewind 	; " found: Rewind!\r\n"
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		jr	cmd_reads1
cmd_reads2:	rst	20h
		db	6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		ld	hl, tape_dma
		ld	de, tape_dma +7Fh
		rst	20h
		db	0Bh			; DISPO, Anzeige eines Speicherbereiches hexadezimal und ASCII von (HL) bis (DE)
		ret

aFoundRewind:	db	" found: Rewind!"
		db	0Dh
		db	0Ah
		db	0

;------------------------------------------------------------------------------
; Ausgabe "Kassette starten"
;------------------------------------------------------------------------------

sub_0_D951:	push	de
		ld	de, aKassetteStarte 	; "Kassette starten -> Abbruch mit GRAPHIC"...
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		pop	de
		ret

aKassetteStarte:db	"Kassette starten -> Abbruch mit GRAPHIC"
		db	0Dh
		db	0Ah
		db	0

;------------------------------------------------------------------------------
; Kontrolle der Kassettenaufzeichnung
; Aufruf: VERIFY
;------------------------------------------------------------------------------

asc_0_D983:	db	7
		db	"** "
		db	0

cmd_verify:	call	sub_bank_xe		; Bank xE selektieren
		ld	de, aKassetteStarte 	; "Kassette starten -> Abbruch mit GRAPHIC"...
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		ld	a, 0FFh
		ld	(tape_fcb + 0Eh), a	; BLNR
		ld	a, 1
		ld	(tape_fcb + 10h), a
cmd_verify1:	ld	hl, tape_dma
		call	bd_marek
		jr	nc, cmd_verify2
		or	a
		scf
		ret	z
		ld	de, asc_0_D983		; "\a** "
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		jp	cmd_verify17
cmd_verify2:	ld	(tape_fcb + 0Fh), a	; LBLNR
		or	a
		jr	z, cmd_verify3
		cp	1
		jp	nz, cmd_verify11
		ld	a, (tape_fcb + 10h)
		or	a
		jr	nz, cmd_verify5
		jp	cmd_verify14
cmd_verify3:	rst	20h
		db	5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c			; bei Fehler
		ld	a, 0FFh
		ld	(tape_fcb + 0dh), a	; ARB
		ld	hl, tape_dma
		ld	b, 8
		rst	20h
		db	9h			; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		ret	c			; bei Fehler
		rst	20h
		db	2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		ld	b, 3
		rst	20h
		db	9h			; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		ret	c			; bei Fehler
		rst	20h
		db	2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		ld	hl, tape_dma+11h
		ld	b, 3
cmd_verify4:	ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ex	de, hl
		rst	20h
		db	7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ex	de, hl
		ret	c			; bei Fehler
		rst	20h
		db	2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		djnz	cmd_verify4
		ld	a, (hl)
		or	a
		jp	z, cmd_verify10
		ld	de, aProtected		; "protected"
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		jr	cmd_verify10
cmd_verify5:	rst	20h
		db	5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c			; bei Fehler
		ld	hl, tape_dma+03h
		ld	b, 8
		rst	20h
		db	9h			; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		ret	c			; bei Fehler
		rst	20h
		db	2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		ld	hl, tape_dma
		ld	b, 3
		rst	20h
		db	9h			; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		ret	c			; bei Fehler
		rst	20h
		db	2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		ld	hl, (tape_dma+0Bh)
		rst	20h
		db	7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		ld	de, 2020h		; 2 Leerzeichen
		rst	20h
		db	4h			; PRNDE, Ausgabe von 2 Zeichen. aus D und E
		ret	c			; bei Fehler
		ld	a, (tape_dma)
		sub	0D3h
		ld	c, a
		jr	z, cmd_verify6
		cp	4
		jr	z, cmd_verify6
		dec	a
		ld	hl, aCsave_0		; "CSAVE*"
		jr	z, cmd_verify8
		cp	4
		jr	z, cmd_verify8
		dec	a
		ld	hl, aList1		; "LIST#1"
		jr	z, cmd_verify8
		cp	4
		jr	z, cmd_verify8
		jr	cmd_verify10
cmd_verify6:	ld	hl, (tape_dma+0Bh)
		ld	de, 0Ch
		add	hl, de
		ld	b, 7
cmd_verify7:	rr	h
		rr	l
		djnz	cmd_verify7
		inc	l
		ld	a, l
		ld	hl, aCsave_1		; "CSAVE "
		jr	cmd_verify9
cmd_verify8:	ld	a, 0FFh
cmd_verify9:	ld	(tape_fcb+0Dh), a	; ARB
		ld	b, 6
		rst	20h
		db	9h			; PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
		ret	c			; bei Fehler
		ld	a, c
		cp	4
		jr	c, cmd_verify10
		ld	de, asc_0_DB00		; "   "
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
cmd_verify10:	rst	20h
		db	5h			; PCRLF, Ausgabe Zeilenschaltung (ODH, OAH)
		ret	c			; bei Fehler
		ld	a, 0FFh
		ld	(tape_fcb+0Eh), a	; BLNR
		jr	cmd_verify14
cmd_verify11:	ld	hl, tape_fcb+0Dh	; ARB
		cp	(hl)
		jr	nz, cmd_verify13
		call	cmd_verify19
		ret	c			; bei Fehler
		ld	a, (tape_fcb+0Eh)	; BLNR
		cp	0FFh
		ld	de, aFileComplete 	; "FILE COMPLETE\r\n"
		jr	z, cmd_verify12
		ld	de, aFileBad		; "FILE BAD\r\n"
cmd_verify12:	rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret	c			; bei Fehler
		jr	cmd_verify15
cmd_verify13:	ld	hl, tape_fcb+0Fh	; LBLNR
		ld	a, (tape_fcb+10h)
		inc	a
		cp	(hl)
		jr	nc, cmd_verify14
		ld	a, (tape_fcb+0Fh)	; LBLNR
		rst	20h
		db	6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		ld	a, 3Ch
		rst	20h
		db	0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret	c			; bei Fehler
		jr	cmd_verify17
cmd_verify14:	call	cmd_verify19
		ret	c			; bei Fehler
		ld	hl, tape_fcb+0Fh	; LBLNR
		ld	a, (tape_fcb+0Eh)	; BLNR
		cp	(hl)
		jr	c, cmd_verify16
cmd_verify15:	ld	a, 0FFh
		ld	(tape_fcb+0Eh), a	; BLNR
cmd_verify16:	ld	a, (tape_fcb+0Fh)
		cp	0FFh
		jr	z, cmd_verify18
		ld	(tape_fcb+10h), a
		jr	cmd_verify18
cmd_verify17:	ld	a, (tape_fcb+0Eh)	; BLNR
		cp	0FFh
		jr	nz, cmd_verify18
		ld	a, (tape_fcb+10h)
		ld	(tape_fcb+0Eh), a	; BLNR
cmd_verify18:	jp	cmd_verify1
cmd_verify19:	ld	a, (tape_fcb+0Fh)	; LBLNR
		rst	20h
		db	6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		ld	a, (tape_fcb+0Eh)	; BLNR
		cp	0FFh
		ld	a, 20h
		jr	z, cmd_verify20
		ld	a, 5Ch
cmd_verify20:	rst	20h
		db	0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret

aCsave_1:	db	"CSAVE "
aCsave_0:	db	"CSAVE*"
aList1:		db	"LIST#1"
asc_0_DB00:	db	"   "
aProtected:	db	"protected"
		db	0
aFileComplete:	db	"FILE COMPLETE"
		db	0Dh
		db	0Ah
		db	0
aFileBad:	db	"FILE BAD"
		db	0Dh
		db	0Ah
		db	0

; Bank xE selektieren
sub_bank_xe:	ld	a, (sys_bank)
		and	0F0h
		or	0Eh
		ld	(sys_bank), a
		out	(0FFh),	a
		ret

;------------------------------------------------------------------------------
; 
; Aufruf: CSAVE name.typ aadr eadr bank sadr aadf eadf
;------------------------------------------------------------------------------

cmd_csave:	call	sub_bank_xe		; Bank xE selektieren
		ld	a, (fcb1+1)		; FNAME
		cp	20h
		ld	a, 1
		scf
		ret	z
		ld	hl, fcb1
		ld	de, tape_fcb
		ld	bc, 10h
		ldir
		rst	20h
		db	28h			; NPAR , 2 Parameter aus Kommandozeile ob 80H als Dateibezeichnung in FCB ab (5C)
		ret	c			; bei Fehler
		ld	ix, tape_fcb
		ld	a, (ix+9)		; FTYP
		cp	20h
		jr	nz, cmd_csave1
		ld	(ix+9),	'C'
		ld	(ix+0Ah), 'O'
		ld	(ix+0Bh), 'M'
cmd_csave1:	rst	20h
		db	1Eh			; PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
		ret	c			; bei Fehler
		ld	(ix+12h), l		; AADR
		ld	(ix+13h), h
		ld	(ix+14h), e		; EADR
		ld	(ix+15h), d
		ld	(ix+16h), 0FFh		; SADR
		ld	(ix+17h), 0FFh
		ld	(ix+0Ch), 0		; PSUM
		ld	(ix+18h), 0		; SBY
		ld	b, 0FFh
		push	hl
		push	de
		ld	a, (fcb1+1)		; FNAME
		cp	20h
		jr	z, cmd_csave2
		rst	20h
		db	19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		jr	c, cmd_csave2
		ld	b, e
		ld	a, (fcb1+1)		; FNAME
		cp	' '
		jr	z, cmd_csave2
		rst	20h
		db	1Dh			; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		jr	c, cmd_csave2
		ld	(ix+16h), e		; SADR
		ld	(ix+17h), d
		ld	a, (fcb1+1)
		cp	' '
		jr	z, cmd_csave2
		rst	20h
		db	1Dh			; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		jr	c, cmd_csave2
		ld	(ix+12h), e		; AADR
		ld	(ix+13h), d
		ld	a, (fcb1+1)
		cp	' '
		jr	z, cmd_csave2
		rst	20h
		db	1Dh			; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		jr	c, cmd_csave2
		ld	(ix+14h), e		; EADR
		ld	(ix+15h), d
cmd_csave2:	pop	de
		pop	hl
		ret	c			; bei Fehler
		call	bd_openw
		ret	c			; bei Fehler
cmd_csave3:	push	de
		push	ix
		ld	de, tape_dma
		ld	ix, 80h
		ld	a, (sys_bank)
		ld	c, a
		rst	20h
		db	44h			; LDIRU, Blocktransport zwischen Bnken von (HL) (B) nach (DE) (C), Lnge = IX
		pop	ix
		pop	de
		ret	c			; bei Fehler
		ex	de, hl
		push	hl
		sbc	hl, de
		ld	hl, tape_dma
cmd_csave4:	jr	c, cmd_csave5
		call	bd_write
		pop	hl
		ex	de, hl
		ret	c			; bei Fehler
		jr	cmd_csave3
cmd_csave5:	call	bd_closw
		pop	hl
		ret


;------------------------------------------------------------------------------
; 
; Aufruf: CLOAD name.typ aadr eadr bank ladr
;------------------------------------------------------------------------------

cmd_cload:	call	sub_bank_xe		; Bank xE selektieren
		ld	a, (fcb1+1)		; folgt Parameter?
		cp	' '
		ld	a, 1
		scf				; nein -> Fehler 1 "zu wenige Parameter eingegeben"
		ret	z
;
		ld	hl, fcb1		; FCB kopieren
		ld	de, tape_fcb
		ld	bc, 10h
		ldir
;
		rst	20h
		db	28h			; NPAR , 2 Parameter aus Kommandozeile ab 80H als Dateibezeichnung in FCB ab (5C)
		ret	c			; bei Fehler
;
		ld	ix, tape_fcb
		ld	a, (ix+9)
		cp	' '			; Dateityp angegeben?
		jr	nz, cmd_cload1
		ld	(ix+9),	'C'		; nein, sann "COM" verwenden
		ld	(ix+0Ah), 'O'
		ld	(ix+0Bh), 'M'
cmd_cload1:	ld	hl, tape_dma
cmd_cload2:	call	bd_openr		; Block 0 lesen nach (HL)
		jr	nc, cmd_cload3		; bei Fehler
		call	sub_0_D7DF
		ret	c			; bei Fehler
		jr	nz, cmd_cload2		; weitersuchen
;		
cmd_cload3:	ld	l, (ix+12h)		; AADR
		ld	h, (ix+13h)
		ld	(ix+14h), 0FFh		; EADR
		ld	(ix+15h), 0FFh
		ld	c, 0FFh
;
		ld	a, (fcb1+1)		; folgt weiterer Parameter?
		cp	' '
		jr	z, cmd_cload4
		rst	20h
		db	1Dh			; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		ret	c			; bei Fehler
		ld	(ix+12h), e		; AADR
		ld	(ix+13h), d
		ex	de, hl
		ld	a, (fcb1+1)		; folgt weiterer Parameter?
		cp	' '
		jr	z, cmd_cload4
		rst	20h
		db	1Dh			; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		ret	c			; bei Fehler
		ld	(ix+14h), e		; EADR
		ld	(ix+15h), d
		ld	a, (fcb1+1)
		cp	' '
		jr	z, cmd_cload4
		rst	20h
		db	19h			; PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
		ret	c			; bei Fehler
		ld	c, e
		ld	a, (fcb1+1)		; folgt weiterer Parameter?
		cp	' '
		jr	z, cmd_cload4
		rst	20h
		db	1Dh			; PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
		ret	c			; bei Fehler
		ex	de, hl
cmd_cload4:	ld	e, (ix+12h)		; AADR
		ld	d, (ix+13h)
		ld	(ix+12h), l
		ld	(ix+13h), h
		sbc	hl, de
		ld	e, l
		rl	l
		ld	l, h
		rl	l
		ld	a, 3
		ret	c			; bei Fehler
		inc	l
		scf
		ret	z
		ld	(ix+0Fh), l		; LBLNR
		ld	hl, tape_dma
cmd_cload5:	call	bd_read
		jr	nc, cmd_cload6
		call	sub_0_D7DF
		ret	c			; bei Fehler
		jr	nz, cmd_cload5
cmd_cload6:	push	af
		ld	a, e
		and	7Fh
		ld	e, a
		ld	d, 0
		ld	a, c
		ld	hl, 80h
		sbc	hl, de
		ld	c, l
		ld	b, h
		ld	hl, tape_dma
		add	hl, de
		push	hl
		ld	l, (ix+12h)		; AADR
		ld	h, (ix+13h)
		push	hl
		add	hl, bc
		dec	hl
		ex	de, hl
		ld	l, (ix+14h)		; EADR
		ld	h, (ix+15h)
		or	a
		sbc	hl, de
		jr	nc, cmd_cload7
		add	hl, bc
		ld	c, l
		ld	b, h
cmd_cload7:	pop	de
		pop	hl
		push	bc
		ex	(sp), ix
		ld	c, a
		ld	b, 0Eh
cmd_cload8:	rst	20h
		db	44h			; LDIRU, Blocktransport zwischen Bnken von (HL) (B) nach (DE) (C), Lnge = IX
		pop	ix
		pop	hl
		ret	c			; bei Fehler
		inc	h
		jr	z, cmd_cload12
		ld	l, (ix+14h)		; EADR
		ld	h, (ix+15h)
		or	a
		sbc	hl, de
		jr	c, cmd_cload12
cmd_cload9:	push	hl
		ld	hl, tape_dma
		call	bd_read
		pop	hl
		jr	nc, cmd_cload10
		call	sub_0_D7DF
		ret	c			; bei Fehler
		jr	nz, cmd_cload9
cmd_cload10:	push	af
		push	ix
		ld	ix, 80h
		push	bc
		ld	bc, 7Fh
		sbc	hl, bc
		jr	nc, cmd_cload11
		ld	c, l
		ld	b, h
		add	ix, bc
cmd_cload11:	pop	bc
		ld	hl, tape_dma
		jr	cmd_cload8
cmd_cload12:	call	bd_closr
		ret	c			; bei Fehler
		ld	l, (ix+12h)		; AADR
		ld	h, (ix+13h)
		rst	20h
		db	7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		ld	a, '-'
		rst	20h
		db	0h			; PRNA , Ausgabe Register A zum Bildschirm
		ret	c			; bei Fehler
		ex	de, hl
		dec	hl
		rst	20h
		db	7h			; PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
		ret	c			; bei Fehler
		rst	20h
		db	2h			; PRNSP, Ausgabe ein Leerzeichen
		ret	c			; bei Fehler
		ld	a, c
		rst	20h
		db	6h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
		ret	c			; bei Fehler
		ld	de, aGeladen		; " geladen"
		rst	20h
		db	8h			; PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
		ret

aGeladen:	db	" geladen"
		db	0

;------------------------------------------------------------------------------
; OPEN WRITE (Schreiben Block Nr. 0 mit Datename/typ)
;------------------------------------------------------------------------------

bd_openw:	call	sub_0_D951		; Ausgabe Startmeldung
		ret	c			; bei Fehler
		push	bc
		push	hl
		ld	(ix+0Fh), 0		; FCB: Blocknummer LBLNR
		push	ix
		pop	hl
		inc	hl
		ld	b, 11			; Lnge FCB
		ld	a, ' '
bd_openw1:	cp	(hl)
		jr	nz, bd_openw2
		ld	(hl), 0
bd_openw2:	inc	hl
		djnz	bd_openw1
		ld	bc, -11
		add	hl, bc			; HL zurcksetzen
		ld	bc, 1770h		; langer Vorton
		jr	bd_write2

;------------------------------------------------------------------------------
; Schreiben Datenblock
;------------------------------------------------------------------------------

bd_write:	push	bc
		push	hl
bd_write1:	ld	bc, 0A0h		; kurzer Vorton
bd_write2:	ld	a, (ix+0Fh)		; FCB: Blocknummer LBLNR
		call	bd_karam		; Ausgabe Block

;;vp080525	
		call	OBLNR

		inc	(ix+0Fh)		; FCB: Blocknummer LBLNR erhhen
		pop	hl
		pop	bc
		ret	c			; bei Fehler
		xor	a
		ret

;------------------------------------------------------------------------------
; CLOSE WRITE (Schreiben Endeblock Nr. FF)
;------------------------------------------------------------------------------

bd_closw:	push	bc
		push	hl
		ld	(ix+0Fh), 0FFh		; FCB: Blocknummer LBLNR
		jr	bd_write1

;------------------------------------------------------------------------------
; OPEN READ (Lesen Block 0 und Vergleichen Datename/typ)
;------------------------------------------------------------------------------

bd_openr:	call	sub_0_D951
		ret	c			; bei Fehler
		push	bc
		push	hl
		push	de
		ld	a, 0
		ld	(ix+0Fh), a		; FCB: Blocknummer LBLNR
		call	bd_rrand
		jr	c, bd_openr4
		inc	a
		ld	a, 0Bh
		scf
		jr	z, bd_openr4
		push	ix
		pop	de
		inc	de
		ex	de, hl
		ld	b, 0Bh
bd_openr1:	ld	a, (hl)
		cp	'?'
		jr	z, bd_openr3
		ld	a, (de)
		or	a
		jr	nz, bd_openr2
		ld	a, ' '
		ld	(de), a
bd_openr2:	res	7, a
		cp	(hl)
		ld	a, 0Dh
		scf
		jr	nz, bd_openr4
bd_openr3:	inc	hl
		inc	de
		djnz	bd_openr1
		ld	bc, 0FFF5h		; -10
		add	hl, bc
		ex	de, hl
		add	hl, bc
		ld	bc, 20h
		ldir
		inc	(ix+0Fh)		; FCB: Blocknummer LBLNR erhhen
		xor	a
bd_openr4:	pop	de
		pop	hl
		pop	bc
		ret

;------------------------------------------------------------------------------
; Lesen Datenblock
;------------------------------------------------------------------------------

bd_read:	ld	a, (ix+0Fh)		; FCB: Blocknummer LBLNR
		call	bd_rrand

;;vp080525	
		call	OBLNR

		ret	c			; bei Fehler
		inc	(ix+0Fh)		; FCB: Blocknummer LBLNR erhhen
		ret

;------------------------------------------------------------------------------
; CLOSE READ (Lesen Endeblock FF) 
; Dummy !!
;------------------------------------------------------------------------------

bd_closr:	or	a			; Cy = 0	
		ret

;------------------------------------------------------------------------------
; Block mit vorgegebener Blocknummer lesen
;------------------------------------------------------------------------------

bd_rrand:	push	bc
		ld	b, a
bd_rrand1:	push	hl
		call	bd_marek
		pop	hl
		jr	c, bd_rrand2
		cp	0FFh
		jr	z, bd_rrand2
		sub	b
		jr	c, bd_rrand1
		jr	z, bd_rrand2
		ld	a, 0Bh
		scf
bd_rrand2:	pop	bc
		ret

;------------------------------------------------------------------------------
; Block mit vorgegebener Blocknummer schreiben
;------------------------------------------------------------------------------

bd_karam:	push	bc
		push	de
		ld	d, a
		ld	a, (fcb1+0Eh)		; BLNR
		push	af
		push	de
		in	a, (DPIO1A)
		set	6, a
		out	(DPIO1A), a
		ex	de, hl
		ld	hl, unk_0_DF3B
		call	sub_0_DF2A
		ex	de, hl
		ld	d, 40h
		ld	e, d
loc_0_DE0C:	call	sub_0_DE70
		jr	c, loc_0_DE53
		dec	bc
		ld	a, c
		or	b
		jr	nz, loc_0_DE0C
		ld	e, 80h
		call	sub_0_DE70
		jr	c, loc_0_DE53
		pop	af
		call	sub_0_DE56
		jr	c, loc_0_DE39
		ld	c, 0
		ld	b, 80h
loc_0_DE27:	ld	a, (hl)
		call	sub_0_DE56
		jr	c, loc_0_DE39
		ld	a, c
		add	a, (hl)
		ld	c, a
		inc	hl
		djnz	loc_0_DE27
		call	sub_0_DE56
		call	nc, sub_0_DE79
loc_0_DE39:	ld	a, 0
;
loc_0_DE3B:	pop	bc
		push	af
		ex	de, hl
		ld	hl, unk_0_DF6B
		call	sub_0_DF2A
		ex	de, hl
		in	a, (DPIO1A)
		res	6, a
		out	(DPIO1A), a
		ld	a, b
		ld	(fcb1+0Eh), a		; LBLNR
		pop	af
		pop	de
		pop	bc
		ret
;
loc_0_DE53:	pop	de
		jr	loc_0_DE39
sub_0_DE56:	push	bc
		ld	c, a
		ld	b, 8
loc_0_DE5A:	rrc	c
		ld	e, 40h
		jr	c, loc_0_DE62
		ld	e, 20h
loc_0_DE62:	call	sub_0_DE70
		jr	c, loc_0_DE6E
		djnz	loc_0_DE5A
		ld	e, 80h
		call	sub_0_DE70
loc_0_DE6E:	pop	bc
		ret


sub_0_DE70:	call	sub_0_DE79
		ret	c			; bei Fehler
		ld	d, e
		call	sub_0_DE79
		ret


sub_0_DE79:	ld	a, d
		ld	(fcb1+0Eh), a		; LBLNR
loc_0_DE7D:	in	a, (DPIOB)
		cp	7Fh
		scf
		ret	z
		ld	a, (fcb1+0Eh)		; LBLNR
		or	a
		jr	nz, loc_0_DE7D
		ret

;------------------------------------------------------------------------------
; Lesen des ersten gefundenen Blocks (Blocknummer ermitteln)
;------------------------------------------------------------------------------

bd_marek:	push	bc
		push	de
		ld	a, (fcb1+0Eh)		; LBLNR
		push	af
		in	a, (DPIO1A)
		set	6, a
		out	(DPIO1A), a
		ex	de, hl
		ld	hl, unk_0_DF51
		call	sub_0_DF2A
		ex	de, hl
bd_marek1:	ld	b, 22			; 22 Vortne suchen
bd_marek2:	call	lstop
		jr	c, bd_marek1		; 0-Bit gelesen
		jr	z, bd_marek6		; bei Abbruch
		cp	90h
		jr	c, bd_marek1		; 1-Bit gelesen
		djnz	bd_marek2
		ld	b, 2			; 1 Trennzeichen
bd_marek3:	call	ls1			; eine Halbperiode messen
		jr	z, bd_marek6		; bei Abbruch
		cp	52h
		jr	nc, bd_marek3		; kein Trennzeichen
		djnz	bd_marek3
		call	ibyte			; Blocknummer lesen
		jr	c, bd_marek5		; Fehler
		ld	e, a
		ld	c, 0			; C = Prfsumme
		ld	b, 80h			; Anzahl Bytes
bd_marek4:	call	ibyte			; Datenbyte lesen
		jr	c, bd_marek5		; Fehler
		ld	(hl), a
		ld	a, c
		add	a, (hl)
		ld	c, a			; neue Prfsumme
		inc	hl
		djnz	bd_marek4
		call	ibyte			; Prfsumme lesen
		jr	c, bd_marek5		; Fehler
		cp	c			; Vergleichen mit berechneter Summe
		ld	a, 0Eh			; CCP-Fehler "TAPE: Pruefsummenfehler"
		scf
		jr	nz, bd_marek5		; bei Ungleichheit
		ccf
		ld	a, e
bd_marek5:	jp	loc_0_DE3B
bd_marek6:	xor	a
		scf
		jr	bd_marek5

; Lesen eines Bytes

ibyte:		push	bc
		ld	c, 0
		ld	b, 8
ibyte1:		call	lstop			; Lesen ein Zeichen
		ccf
		jr	nc, ibyte2		; 0-Bit
		jr	z, ibyte5
		cp	90h
		jr	c, ibyte4		; Trennzeichen
		scf				; 1-Bit
ibyte2:		rr	c
		djnz	ibyte1
		call	lstop			; Lesen Trennzeichen
		jr	c, ibyte4
ibyte3:		jr	z, ibyte5
		ld	a, c
ibyte4:		pop	bc
		ret	nc
		ld	a, 0Ch
		ret
ibyte5:		pop	bc
		xor	a
		scf
		ret

; ein Bit/Trennzeichen lesen

lstop:		push	bc
		call	ls1
		jr	z, lstop1		; bei Abbruch
		ld	c, a
		call	ls1
		jr	z, lstop1		; bei Abbruch
		add	a, c
lstop1:		pop	bc
		ret

; Lesen einer Flanke

ls1:		xor	a
		ld	(fcb1+0Eh), a		; LBLNR
ls2:		in	a, (DPIOB)
		cp	7Fh			; Graphic-Taste gedrckt?
		ret	z
		ld	a, (fcb1+0Eh)		; LBLNR
		or	a
		jr	z, ls2			; warten auf Flanke
		ret

;------------------------------------------------------------------------------
; Programmieren von Peripherie-Bausteinen
; HL: Liste mit je 1 Byte Anzahl, 1 Byte Port, n Byte Daten; 
; Ende der Liste mit Anzahl 0
;------------------------------------------------------------------------------

sub_0_DF2A:	push	bc
		di
loc_0_DF2C:	ld	a, (hl)			; Anzahl
		inc	hl
		or	a			; Ende bei Anzahl==0
		jr	z, loc_0_DF38
		ld	b, a
		ld	c, (hl)			; Port
		inc	hl			; Werte ausgeben
		otir
		jr	loc_0_DF2C
loc_0_DF38:	ei
		pop	bc
		ret


; fr Karam
unk_0_DF3B:	db	2			; Anzahl
		db	CTC2			; Port
		db	27h			; Werte
		db	96h
;
		db	3
		db	SPIOB
		db	3
		db	0CFh
		db	0FFh
;
		db	2
		db	SPIOA
		db	0CFh
		db	0
;
		db	1
		db	DPIOA
		db	0F7h
;
		db	3
		db	CTC0
		db	0
		db	85h
		db	40h
;
		db	0

; fr marek
unk_0_DF51:	db	2
		db	CTC2
		db	27h
		db	96h
;
		db	3
		db	SPIOB
		db	3
		db	0CFh
		db	0FFh
;
		db	2
		db	SPIOA
		db	0CFh
		db	0
;
		db	1
		db	DPIOA
		db	0F7h
;
		db	2
		db	CTC0
		db	5
		db	0B0h
;
		db	3
		db	SPIO1A
		db	0Ah
		db	0Fh
		db	83h
;
		db	0

; fr karam (2)
unk_0_DF6B:	db	1
		db	SPIO1A
		db	3
;
		db	2
		db	CTC0
		db	3
		db	0
;
		db	2
		db	CTC3
		db	0C7h
		db	40h
;
		db	2
		db	CTC2
		db	27h
		db	96h
;
		db	5
		db	SPIOB
		db	8
		db	0CFh
		db	0FFh
		db	97h
		db	0
;
		db	2
		db	SPIOA
		db	0CFh
		db	0
;
		db	1
		db	DPIOA
		db	0
;
		db	0

;;vp080525
;
;Ausgabe <A> hexa, Cursor zurueck
;

DCU:	EQU	0F73EH	;Cursor loeschen

OBLNR:	PUSH	AF

	rst	20h
	db 06h			; PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
	rst	20h
	db 00h			; PRNA , Ausgabe Register A zum Bildschirm
	rst	20h
	db 00h			; PRNA , Ausgabe Register A zum Bildschirm
	pop	af
25.05.2008 17:07 das geht nicht :-(
	PUSH	BC
	PUSH	DE
	PUSH	HL
	LD	L,3	;noetig
	CALL	DCU	;Cusor loeschen
	POP	HL
	POP	DE
	POP	BC

	POP	AF
	RET
