;------------------------------------------------------------------------------
; UP
;------------------------------------------------------------------------------

;		org	0c500h

		jp	cmd_bo_up
aUp:		db "#UP     "
		db 0
		jp	cmd_i_bios
aBios:		db "$BIOS   "
		db 0
		jp	up_oprdr
aOprdr:		db "OPRDR   "
		db 0
		jp	up_clrdr
aClrdr:		db "CLRDR   "
		db 0
		jp	up_oppun
aOppun:		db "OPPUN   "
		db 0
		jp	up_clpun
aClpun:		db "CLPUN   "
		db 0
		jp	up_oplst
aOplst:		db "OPLST   "
		db 0
		jp	up_cllst
aCllst:		db "CLLST   "
		db 0
		db 0

;------------------------------------------------------------------------------
; RST 20-Subroutine (Sprungverteiler UP-Programme)
; wird bei Aufruf von RST 20 ausgefhrt.
;------------------------------------------------------------------------------

sub_rst20:	pop	af
		ex	(sp), hl
		inc	hl
		ex	(sp), hl
		push	hl
		push	af
		ld	hl, (0021h)		; Zieladr. von RST 20
		inc	hl
		inc	hl
		ld	l, (hl)
		ld	a, (sys_bank)
		ld	h, a
		ld	a, l
		ld	(sys_bank), a
		ei
		pop	af
		ex	(sp), hl
		push	hl
		ld	hl, sys_rst20ret
		ex	(sp), hl
		push	de
		push	hl
		push	af
		ld	hl, 9
		add	hl, sp
		ld	a, (hl)
		inc	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		dec	hl
		call	up_r3
;
sub_rst201:	ld	d, 0
		ld	hl, up_tabelle		; e000h
		add	hl, de
		add	hl, de
		add	hl, de
		ld	a, sys_bank_up
		call	up_r35
		ld	a, h
		and	0Fh
		cp	0Fh
		jr	nz, sub_rst202
		ld	a, h
		and	0F0h
		ld	h, a
		ld	a, (sys_bank)
		and	0Fh
		or	h
		ld	h, a
sub_rst202:	ex	de, hl
		di
		inc	sp
		inc	sp
		inc	sp
		inc	sp
		ex	(sp), hl
		dec	sp
		dec	sp
		dec	sp
		dec	sp
		ei
		ex	de, hl
		jp	sys_rst20ret+2	; weiter im orig. RST20-Return-Code

;------------------------------------------------------------------------------
; 40 R1   , 1 Byte von (HL) Bank (A) in A lesen
;------------------------------------------------------------------------------

up_r1:		push	de
		push	hl
		call	up_r3
		ld	a, e
		pop	hl
		pop	de
		ret

;------------------------------------------------------------------------------
; 41 R3   , 3 Byte von (HL) (A) in E, D, H lesen
;------------------------------------------------------------------------------

up_r3:		ld	d, a
		ld	a, h
		and	0E0h
		cp	0C0h
		jr	z, up_r31		; Lesen aus Bereich C000-DFFF
		ld	a, h
		and	0F8h
		cp	0E0h
		jr	z, up_r34		; Lesen aus Bereich E000-E7FF
;
		ld	e, (hl)			; sonst direkt lesen
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	h, (hl)
		or	a
		ret
;
up_r31:		push	bc
		ld	c, d
		push	iy
		ld	iy, 0E01Ch		; fkt_up_r3 (in BO1) in Bank E000 (00)
up_r32:		or	a
		ld	a, r
		push	af
		push	ix
		ld	a, (user_bank)
		and	0Fh
		push	de
		ld	d, a
		ld	a, (sys_bank)
		ld	b, a
		and	0F0h
		or	d
		pop	de
		ld	ix, up_r33
		di
		ld	(sys_bank), a
		out	(0FFh),	a
		ld	a, c
		jp	(iy)

up_r33:		ld	a, b
		ld	(sys_bank), a
		out	(0FFh),	a
		pop	ix
		pop	af
		pop	iy
		pop	bc
		ret	po
		ei
		ret

up_r34:		ld	a, d
up_r35:		and	0Fh
		ld	d, a
		ld	a, (sys_bank)
		and	0F0h
		or	d
		ld	d, a
		ld	a, r
		ld	a, d
		di
		out	(0FFh),	a
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	h, (hl)
		ld	a, (sys_bank)
		out	(0FFh),	a
		ret	po
		ei
		ret

;------------------------------------------------------------------------------
; 43 W2   , 2 Byte aus E, D auf (HL) (A) schreiben
;------------------------------------------------------------------------------

up_w2:		push	bc
		ld	b, 2
up_w21:		ld	c, a
		ld	a, h
		and	0E0h
		cp	0C0h
		jr	z, up_w23
		ld	a, h
		and	0F8h
		cp	0E0h
		jr	z, up_w24
		ld	(hl), e
		dec	b
		jr	z, up_w22
		inc	hl
		ld	(hl), d
		dec	hl
up_w22:		pop	bc
		or	a
		ret
up_w23:		push	iy
		ld	iy, 0E01Fh		; fkt_up_w1 (in BO1) in Bank E000 (00)
		dec	b
		jr	z, up_r32
		ld	iy, 0E022h		; fkt_up_w2 (in BO1) in Bank E000 (00)
		jr	up_r32
up_w24:		ld	a, c
		and	0Fh
		ld	c, a
		ld	a, (sys_bank)
		and	0F0h
		or	c
		ld	c, a
		dec	b
		jr	z, up_w26
		ld	a, r
		ld	a, c
		di
		out	(0FFh),	a
		ld	(hl), e
		inc	hl
		ld	(hl), d
		dec	hl

up_w25:		ld	a, (sys_bank)
		out	(0FFh),	a
		pop	bc
		ret	po
		ei
		ret

;------------------------------------------------------------------------------
; 42 W1   , 1 Byte aus E auf (HL) in Bank (A) schreiben
;------------------------------------------------------------------------------

up_w1:		push	bc
		ld	b, 1
		jr	up_w21

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

up_w26:		ld	a, r
		ld	a, c
		di
		out	(0FFh),	a
		ld	(hl), e
		jr	up_w25

;------------------------------------------------------------------------------
; 44 LDIRU, Blocktransport zwischen Bnken von (HL) (B) nach (DE) (C), Lnge = IX
;------------------------------------------------------------------------------

up_ldiru:	dec	ix
up_ldiru1:	push	hl
		push	de
		ld	a, b
		call	up_r3
		pop	hl
		ld	a, c
		call	up_w1
		ld	de, 0FFFFh
		add	ix, de
		pop	de
		ex	de, hl
		inc	hl
		inc	de
		jr	c, up_ldiru1
		ret

;------------------------------------------------------------------------------
; 46 LDDRU, Blocktransport rckwrts (entspricht LDDR), Register wie LDIRU
;------------------------------------------------------------------------------

up_lddru:	dec	ix
up_lddru1:	push	hl
		push	de
		ld	a, b
		call	up_r3
		pop	hl
		ld	a, c
		call	up_w1
		ld	de, 0FFFFh
		add	ix, de
		pop	de
		ex	de, hl
		dec	hl
		dec	de
		jr	c, up_lddru1
		ret

;------------------------------------------------------------------------------
; unbenutze, "leere" UP-Funktion
;------------------------------------------------------------------------------

ccp_kdo:	ld	hl, 3
		add	hl, sp
		ld	a, (hl)
		inc	hl
		ld	e, (hl)
		inc	hl
		ld	d, (hl)
		ex	de, hl
		dec	hl
		call	up_r3
		ld	b, e
		ld	a, 7		; Fehler undefinierte UP-Funktion
		scf
		ret

;------------------------------------------------------------------------------
; UP-Liste, wird nach RAM E000 (0c) aufbereitet, um nderungen patchen zu knnen
;------------------------------------------------------------------------------

lst_up_kdo:	dw up_prna			; 00
		dw up_prnz			; 01
		dw up_prnsp			; 02
		dw up_prnda			; 03
		dw up_prnde			; 04
		dw up_prcrlf			; 05
		dw up_prnby			; 06
		dw up_prnad			; 07
		dw up_prnst			; 08
		dw up_prst			; 09
		dw up_prcst			; 0A
		dw up_dispo			; 0B
		dw up_prner			; 0C
		dw up_prdez			; 0D
		dw ccp_kdo			; 0E
		dw up_list1			; 0F
		dw up_inby			; 10
		dw up_inad			; 11
		dw up_instr			; 12
		dw up_pause			; 13
		dw up_inzif			; 14
		dw up_inzia			; 15
		dw up_input			; 16
		dw up_inpda			; 17
		dw up_stent			; 18
		dw up_parh2			; 19
		dw up_parb2			; 1A
		dw up_pardb			; 1B
		dw up_parda			; 1C
		dw up_parh4			; 1D
		dw up_para2			; 1E
		dw up_para3			; 1F
		dw up_ashex			; 20
		dw up_nump			; 21
		dw ccp_kdo			; 22
		dw up_dadbc			; 23
		dw ccp_kdo			; 24
		dw ccp_kdo			; 25
		dw ccp_kdo			; 26
		dw ccp_kdo			; 27
		dw ccp_kdo			; 28
		dw ccp_kdo			; 29
		dw ccp_kdo			; 2A
		dw up_hexdu			; 2B
		dw up_dezdu			; 2C
		dw ccp_kdo			; 2D
		dw ccp_kdo			; 2E
		dw ccp_kdo			; 2F
		dw up_consi			; 30
		dw up_stcon			; 31
		dw up_cono			; 32
		dw up_conso			; 33
		dw up_readi			; 34
		dw up_strdr			; 35
		dw up_oprdr			; 36
		dw up_clrdr			; 37
		dw up_puno			; 38
		dw up_stpun			; 39
		dw up_oppun			; 3A
		dw up_clpun			; 3B
		dw up_listo			; 3C
		dw up_stlst			; 3D
		dw up_oplst			; 3E
		dw up_cllst			; 3F
		dw up_r1			; 40
		dw up_r3			; 41
		dw up_w1			; 42
		dw up_w2			; 43
		dw up_ldiru			; 44
		dw ccp_kdo			; 45
		dw up_lddru			; 46

;------------------------------------------------------------------------------
; BIOS-Liste wird nach RAM E150(0c) aufbereitet, um nderungen patchen zu knnen
;------------------------------------------------------------------------------

lst_bios_kdo:	dw up_ctty			; 70
		dw up_ccrt			; 71
		dw up_cbat			; 72
		dw up_cuc1			; 73
		dw up_rtty			; 74
		dw up_rptr			; 75
		dw up_rur1			; 76
		dw up_rur2			; 77
		dw up_ptty			; 78
		dw up_pptp			; 79
		dw up_pup1			; 7A
		dw up_pup2			; 7B
		dw up_ltty			; 7C
		dw up_lcrt			; 7D
		dw up_llpt			; 7E
		dw up_lul1			; 7F
		dw up_boot			; 80
		dw 0				; 81
		dw up_stcon			; 82
		dw up_consi			; 83
		dw up_cono			; 84
		dw up_listo			; 85
		dw up_puno			; 86
		dw up_readi			; 87
		dw dbios_kdo			; 88
		dw dbios_kdo			; 89
		dw dbios_kdo			; 8A
		dw dbios_kdo			; 8B
		dw dbios_kdo			; 8C
		dw dbios_kdo			; 8D
		dw dbios_kdo			; 8E
		dw up_stlst			; 8F
		dw dbios_kdo			; 90
		dw up_stcon			; 91
		dw up_strdr			; 92
		dw up_stpun			; 93
		dw dbios_kdo			; 94

;------------------------------------------------------------------------------
; Kommando #UP
; Erstellen der UP-Liste im RAM E000(C), Initialisieren von RST20 und RST30
; Aufruf: durch BO2 (Systemanlauf)
;------------------------------------------------------------------------------

cmd_bo_up:	
; Kopieren der UP-Liste in RAM E000(C), jeweils 2 Byte Adr und 1 Byte Bank
		ld	hl, lst_up_kdo
		ld	de, up_tabelle		; e000
		ld	a, (sys_bank)
		and	0F0h
		or	sys_bank_up
		di
		out	(0FFh),	a		; Bank sys_bank_up (xC) whlen
		ld	bc, lst_bios_kdo-lst_up_kdo	; Anzahl Bytes (8Eh)
		ld	a, (sys_bank)
		or	0Fh
cmd_bp_up1:	ldi				; je 2 Byte Adresse kopieren
		ldi
		ld	(de), a			; und 1 Byte Bank merken
		inc	de
		jp	pe, cmd_bp_up1
;die restlichen (bis FF ) UP-Eintrge im RAM mit ccp_kdo initialisieren
		ld	b, 0ffh - (lst_bios_kdo-lst_up_kdo)/2
		ex	de, hl			; HL = aktuelle Adresse im RAM
		ld	de, ccp_kdo
cmd_bp_up2:	ld	(hl), e			; je 2 Byte Adresse
		inc	hl
		ld	(hl), d
		inc	hl
		ld	(hl), a			; und 1 Byte Bank merken
		inc	hl
		djnz	cmd_bp_up2
; Eintragen von UP FF EXTUP		
		ld	de, up_extup
		ld	(hl), e
		inc	hl
		ld	(hl), d
		inc	hl
		ld	(hl), a
; Eintragen der BIOS-UPs		
		ld	e, 70h			; ab UP-Nr. 70H
		ld	d, 0
		ld	hl, up_tabelle		; e000
		add	hl, de
		add	hl, de
		add	hl, de
		ex	de, hl			; DE = Adr. UP-Eintrag 70H
		ld	hl, lst_bios_kdo
		ld	bc, cmd_bo_up-lst_bios_kdo	; Anzahl 4Ah
cmd_bp_up3:	ldi				; je 2 Byte Adresse kopieren
		ldi
		ld	(de), a			; und 1 Byte Bank merken
		inc	de
		jp	pe, cmd_bp_up3
;		
		ld	a, (sys_bank)		; Systembank restaurieren
		out	(0FFh),	a
;Eintragen von RST 20h
						;Code durch BO2 erzeugt:
						;rst20:		jp	02dbh
						;02dbh:		push	af
						;		ld	a, 0FFh
						;		di
						;		out	(0FFh),	a
						;		jp	0
;code patchen
		ld	hl, (0021h)		; Zieladr. von RST 20
		inc	hl
		inc	hl
		ld	a, (sys_bank)
		or	0Fh
		ld	(hl), a			; neu: ld a, diese Bank
		ld	de, 5
		add	hl, de
		ld	de, sub_rst20
		ld	(hl), e
		inc	hl
		ld	(hl), d			; neu: jp sub_rst20
;Eintragen von RST 30h
		ld	hl, (0031h)		; Zieladr. von RST 30
		inc	hl
		inc	hl
		ld	(hl), a			; neu: ld a, diese Bank
		ld	de, 5
		add	hl, de
		ld	de, sub_rst30
		ld	(hl), e
		inc	hl
		ld	(hl), d			; neu: jp sub_rst30
		ei
		ret

;------------------------------------------------------------------------------
; FF EXTUP, Einbindung eines weiteren Unterprogrammes in das System UP
; DE Adr, A Bank, C Up-Nr.
;------------------------------------------------------------------------------

up_extup:	push	bc
		push	hl
		ld	b, 0
		ld	hl, up_tabelle		; e000
		add	hl, bc
		add	hl, bc
		add	hl, bc			; HL = UP-Pos. in UP-Liste
		or	0Fh
		ld	b, a
		ld	a, (sys_bank)
		and	0F0h
		or	sys_bank_up
		ld	c, a
		ld	a, r			; IFF-Flag ins P/V-Flag holen
		ld	a, c
		di
		out	(0FFh),	a		; Umschalten auf Bank C
		ld	(hl), e			; Eintragen UP-Adr
		inc	hl
		ld	(hl), d
		inc	hl
		ld	(hl), b			; Eintragen UP-Bank
		ld	a, (sys_bank)		; Bank zurcksetzen
		out	(0FFh),	a
		ld	a, b
		pop	hl
		pop	bc
		ret	po			; zurck ohne EI bei IFF=0 (gerade im Interrupt)
		ei
		ret

;------------------------------------------------------------------------------
; Kommando $BIOS
; Initialisierung BIOS
; Aufruf: durch BO (Kaltstartinitialsierung)
;------------------------------------------------------------------------------


cmd_i_bios:	ld	hl, tab_bios		; bios-Tabelle in RAM kopieren
		ld	de, up_biostab		; 0E200h
		ld	a, (sys_bank)
		ld	b, a
		ld	c, 0FFh
		ld	ix, sub_bios - tab_bios; Lnge
		call	up_ldiru		; Kopieren von HL (B) nach DE (C)
;
		ld	a, (sys_bank)
		or	0Fh
		ld	e, a
		ld	a, c
		ld	hl, loc_0_C901+1	; 0E28Fh
		call	up_w1			; Patchen der System-Pank
		ret

;-----------------------------------------------------------------------------
; wird nach E200 (FF) kopiert
;-----------------------------------------------------------------------------

tab_bios:	
		phase	up_biostab

		jp	loc_0_C8AF	; 0E23Ch
		jp	loc_0_C8B3	; 0E240h
		jp	loc_0_C8B7	; 0E244h
		jp	loc_0_C8BB	; 0E248h
		jp	loc_0_C8BF	; 0E24Ch
		jp	loc_0_C8C3	; 0E250h
		jp	loc_0_C8C7	; 0E254h
		jp	loc_0_C8CB	; 0E258h
		jp	loc_0_C8CF	; 0E25Ch
		jp	loc_0_C8D3	; 0E260h
		jp	loc_0_C8D7	; 0E264h
		jp	loc_0_C8DB	; 0E268h
		jp	loc_0_C8DF	; 0E26Ch
		jp	loc_0_C8E3	; 0E270h
		jp	loc_0_C8E7	; 0E274h
		jp	loc_0_C8EB	; 0E278h
		jp	loc_0_C8EF	; 0E27Ch
		jp	loc_0_C8F3	; 0E280h
		jp	loc_0_C8F7	; 0E284h
		jp	loc_0_C8FB	; 0E288h

loc_0_C8AF:	ld	l, 80h
		jr	loc_0_C8FD

loc_0_C8B3:	ld	l, 81h
		jr	loc_0_C8FD

loc_0_C8B7:	ld	l, 82h
		jr	loc_0_C8FD

loc_0_C8BB:	ld	l, 83h
		jr	loc_0_C8FD

loc_0_C8BF:	ld	l, 84h
		jr	loc_0_C8FD

loc_0_C8C3:	ld	l, 85h
		jr	loc_0_C8FD

loc_0_C8C7:	ld	l, 86h
		jr	loc_0_C8FD

loc_0_C8CB:	ld	l, 87h
		jr	loc_0_C8FD

loc_0_C8CF:	ld	l, 88h
		jr	loc_0_C8FD

loc_0_C8D3:	ld	l, 89h
		jr	loc_0_C8FD

loc_0_C8D7:	ld	l, 8Ah
		jr	loc_0_C8FD

loc_0_C8DB:	ld	l, 8Bh
		jr	loc_0_C8FD

loc_0_C8DF:	ld	l, 8Ch
		jr	loc_0_C8FD

loc_0_C8E3:	ld	l, 8Dh
		jr	loc_0_C8FD

loc_0_C8E7:	ld	l, 8Eh
		jr	loc_0_C8FD

loc_0_C8EB:	ld	l, 8Fh
		jr	loc_0_C8FD

loc_0_C8EF:	ld	l, 90h
		jr	loc_0_C8FD

loc_0_C8F3:	ld	l, 91h
		jr	loc_0_C8FD

loc_0_C8F7:	ld	l, 92h
		jr	loc_0_C8FD

loc_0_C8FB:	ld	l, 93h

loc_0_C8FD:	ld	a, (sys_bank)
		ld	h, a
loc_0_C901:	ld	a, 0FFh			; FF steht auf Adr. 0E28Fh
						; wird durch cmd_i_bios mit der korrekten Bank gepatcht
		ld	(sys_bank), a
		out	(0FFh),	a
		jp	sub_bios

		dephase

;-----------------------------------------------------------------------------
; Ausfhren eines BIOS-Aufrufs
;-----------------------------------------------------------------------------

sub_bios:	push	hl
		push	hl
		ld	hl, sys_rst20ret
		ex	(sp), hl
		push	hl
		push	iy
		ld	iy, 0E465h		; ???? s.a. DBIOS
		push	hl
		ld	hl, sub_bios_ret
		ex	(sp), hl
		push	af
		push	hl
		ld	hl, sys_rst20ret
		ex	(sp), hl
		push	de
		push	hl
		push	af
		ld	e, l
		jp	sub_rst201
;
;
;
sub_bios_ret:	pop	iy
		jr	c, sub_bios_ret1	; bei Fehler
		inc	sp
		inc	sp
		ret
;
sub_bios_ret1:	pop	hl
		ld	c, a
		ld	de, aFehlerBeiBiosF 	; "\r\nFehler bei BIOS-Funktion: "
		ld	a, (sys_bank)
		call	up_prnst1
		jr	c, sub_bios_ret2
		ld	a, l
		sub	80h
		call	up_prnby
		jr	c, sub_bios_ret2
		ld	a, c
sub_bios_ret2:	rst	20h
		db 0Ch				; PRNER, Systemfehleranzeige, A=Fehlercode, B=Zusatzinformation
		jp	0

aFehlerBeiBiosF:db 0Dh
		db 0Ah
		db "Fehler bei BIOS-Funktion: "
		db 0

;------------------------------------------------------------------------------
; 30 CONSI, Eingabe von Console (Tastatur)
;------------------------------------------------------------------------------

up_consi:	ld	a, 1
		jr	up_list1

;------------------------------------------------------------------------------
; 32 CONO , Ausgabe zu Console (Bildschirm)
;------------------------------------------------------------------------------

up_cono:	ld	a, 2
		jr	up_list1

;------------------------------------------------------------------------------
; 31 STCON, Statusabfrage Console (Tastaturstatus)
;------------------------------------------------------------------------------

up_stcon:	ld	a, 0
		jr	up_list1

;------------------------------------------------------------------------------
; 34 READI, Eingabe vom Reader
;------------------------------------------------------------------------------

up_readi:	ld	a, 41h
		jr	up_list1

;------------------------------------------------------------------------------
; 35 STRDR, Statusabfrage Reader
;------------------------------------------------------------------------------

up_strdr:	ld	a, 40h
		jr	up_list1

;------------------------------------------------------------------------------
; 36 OPRDR, OPEN Reader
;------------------------------------------------------------------------------

up_oprdr:	ld	a, 51h
		jr	up_list1

;------------------------------------------------------------------------------
; 37 CLRDR, CLOSE Reader
;------------------------------------------------------------------------------

up_clrdr:	ld	a, 53h
		jr	up_list1

;------------------------------------------------------------------------------
; 38 PUNO , Ausgabe zu Punch
;------------------------------------------------------------------------------

up_puno:	ld	a, 82h
		jr	up_list1

;------------------------------------------------------------------------------
; 39 STPUN, Statusabfrage Punch
;------------------------------------------------------------------------------

up_stpun:	ld	a, 80h
		jr	up_list1

;------------------------------------------------------------------------------
; 3A OPPUN, OPEN Punch
;------------------------------------------------------------------------------

up_oppun:	ld	a, 92h
		jr	up_list1

;------------------------------------------------------------------------------
; 3B CLPUN, CLOSE Punch
;------------------------------------------------------------------------------

up_clpun:	ld	a, 94h
		jr	up_list1

;------------------------------------------------------------------------------
; 3C LISTO, Ausgabe zu List
;------------------------------------------------------------------------------

up_listo:	ld	a, 0C2h
		jr	up_list1

;------------------------------------------------------------------------------
; 3D STLST, Statusabfrage List
;------------------------------------------------------------------------------

up_stlst:	ld	a, 0C0h
		jr	up_list1

;------------------------------------------------------------------------------
; 3E OPLST, OFEN List
;------------------------------------------------------------------------------

up_oplst:	ld	a, 0D2h
		jr	up_list1

;------------------------------------------------------------------------------
; 3F CLLST, CLOSE List
;------------------------------------------------------------------------------

up_cllst:	ld	a, 0D4h

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

up_list1:	push	bc
		push	de
		push	hl
		push	hl
		ld	hl, up_list1ret
		ex	(sp), hl
		push	hl
		push	af
		ld	a, (sys_bank)
		ld	h, a
		pop	af
		ex	(sp), hl
		push	hl
		ld	hl, sys_rst20ret
		ex	(sp), hl
		push	af
		rlca
		rlca
		rlca
		ld	b, a
		pop	af
		and	1Fh
		push	de
		push	hl
		push	af
		ld	hl, 4
		ld	a, i
		cp	2
		jr	z, up_list2
		dec	hl
up_list2:	ld	a, b
		and	6
		ld	b, a
		ld	e, a
		ld	a, (hl)
		jr	z, up_list4
up_list3:	srl	a
		djnz	up_list3
up_list4:	and	3
		sla	e
		or	e
		ld	b, a
		add	a, 70h
		ld	e, a
		jp	sub_rst201
;
;
;
up_list1ret:	pop	hl
		pop	de
		jr	c, up_list1ret1
		pop	bc
		ret
up_list1ret1:	inc	sp
		inc	sp
		ret

;------------------------------------------------------------------------------
; RST30-Programm
; wird bei RST 30 angesprungen
;------------------------------------------------------------------------------

sub_rst30:	ld	l, a
		ld	a, (sys_bank)
		ld	h, a
		ld	a, l
		ld	(sys_bank), a
		pop	af
		ei
		push	hl
		ld	hl, sys_rst20ret
		push	hl
		or	0C0h
		jr	up_list1

;------------------------------------------------------------------------------
; Gertreiberaufrufe
; die Adressen der Gertetreiber werden aus der Adretabelle (EFC9-EFE8) geholt
;------------------------------------------------------------------------------

up_ctty:	ld	hl, (0EFC9h)
		jr	up_treiber1

up_ccrt:	ld	hl, (0EFCBh)
		jr	up_treiber1

up_cbat:	ld	hl, (0EFCDh)
		jr	up_treiber1

up_cuc1:	ld	hl, (0EFCFh)
		jr	up_treiber1

up_rtty:	ld	hl, (0EFD1h)
		jr	up_treiber1

up_rptr:	ld	hl, (0EFD3h)
		jr	up_treiber1

up_rur1:	ld	hl, (0EFD5h)
		jr	up_treiber1

up_rur2:	ld	hl, (0EFD7h)
		jr	up_treiber1

up_ptty:	ld	hl, (0EFD9h)
		jr	up_treiber1

up_pptp:	ld	hl, (0EFDBh)
		jr	up_treiber1

up_pup1:	ld	hl, (0EFDDh)
		jr	up_treiber1

up_pup2:	ld	hl, (0EFDFh)
		jr	up_treiber1

up_ltty:	ld	hl, (0EFE1h)
		jr	up_treiber1

up_lcrt:	ld	hl, (0EFE3h)
		jr	up_treiber1

up_llpt:	ld	hl, (0EFE5h)
		jr	up_treiber1

up_lul1:	ld	hl, (0EFE7h)

up_treiber1:	push	af			
		inc	hl			; HL-Adresse Gertetreiber
		ld	a, l
		or	h
		jr	z, up_treiber3		; Abbruch bei Adresse 0FFFFH
		dec	hl
;
		ld	a, h
		and	0F8h
		cp	0E0h
		jr	z, up_treiber3		; Abbruch bei Adresse E0xx - E7xx
		and	0E0h
		cp	0C0h
		jr	z, up_treiber3		; Abbruch bei Adresse C0xx - DFxx
		pop	af
;		
		call	up_treiber2		; Ersatz fr call (hl), Aufruf Treiber
		ret	nc			; zurck, wenn kein Fehler
		ld	a, 8			; Fehler 8 (log. Geraet nicht zugewiesen)
		ret
;		
up_treiber2:	jp	(hl)
;
up_treiber3:	pop	af
		ld	a, 8			; Fehler 8 (log. Geraet nicht zugewiesen)
		scf
		ret

;------------------------------------------------------------------------------
; 33 CONSO, Ausgabe zu Console und evtl. zum Drucker.
;------------------------------------------------------------------------------

up_conso:	ld	a, c
		cp	10h			; <CONTR P>
		jr	nz, up_conso1
		ld	a, (15h)		; 0015h - LISW Schalter fr Hardcopy
		xor	1
		ld	(15h), a
		ret
;
up_conso1:	call	up_cono
		jr	c, up_conso2
		ld	a, (15h)
		or	a
		ret	z
		
		call	up_listo
		ret	nc
up_conso2:	push	af
		xor	a
		ld	(15h), a
		pop	af
		ret

;------------------------------------------------------------------------------
; 80 BOOT , BIOS-Ruf 0 Kaltstart
;------------------------------------------------------------------------------

up_boot:	ld	a, (sys_bank)
		and	0F0h
		di
		ld	(sys_bank), a
		out	(0FFh),	a
		jp	0E000h			; in Bank x0 => "#       "

;------------------------------------------------------------------------------
; "leeres" Kommando
;------------------------------------------------------------------------------

dbios_kdo:	ld	hl, 0
		xor	a
		inc	a
		ret

;------------------------------------------------------------------------------
; 
;------------------------------------------------------------------------------

loc_0_CAA9:	push	hl
		ld	hl, 7
		add	hl, sp
		ld	a, (hl)
		pop	hl
		ret

;------------------------------------------------------------------------------
; 08 PRNST, Ausgabe Zeichenkette ab (DE) bis zum Code 00
;------------------------------------------------------------------------------

up_prnst:	call	loc_0_CAA9
up_prnst1:	push	ix
		ld	ix, up_prna
up_prnst2:	push	bc
		ld	b, a
		push	hl
up_prnst3:	push	de
		ex	de, hl
		ld	a, b
		call	up_r3
		ld	a, e
		or	a
		jr	z, up_prnst4
		call	up_prnst8
		jr	c, up_prnst4
		ld	a, d
		or	a
		jr	z, up_prnst5
		call	up_prnst8
		jr	c, up_prnst5
		ld	a, h
		or	a
		jr	z, up_prnst6
		call	up_prnst8
		jr	c, up_prnst6
		pop	de
		inc	de
		inc	de
		inc	de
		jr	up_prnst3
up_prnst4:	pop	de
		jr	up_prnst7
up_prnst5:	pop	de
		inc	de
		jr	up_prnst7
up_prnst6:	pop	de
		inc	de
		inc	de
up_prnst7:	pop	hl
		pop	bc
		pop	ix
		ret

up_prnst8:	jp	(ix)

;------------------------------------------------------------------------------
; 0A PRCST, Ausgabe Zeichenkette ob (DE) bis zum Code 00 (fr Fehlermeldungen) 
;------------------------------------------------------------------------------

up_prcst:	call	loc_0_CAA9
up_prcst1:	push	ix
		ld	ix, up_prnda
		jr	up_prnst2

;------------------------------------------------------------------------------
; 09 PRST , Ausgabe Zeichenkette ab (HL), Zeichenzahl in B
;------------------------------------------------------------------------------

up_prst:	call	loc_0_CAA9
		push	bc
		ld	c, a
		push	de
		ld	a, b
		or	a
		jr	z, up_prst5
up_prst1:	push	hl
		ld	a, c
		call	up_r3
		ld	a, e
		call	up_prnz
		jr	c, up_prst2
		dec	b
		jr	z, up_prst2
		ld	a, d
		call	up_prnz
		jr	c, up_prst3
		dec	b
		jr	z, up_prst3
		ld	a, h
		call	up_prnz
		jr	c, up_prst4
		dec	b
		jr	z, up_prst4
		pop	hl
		inc	hl
		inc	hl
		inc	hl
		jr	up_prst1
up_prst2:	pop	hl
		jr	up_prst5
up_prst3:	pop	hl
		inc	hl
		jr	up_prst5
up_prst4:	pop	hl
		inc	hl
		inc	hl
up_prst5:	inc	hl
		pop	de
		pop	bc
		ret

;------------------------------------------------------------------------------
; 1A PARB2, 2 Byte hex. aus Kommandozeile holen, 1.Byte in L, 2.Byte in H u. E 
;------------------------------------------------------------------------------

up_parb2:	call	up_parh2
		ret	c			; bei Fehler
		ld	l, e
		call	up_parh2
		ld	h, e
		ret

;------------------------------------------------------------------------------
; 1F PARA3, 3 Adressen hexadezimal aus Kommandozeile in HL, DE und BC holen
;------------------------------------------------------------------------------

up_para3:	call	up_para2
		ret	c			; bei Fehler
		push	de
		call	up_parh4
		ld	c, e
		ld	b, d
		pop	de
		ret

;------------------------------------------------------------------------------
; 1E PARA2, 2 Adressen hexadezimal aus Kommandozeile in HL und DE holen
;------------------------------------------------------------------------------

up_para2:	call	up_parh4
		ret	c			; bei Fehler
		ld	l, e
		ld	h, d
		call	up_parh4
		ret	c			; bei Fehler
		ex	de, hl
		push	hl
		or	a
		sbc	hl, de
		pop	hl
		ex	de, hl
		ld	a, 2
		ret

;------------------------------------------------------------------------------
; 1D PARH4, 1 Adresse hexadezimal aus Kommandozeile in DE holen
;------------------------------------------------------------------------------

up_parh4:	ld	de, fcb1+1
		ld	a, (de)
		cp	' '
		scf
		jr	z, up_parh41
		call	up_hexdu
		ret	c			; bei Fehler
		rst	20h
		db 28h				; NPAR , 2 Parameter aus Kommandozeile ob 80H als Dateibezeichnung in FCB ab (5C)
		ret
up_parh41:	ld	a, 1
		ret

;------------------------------------------------------------------------------
; 19 PARH2, 1 Byte hexadezimal aus Kommandozeile in Register E holen
;------------------------------------------------------------------------------

up_parh2:	call	up_parh4
		ret	c			; bei Fehler
		ld	a, d
		or	a
		ret	z
		ld	a, 3
		scf
		ret

;------------------------------------------------------------------------------
; 1C PARDA, 1 Adresse dezimal aus Kommandozeile in DE holen
;------------------------------------------------------------------------------

up_parda:	ld	de, fcb1+1
		ld	a, (de)
		cp	' '
		scf
		jr	z, up_parh41
		call	up_dezdu
		ret	c			; bei Fehler
		rst	20h
		db 28h				; NPAR , 2 Parameter aus Kommandozeile ob 80H als Dateibezeichnung in FCB ab (5C)
		ret

;------------------------------------------------------------------------------
; 1B PARDB, 1 Byte dezimal aus Kommandozeile in E holen
;------------------------------------------------------------------------------

up_pardb:	call	up_parda
		ret	c			; bei Fehler
		ld	a, d
		or	a
		ret	z
		ld	a, 3
		scf
		ret

;------------------------------------------------------------------------------
; Aufruf System RCONB, Eingabe Zeichenkette
;------------------------------------------------------------------------------

up_rconb:	push	bc
		push	de
		push	hl
		call	0F365h			; RCONB, Eingabe Zeichenkette
		pop	hl
		pop	de
		pop	bc
		ret

;------------------------------------------------------------------------------
; 11 INAD , Eingabe Adresse hexadezimal in DE   R:A=1 leer / A=2 falsch / A=3 OK
;------------------------------------------------------------------------------

up_inad:	push	hl
		ld	de, 7Fh
		ld	a, 8
		ld	(de), a
		push	bc
		ld	c, 0Ah
		call	up_rconb
		pop	bc
		jr	c, up_inad3
		inc	de
		ld	a, (de)
		inc	de
		ld	l, a
		ld	h, 0
		add	hl, de
		ld	(hl), 0
		ld	hl, fcb1
		rst	20h
		db 29h				; PARA , Parameter ab (DE) als Dateibezeichnung interpretieren und ab (HL) eintr.
		jr	nc, up_inad1
		cp	1
		jr	z, up_inad2
		scf
		jr	up_inad3
up_inad1:	ld	de, fcb1+1
		ld	a, (de)
		cp	20h
		ld	a, 1
		jr	z, up_inad3
		call	up_hexdu
		ccf
up_inad2:	ld	a, 2
		jr	nc, up_inad3
		ld	a, 3
		or	a
up_inad3:	pop	hl
		ret

;------------------------------------------------------------------------------
; 10 INBY , Eingabe 1 Byte hexadezimal in E   R:A=1 leer / A=2 falsch / A=3 OK
;------------------------------------------------------------------------------

up_inby:	call	up_inad
		ret	c			; bei Fehler
		cp	3
		scf
		ccf
		ret	nz
		ld	a, d
		or	a
		ld	a, 2
		ret	nz
		inc	a
		ret

;------------------------------------------------------------------------------
; 12 INSTR, Eingabe Zeichenkette ob (HL), B=Lnge, C=Bank
;------------------------------------------------------------------------------

up_instr:	push	bc
		push	de
		push	hl
		ld	de, 7Fh
		ld	a, 7Eh
		ld	(de), a
		push	bc
		ld	c, 0Ah
		call	up_rconb
		pop	bc
		jr	c, up_instr5
		inc	de
		ld	a, (de)
		or	a
		jr	z, up_instr3
		dec	a
		cp	b
		ld	a, 2
		jr	nc, up_instr4
up_instr1:	inc	de
		ld	a, (de)
		push	de
		ld	e, a
		ld	a, c
		call	up_w1
		inc	hl
		pop	de
		dec	b
		ld	a, 3
		jr	z, up_instr4
		push	hl
		ld	hl, 80h
		dec	(hl)
		pop	hl
		jr	nz, up_instr1
		ld	e, 0
up_instr2:	ld	a, c
		call	up_w1
		inc	hl
		djnz	up_instr2
		ld	a, 3
		jr	up_instr4
up_instr3:	ld	a, 1
up_instr4:	or	a
up_instr5:	pop	hl
		pop	de
		pop	bc
		ret

;------------------------------------------------------------------------------
; 16 INPUT, Eingabe Zeichenkette mit Aufforderungstext
;------------------------------------------------------------------------------

up_input:	call	loc_0_CAA9
		push	de
		call	up_prnst1
		pop	de
		ret	c			; bei Fehler
		call	up_instr
		ret	c			; bei Fehler
		dec	a
		ret	z
		dec	a
		ret	nz
		ld	a, 0Bh
		call	up_prna
		ret	c			; bei Fehler
		jr	up_input

;------------------------------------------------------------------------------
; 15 INZIA, Eingabe Adresse mit Aufforderungstext
;------------------------------------------------------------------------------

up_inzia:	call	loc_0_CAA9
up_inzia1:	push	hl
		ld	h, a
		push	de
		call	up_prnst1
		jr	c, up_inzia2
		call	up_inad
		jr	c, up_inzia2
		ld	c, e
		ld	b, d
		dec	a
		jr	z, up_inzia2
		dec	a
		jr	nz, up_inzia2
		ld	a, 0Bh
		call	up_prna
		jr	c, up_inzia2
		pop	de
		ld	a, h
		pop	hl
		jr	up_inzia1
up_inzia2:	pop	de
		pop	hl
		ret

;------------------------------------------------------------------------------
; 14 INZIF, Eingabe 1 Byte mit Aufforderungstext
;------------------------------------------------------------------------------

up_inzif:	call	loc_0_CAA9
up_inzif1:	push	hl
		ld	h, a
		call	up_inzia1
		jr	c, up_inzif3
		jr	z, up_inzif3
		ld	a, b
		or	a
		jr	z, up_inzif2
		ld	a, 0Bh
		call	up_prna
		jr	c, up_inzif3
		ld	a, h
		pop	hl
		jr	up_inzif1
up_inzif2:	dec	a
up_inzif3:	pop	hl
		ret

;------------------------------------------------------------------------------
; 17 INPDA, Eingabe 1 Byte mit Aufforderungstext und Anzeige des vorgegebenen Wertes
;------------------------------------------------------------------------------

up_inpda:	call	loc_0_CAA9
up_inpda1:	push	hl
		ld	h, a
		push	de
		call	up_prnst1
		jr	c, up_inpda3
		ld	d, ' '
		ld	e, '['
		call	up_prnde
		jr	c, up_inpda3
		ld	a, c
		call	up_prnby
		jr	c, up_inpda3
		ld	d, ']'
		ld	e, ':'
		call	up_prnde
		jr	c, up_inpda3
		call	up_inby
		jr	c, up_inpda3
		dec	a
		jr	z, up_inpda3
		dec	a
		jr	nz, up_inpda2
		ld	a, 0Bh
		call	up_prna
		jr	c, up_inpda3
		pop	de
		ld	a, h
		pop	hl
		jr	up_inpda1
up_inpda2:	ld	c, e
up_inpda3:	pop	de
		pop	hl
		ret

;------------------------------------------------------------------------------
; 18 STENT, Tastatureingabe STOP, ENTER auswerten
;------------------------------------------------------------------------------

up_stent:	push	de
		ld	de, aFortsetzenEnte ; "\r\nFortsetzen: ENTER  /  Abbruch: STOP "
		ld	a, (sys_bank)
		call	up_prcst1
up_stent1:	pop	de
		ret	c			; bei Fehler
up_stent2:	call	up_consi
		cp	0Dh
		jr	z, up_stent3
		sub	3
		jr	nz, up_stent2
up_stent3:	or	a
		push	af
		ld	a, 0Dh
		call	up_prnda
		jr	c, up_stent1
		ld	a, 0Ah
		call	up_prnda
		jr	c, up_stent1
		pop	af
		ret

aFortsetzenEnte:db 0Dh
		db 0Ah
		db "Fortsetzen: ENTER  /  Abbruch: STOP "
		db 0

;------------------------------------------------------------------------------
; 13 PAUSE, Tastatureingabe PAUSE, CONT, STOP auswerten
;------------------------------------------------------------------------------

up_pause:	call	up_stcon
		ret	c			; bei Fehler
		or	a
		jr	z, up_pause3
		cp	3			; <STOP>
		jr	z, up_pause2
		cp	0Dh			; <ENTER>
		jr	z, up_pause2
		cp	1Eh			; <CONT>
		jr	z, up_pause2
		cp	13h			; <PAUSE>
		jr	nz, up_pause3
up_pause1:	call	up_stcon
		ret	c			; bei Fehler
		cp	3			; <STOP>
		jr	z, up_pause2
		cp	1Eh			; <CONT>
		jr	nz, up_pause1
up_pause2:	call	up_consi
		ret	c			; bei Fehler
up_pause3:	cp	3
		scf
		ccf
		ret

;------------------------------------------------------------------------------
; 2B HEXDU, Umwandlung Zeichenkette (z.B.'F123H') in HEX-Zahl in DE
;------------------------------------------------------------------------------

up_hexdu:	push	bc
		push	hl
		ld	hl, 0
		ld	a, (de)
up_hexdu1:	call	up_ashex
		jr	c, up_hexdu2
		and	0Fh
		ld	c, a
		ld	b, 0
		ld	a, 3
		add	hl, hl
		jr	c, up_hexdu3
		add	hl, hl
		jr	c, up_hexdu3
		add	hl, hl
		jr	c, up_hexdu3
		add	hl, hl
		jr	c, up_hexdu3
		add	hl, bc
		jr	c, up_hexdu3
		inc	de
		ld	a, (de)
		cp	' '
		jr	z, up_hexdu3
		cp	'H'
		jr	z, up_hexdu3
		cp	'h'
		jr	z, up_hexdu3
		jr	up_hexdu1
up_hexdu2:	ld	a, 2
up_hexdu3:	ex	de, hl
		pop	hl
		pop	bc
		ret

;------------------------------------------------------------------------------
; 20 ASHEX, '0' ... 'F' in 30...3F umwandeln
;------------------------------------------------------------------------------

up_ashex:	cp	30h
		ret	c			; bei Fehler
		cp	3Ah
		ccf
		ret	nc
		and	0DFh
		sub	7
		cp	3Ah
		ret	c			; bei Fehler
		cp	40h
		ccf
		ret

;------------------------------------------------------------------------------
; 2C DEZDU, Umwandlung Zeichenkette (z.B.'0123') in Dezimalzahl in DE
;------------------------------------------------------------------------------

up_dezdu:	push	bc
		push	hl
		ld	hl, 0
		ld	a, (de)
up_dezdu1:	cp	30h
		jr	c, up_dezdu3
		cp	3Ah
		ccf
		jr	c, up_dezdu3
		and	0Fh
		ld	c, a
		ld	b, 0
		ld	a, 3
		add	hl, hl
		jr	c, up_dezdu4
		push	de
		ld	e, l
		ld	d, h
		add	hl, hl
		jr	c, up_dezdu2
		add	hl, hl
		jr	c, up_dezdu2
		add	hl, de
up_dezdu2:	pop	de
		jr	c, up_dezdu4
		add	hl, bc
		jr	c, up_dezdu4
		inc	de
		ld	a, (de)
		cp	20h
		jr	z, up_dezdu4
		jr	up_dezdu1
up_dezdu3:	ld	a, 2
up_dezdu4:	ex	de, hl
		pop	hl
		pop	bc
		ret

;------------------------------------------------------------------------------
; 21 NUMP , Byte aus A in 2 ASCII-Zeichen in DE umwandeln
;------------------------------------------------------------------------------

up_nump:	push	af
		rlca
		rlca
		rlca
		rlca
		call	up_nump1
		ld	d, e
		pop	af
up_nump1:	and	0Fh
		add	a, 30h
		cp	3Ah
		jr	c, up_nump2
		add	a, 7
up_nump2:	ld	e, a
		ret

;------------------------------------------------------------------------------
; 23 DADBC, BCD-Addition 8 Tetraden DEHL:=DEHL+BC
;------------------------------------------------------------------------------

up_dadbc:	ld	a, l
		add	a, c
		daa
		ld	l, a
		
		ld	a, h
		adc	a, b
		daa
		ld	h, a
		
		ld	a, e
		adc	a, 0
		daa
		ld	e, a
		
		ld	a, d
		adc	a, 0
		daa
		ld	d, a
		
		ret	nc
		ld	a, 3
		scf
		ret

;------------------------------------------------------------------------------
; 05 PCRLF, Ausgabe Zeilenschaltung (0DH, 0AH)
;------------------------------------------------------------------------------

up_prcrlf:	push	de
		ld	de, 0D0Ah		; CR-LF-Ascii-Codes
		call	up_prnde
		pop	de
		ret

;------------------------------------------------------------------------------
; 04 PRNDE, Ausgabe von 2 Zeichen. aus D und E
;------------------------------------------------------------------------------

up_prnde:	ld	a, d
		call	up_prna
		ret	c			; bei Fehler
		ld	a, e
		jr	up_prna

;------------------------------------------------------------------------------
; 01 PRNZ , Ausgabe Register A als ASCII-Zeichen zum Bildschirm (00-1F als '.')
;------------------------------------------------------------------------------

up_prnz:	cp	' '
		jr	nc, up_prna
		ld	a, '.'
		jr	up_prna

;------------------------------------------------------------------------------
; 02 PRNSP, Ausgabe ein Leerzeichen
;------------------------------------------------------------------------------

up_prnsp:	ld	a, ' '

;------------------------------------------------------------------------------
; 00 PRNA , Ausgabe Register A zum Bildschirm
;------------------------------------------------------------------------------

up_prna:	push	bc
		ld	c, a
		call	up_conso
		pop	bc
		ret

;------------------------------------------------------------------------------
; Ausgabe von A	direkt auf Bildschirm
;------------------------------------------------------------------------------

up_prnda:	push	bc
		ld	c, a
		call	up_cono
		pop	bc
		ret

;------------------------------------------------------------------------------
; 07 PRNAD, Ausgabe Register HL hexadezimal (4 Zeichen)
;------------------------------------------------------------------------------

up_prnad:	ld	a, h
		call	up_prnby
		ret	c			; bei Fehler
		ld	a, l

;------------------------------------------------------------------------------
; 06 PRNBY, Ausgabe Register A hexadezimal (2 Zeichen)
;------------------------------------------------------------------------------

up_prnby:	push	de
		call	up_nump
		call	up_prnde
		pop	de
		ret

;------------------------------------------------------------------------------
; 0D PRDEZ, Ausgabe Register HL Dezimal (5 Zeichen)
;------------------------------------------------------------------------------

up_prdez:	push	bc
		push	de
		push	hl
		ld	c, 0
		ld	de, 10000
		call	up_prdez1
		ld	de, 1000
		call	nc, up_prdez1
		ld	de, 100
		call	nc, up_prdez1
		ld	de, 10
		call	nc, up_prdez1
		inc	c
		ld	de, 1
		call	nc, up_prdez1
		pop	hl
		pop	de
		pop	bc
		ret

up_prdez1:	ld	b, 0FFh
		or	a
up_prdez2:	inc	b
		sbc	hl, de
		jr	nc, up_prdez2
		add	hl, de
		ld	a, c
		or	a
		ld	a, b
		jr	nz, up_prdez3
		or	a
		jr	z, up_prnsp
up_prdez3:	inc	c
		add	a, 30h
		jr	up_prna

;------------------------------------------------------------------------------
; 0B DISPO, Anzeige eines Speicherbereiches hexadezimal und ASCII von (HL) bis (DE)
;------------------------------------------------------------------------------

up_dispo:	call	loc_0_CAA9
		push	bc
		ld	c, a
		call	up_prcrlf
		call	nc, up_dispo1
		pop	bc
		ret

up_dispo1:	call	up_prnad
		call	nc, up_prnsp
		ret	c			; bei Fehler
		push	hl
		ld	b, 8
up_dispo2:	ld	a, c
		call	up_r1
		inc	hl
		call	up_prnby
		call	nc, up_prnsp
		jr	c, up_dispo3
		djnz	up_dispo2
		call	up_prnsp
up_dispo3:	pop	hl
		ret	c			; bei Fehler
		ld	b, 8
up_dispo4:	ld	a, c
		call	up_r1
		inc	hl
		call	up_prnz
		ret	c			; bei Fehler
		djnz	up_dispo4
		call	up_prcrlf
		ret	c			; bei Fehler
		push	hl
		dec	hl
		sbc	hl, de
		pop	hl
		ret	nc
		call	up_pause
		ret	c			; bei Fehler
		ret	z
		jr	up_dispo1

;------------------------------------------------------------------------------
; 0C PRNER, Systemfehleranzeige, A=Fehlercode, B=Zusatzinformation
;------------------------------------------------------------------------------

up_prner:	push	bc
		push	de
		ld	c, a
		ld	de, aError		; "\r\nError "
		ld	a, (sys_bank)
		call	up_prnst1		; Anzeige "Error"
		jr	c, up_prner1
		ld	a, c
		call	up_prnby		; Anzeige Fehlercode 
		call	nc, up_prnsp
		jr	c, up_prner1
		ld	a, b
		call	up_prnby		; Anzeige Zusatzinfo
		jr	c, up_prner1
		call	up_prcrlf
up_prner1:	pop	de
		pop	bc
		ret
;
aError:		db 0Dh
		db 0Ah
		db "Error "
		db 0

